//
//  HiveSDKPostBox.h
//  HiveSDKPostBox
//
//  Created by BK on 2021/08/09.
//

#import <Foundation/Foundation.h>

#ifndef __HIVESDKPOSTBOX_H__
#define __HIVESDKPOSTBOX_H__

#ifdef __cplusplus
extern "C" {
#endif

    typedef enum _PBServerState {
        Server_None = -1,
        Server_LiveServer = 0,
        Server_StagingServer,
        Server_SandboxServer
    }PBServerState;
    
    /****
     * 콜백
     ****/

    /**
     * @brief 영수증 검증 완료 콜백
     */
    typedef void (*PBVerifyFinish)(const char* pid);
    

    /****
     * API
     ****/

    /**
     * HIVE 프로모션 초기화.
     */
    void PB_StartPostBox(PBServerState serverState, const char* appId, const char* did, const char* uid, const char* vid, const char* sessionToken, bool isShow);
    
    /**
     * HIVE 프로모션 초기화.
     */
    void PB_VerifyIap(const char* bypassInfo, bool isSub, PBVerifyFinish handler);
    
    
#ifdef __cplusplus
};
#endif


#endif

