//
//  AnalyticesViewController.swift
//  HIVE_SDK_Sample
//
//  Created by daunjoung on 2021/05/13.
//  Copyright © 2021 gcp. All rights reserved.
//

import UIKit
import HIVEService
enum AnalyticesApi: String, CaseIterable {
    case sendAnlayticesLog = "sendAnlayticesLog(120/second)"
}

class AnalyticesViewController: BaseViewController {
    let apis: [AnalyticesApi] = AnalyticesApi.allCases
    var timer = Timer()
    
    let LOG_AMOUNT = 10
    let LOG_CYCLE = 1
    let LOG_SEND_LIMIT = 100
    let LOG_QUEUE_LIMIT = 100
    
    @IBOutlet weak var tableView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        self.tableView.contentInset = UIEdgeInsets.init(top: 44, left: 0, bottom: 0, right: 0)
    }
    

    func callAPI(api: AnalyticesApi) {
        switch api {
        case .sendAnlayticesLog:            
            ConfigurationInterface.setAnalyticsSendCycleSeconds(LOG_CYCLE)
            ConfigurationInterface.setAnalyticsSendLimit(LOG_SEND_LIMIT)
            ConfigurationInterface.setAnalyticsQueueLimit(LOG_QUEUE_LIMIT)
            
            scheduledTimerWithTimeInterval()
        }
    }
        
        

        func scheduledTimerWithTimeInterval() {
            // Scheduling timer to Call the function "updateCounting" with the interval of 1 seconds    // Scheduling timer to Call the function "updateCounting" with the interval of 1 seconds
            timer = Timer.scheduledTimer(
                timeInterval: TimeInterval(LOG_CYCLE/12),
                target: self,
                selector: #selector(self.sendLog),
                userInfo: nil,
                repeats: true
            )

        }

        @objc func sendLog() {
            for i in 0..<LOG_AMOUNT {
                print("Send Log -- \(i)!!!!!")
                let logData: [String: Any] = [
                    "category": "hivesdk_asset_var_log",
                    "amountCurr": 7,
                    "characterTypeId": 0,
                    "characterId": 0,
                    "accountLevel": 80,
                    "assetId": 105,
                    "itemName": "",
                    "amountVar": -1,
                    "amountPrev": 8,
                    "actionId": 7,
                    "accountId": 163865,
                    "actionName": "명예의전장",
                    "assetName": "전투력",
                    "itemId": 0,
                    "channelUid": "",
                    "characterLevel": 0,
                    "extraLogBoby": 0,
                    "amount_free_prev": 0,
                    "amount_free_var": 0,
                    "amount_free_curr": 0,
                    "amount_paid_prev": 0,
                    "amount_paid_var": 0,
                    "amount_paid_curr": 0,
                    "account_id": 0,
                    "deviceid": 0,
                    "isEmulator": 0
                ]

                _ = AnalyticsInterface.sendAnalyticsLog(logData)
            }
        }
    
    

}

extension AnalyticesViewController: UITableViewDelegate, UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        self.apis.count
    }

    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        guard let cell = tableView.dequeueReusableCell(withIdentifier: "ApiCell") as? AnalyticesTableViewCell
        else {
            preconditionFailure("Not supported cell type")
        }

        cell.configureCell(api: self.apis[indexPath.row])

        return cell
    }

    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        self.callAPI(api: apis[indexPath.row])
        tableView.deselectRow(at: indexPath, animated: true)
    }
}
