//
//  BaseViewController.swift
//  HIVE_SDK_Sample
//
//  Created by jhjang on 05/12/2018.
//  Copyright © 2018 gcp. All rights reserved.
//

import UIKit

class BaseViewController: UIViewController {
	
	weak var logDelegate: LogProtocol?
	
    override func viewDidLoad() {
        super.viewDidLoad()
    }

    override func present(_ viewController: UIViewController, animated: Bool, completion: (() -> Void)?) {
        // Pad는 Phone과 달리 화면 크기가 크기 떄문에, UIAlertController의 actionSheet 스타일을 노출시킬 때 노출될 위치를 지정해줘야 한다. 그렇지 않으면 크래시 발생.
        if
            let alert = viewController as? UIAlertController, alert.preferredStyle == .actionSheet, UIDevice.current.userInterfaceIdiom == .pad,
            let popoverController = viewController.popoverPresentationController {
                popoverController.sourceView = self.view
                popoverController.sourceRect = CGRect(x: self.view.bounds.midX, y: self.view.bounds.midY, width: 0, height: 0)
                popoverController.permittedArrowDirections = []
                super.present(viewController, animated: animated, completion: completion)
        } else {
            super.present(viewController, animated: animated, completion: completion)
        }
    }
}

