//
//  ConfigurationEditViewController.swift
//  HIVE_SDK_Sample
//
//  Created by jhjang on 14/05/2019.
//  Copyright © 2019 gcp. All rights reserved.
//

import UIKit

protocol ConfigurationEditDelegate: AnyObject {
    func didTextFieldChanged(value: String)
}

class ConfigurationEditViewController: UIViewController {

    @IBOutlet weak var textField: UITextField!
    @IBOutlet weak var label: UILabel!
    @IBOutlet weak var confirmButton: UIBarButtonItem!
    
    var labelTitle: String = ""
    var content: String = ""
    weak var delegate: ConfigurationEditDelegate?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.textField.text = content
        self.label.text = self.label.text?.replacingOccurrences(of: "$0", with: labelTitle)
    }
    
    @IBAction func didConfirmButtonTouched(_ sender: Any) {
        self.delegate?.didTextFieldChanged(value: textField.text ?? "")
        self.navigationController?.popViewController(animated: true)
    }
}
