//
//  SwitchTableViewCell.swift
//  HIVE_SDK_Sample
//
//  Created by jhjang on 10/05/2019.
//  Copyright © 2019 gcp. All rights reserved.
//

import HIVEService

import UIKit

class SwitchTableViewCell: TitleLabelTableViewCell {
    
    @IBOutlet weak var onOffSwitch: UISwitch!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
    }

    @IBAction func didSwitchValueChanged(_ sender: UISwitch) {
        Logger.d("sender - \(sender.isOn)")
        if sender.tag == 1 {
            ConfigurationInterface.setAgeGateU13(sender.isOn)
        }
        if sender.tag == 2 {
            ConfigurationInterface.setHivePermissionViewOn(sender.isOn)
        } else if sender.tag == 3 {
            if sender.isOn {
            ConfigurationInterface.setHiveTheme(.hiveDark)
            } else {
                ConfigurationInterface.setHiveTheme(.hiveLight)
            }
        } else if sender.tag == 4 {
            ConfigurationInterface.setUseHercules(sender.isOn)
        }
    }
    
    func setupCell(title: String, isOn: Bool) {
        self.setupCell(title: title)
        onOffSwitch.isOn = isOn
    }

    func setupCell(title: String, isOn: Bool, tag: Int) {
        self.setupCell(title: title)
        onOffSwitch.isOn = isOn
        onOffSwitch.tag = tag
    }
}
