//
//  ActiveUserViewController.m
//  HIVE_SDK_Sample
//
//  Created by daunjoung on 2021/06/01.
//  Copyright © 2021 gcp. All rights reserved.
//

#import "ActiveUserViewController.h"
#import "C2SActiveUser.h"

@interface ActiveUserViewController ()
@property (weak, nonatomic) IBOutlet UISegmentedControl *serverSelectSegment;

@end

@implementation ActiveUserViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    
    CS_ActiveUserSetCallback(AUTest_ActiveUserCallBack);
    CS_UserAgreeSetCallback(AUTest_UserAgreeCallBack);
    
    
}



// MARK: -- Actions
- (IBAction)onClickStartEx:(id)sender {
    SERVER_STATE state = LIVE_SERVER;
    
    if(_serverSelectSegment.selectedSegmentIndex == 0 ) {
        state = LIVE_SERVER;
    } else if(_serverSelectSegment.selectedSegmentIndex == 1) {
        state = STAGING_SERVER;
    } else {
        state = SANDBOX_SERVER;
    }
    
    [_serverSelectSegment setEnabled:FALSE];
    
    CS_ActiveUserStartEx(state);
}

- (IBAction)onClickSetServerId:(id)sender {
    UIAlertController * alert = [UIAlertController alertControllerWithTitle: @"ServerID"
                                                                                     message: @"서버 ID 입력해주세요"
                                                                                 preferredStyle:UIAlertControllerStyleAlert];
       [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
           textField.placeholder = @"ex) server_001";
           textField.text = @"server_001";
       }];
    
       [alert addAction:[UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
           NSArray * textfields = alert.textFields;
           UITextField * serverId = textfields[0];
           NSLog(@"%@",serverId.text);
           
           CS_ActiveUserSetServerId(serverId.text.UTF8String);
       }]];
       [self presentViewController:alert animated:YES completion:nil];
}

- (IBAction)onClickSetChannel:(id)sender {
    UIAlertController * alert = [UIAlertController alertControllerWithTitle: @"HiveChannel"
                                                                    message: @"Channel을 설정 해 주세요."
                                                             preferredStyle: UIAlertControllerStyleAlert];
    
    [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
        textField.placeholder = @"C2S";
        textField.text = [NSString stringWithUTF8String:CS_GetChannel()];
    }];
    
    [alert addAction:[UIAlertAction actionWithTitle:@"OK"
                                              style:UIAlertActionStyleDefault
                                            handler:^(UIAlertAction * action) {
        NSArray * textFields = alert.textFields;
        UITextField * hiveCountry = textFields[0];
        NSLog(@"%@", hiveCountry.text);
        
        CS_SetChannel(hiveCountry.text.UTF8String);
    }]];
    [self presentViewController:alert animated:YES completion:nil];
}


- (IBAction)onClickSetGameLanguage:(id)sender {
    UIAlertController * alert = [UIAlertController alertControllerWithTitle: @"GameLanguage"
                                                                                     message: @"게임 언어 코드를 입력해주세요"
                                                                                 preferredStyle:UIAlertControllerStyleAlert];
       [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
           textField.placeholder = @"ex) ko, en, ja, zh-hans, zh-hant, de, ru, vi, es, it, id, th, tr, pt, fr...";
           textField.text = @"ko";
       }];
    
       [alert addAction:[UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
           NSArray * textfields = alert.textFields;
           UITextField * lang = textfields[0];
           NSLog(@"%@",lang.text);
           
           CS_ActiveUserSetGameLanguage(lang.text.UTF8String);
       }]];
       [self presentViewController:alert animated:YES completion:nil];
}

- (IBAction)onClickUpdateNoticeShowPopup:(id)sender {
    CS_UpdateNoticeShowPopup(AUTest_UpdateNoticePopupCallBack);
}

- (IBAction)onClickUserAgreeShowTermEx:(id)sender {
    CS_UserAgreeShowTermsUI(nil);
}

- (IBAction)onClickNoticeGetPopupInfo:(id)sender {
    CS_UpdateNoticeGetPopupInfo(AUTest_UpdateNoticeInfoCallBack);
}

- (IBAction)onClickSetUseHercules:(id)sender {
    UIAlertController* alert = [UIAlertController alertControllerWithTitle: @"enable?"
                                                                                     message: @"Hercules 사용 여부"
                                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    [alert addAction:[UIAlertAction actionWithTitle:@"true" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        CS_SetUseHercules(true);
    }]];
    
    [alert addAction:[UIAlertAction actionWithTitle:@"false" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        CS_SetUseHercules(false);
    }]];
    
    [self presentViewController:alert animated:YES completion:nil];
}


// MARK: -- CallBack

void AUTest_UserAgreeCallBack(USER_AGREE_RESULT type)
{
    switch (type) {
        case USER_AGREE_SUCCESS:
            NSLog(@"USER_AGREE_SUCCESS");
            break;
        case USER_AGREE_TERMS_CLOSE:
            NSLog(@"USER_AGREE_TERMS_CONFIRM");
            break;
        default:
            break;
    }
}

void AUTest_ActiveUserCallBack(ACTIVE_USER_RESULT type)
{
    switch (type) {
        case ACTIVE_USER_GETDID_SUCCESS:
            NSLog(@"ACTIVE_USER_GETDID_SUCCESS");
            NSLog(@"%s", CS_ActiveUserGetDID());
            break;
        case ACTIVE_USER_GETDID_FAIL:
            NSLog(@"ACTIVE_USER_GETDID_FAIL");
            break;
        default:
            break;
    }
}

void AUTest_UpdateNoticePopupCallBack(POPUP_STATE state)
{
        UIAlertView *alert = NULL;
    switch (state) {
        case CLOSE:
            alert = [[UIAlertView alloc]initWithTitle:@"Result - CLOSE"
                                              message:@"UpdateNoticePopup was called with close state"
                                             delegate:nil
                                    cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                    otherButtonTitles:@"YES", nil];
            break;
        case UNSHOWN:
            alert = [[UIAlertView alloc]initWithTitle:@"Result - UNSHOWN"
                                              message:@"UpdateNoticePopup was called with unShown state"
                                             delegate:nil
                                    cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                    otherButtonTitles:@"YES", nil];
            break;
        case POPUP_STATE_ERROR:
            alert = [[UIAlertView alloc]initWithTitle:@"Result - ERROR"
                                              message:@"UpdateNoticePopup was called with ERROR state"
                                             delegate:nil
                                    cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                    otherButtonTitles:@"YES", nil];
            
            break;
        default:
            break;
    }
    if(alert != NULL){
        [alert show];
    }
}
void AUTest_UpdateNoticeInfoCallBack(SHOW_POPUP show, const char* jsonData){
    
    UIAlertView *alert = NULL;
    switch (show) {
        case SHOW:
             alert = [[UIAlertView alloc]initWithTitle:@"Result - SHOW"
                                                           message:[NSString stringWithUTF8String:jsonData]
                                                          delegate:nil
                                                 cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                                 otherButtonTitles:@"YES", nil];
        
            break;
        case NOTSHOW:
            alert = [[UIAlertView alloc]initWithTitle:@"Result - NOTSHOW"
                                                           message:[NSString stringWithUTF8String:jsonData]
                                                          delegate:nil
                                                 cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                                 otherButtonTitles:@"YES", nil];


            break;
        case SHOW_POPUP_ERROR:
            alert = [[UIAlertView alloc]initWithTitle:@"Result - ERROR"
                                              message:@"Result - ERROR"
                                             delegate:nil
                                    cancelButtonTitle:@"NO"    /* nil 로 지정할 경우 cancel button 없음 */
                                    otherButtonTitles:@"YES", nil];
            
            
            break;
            
            
        default:
            break;
    }
    if(alert != NULL){
        
        // alert창을 띄우는 method는 show이다.
        [alert show];
    }
}

@end
