//
//  PushViewController.m
//  HIVE_SDK_Sample
//
//  Created by daunjoung on 2021/06/01.
//  Copyright © 2021 gcp. All rights reserved.
//

#import "C2SPushViewController.h"
#import "C2SPush.h"

@interface C2SPushViewController ()
@property (weak, nonatomic) IBOutlet UILabel *pushStateLabel;

@end

@implementation C2SPushViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];

    [self updatePushState];
}


- (void)updatePushState {
    Push_BoolType noticeState = CS_pushGetAgreeNotice();
    Push_BoolType nightState = CS_pushGetAgreeNight();
    
    NSString *notice = noticeState == Push_TRUE ? @"ON" : @"OFF";
    NSString *night = nightState == Push_TRUE ? @"ON" : @"OFF";
    
    [self.pushStateLabel setText:[NSString stringWithFormat:@"Push State\nNotice : %@ \t\tNight : %@", notice, night]];
}





// MARK: -- Actions
- (IBAction)onClickStartEx:(id)sender {
}

- (IBAction)onClickSetAgreeONON:(id)sender {
    CS_pushSetAgree(Push_TRUE, Push_TRUE);
    [self updatePushState];
}

- (IBAction)onClickSetAgreeONOFF:(id)sender {
    CS_pushSetAgree(Push_TRUE, Push_FALSE);
    [self updatePushState];
}

- (IBAction)onClickSetAgreeOFFON:(id)sender {
    CS_pushSetAgree(Push_FALSE, Push_TRUE);
    [self updatePushState];
}

- (IBAction)onClickSetAgreeOFFOFF:(id)sender {
    CS_pushSetAgree(Push_FALSE, Push_FALSE);
    [self updatePushState];
}

- (IBAction)onClickUpdateState:(id)sender {
    [self updatePushState];
}

@end
