//
//  HiveSocialManager.h
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString * const SPHiveSocialDidInitializeNotification;
extern NSString * const SPHiveSocialDidUnInitializeNotification;

@class HiveSocialLogData;

typedef void (^HiveSocialCompletion) (id result, NSError* error);

@interface HiveSocialManager : NSObject

@property (nonatomic, strong) NSString* guestUid;

@property (nonatomic, strong) NSString* uid;

@property (nonatomic, strong) NSString* did;

@property (nonatomic, strong) NSString* sessionKey;

@property (nonatomic, strong) NSString* username;

@property (nonatomic, strong) NSString* userId;

@property (nonatomic, strong) NSString* picture;

@property (nonatomic, strong) NSString* fbid;

@property (nonatomic, strong) NSString* googleplusId;

@property (nonatomic) BOOL isInitialized;

+ (instancetype)sharedInstance;

+ (void)hiveInitializeEx:(HiveSocialCompletion)completion;

+ (void)hiveAuth:(HiveSocialCompletion)completion;

+ (void)hiveLogout:(HiveSocialCompletion)completion;

+ (void)hiveUserDelete:(HiveSocialCompletion)completion;

+ (void)hiveShowDialog:(NSString *)path completion:(HiveSocialCompletion)completion;

+ (void)hiveAsyncRequest:(NSString *)requestName params:(NSDictionary *)params completion:(HiveSocialCompletion)completion;

+ (void)hiveSocialRequest:(NSString *)serviceName actionName:(NSString *)actionName params:(NSDictionary *)params completion:(HiveSocialCompletion)completion;

+ (void)hiveGuestAcquireUid:(HiveSocialCompletion)completion;

+ (void)hiveGuestBind:(NSString *)guestUid userId:(NSString *)userId completion:(HiveSocialCompletion)completion;

+ (void)hiveCSBotRequestWithCompletion:(HiveSocialCompletion)completion;

+ (void)hiveApplicationDidBecomeActive;

+ (BOOL)hiveApplicationOpenURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;

- (void)reset;

+ (NSString *)getHiveSocialVersion;

+ (NSString *)getAUVersion;
@end
