//
//  LoginViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "LoginViewController.h"
#import "MainUserViewController.h"
#import "MainGuestUserViewController.h"
#import "HiveSocialManager.h"

@interface LoginViewController ()
{
	NSMutableArray* _allConstraints;
	
	BOOL _isRegistered;
}
@end

@implementation LoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
	
	self.title	= TITLE_LOGIN;
	
	_loginButton	= [SPButton buttonWithTitle:TITLE_HIVE_SOCIAL_LOGIN handler:^(SPButton *button) {
		[self _onMemberLogin];
	}];
	_loginButton.translatesAutoresizingMaskIntoConstraints	= NO;
	[self.contentView addSubview:_loginButton];
	
	_guestButton	= [SPButton buttonWithTitle:TITLE_HIVE_SOCIAL_GUEST_LOGIN handler:^(SPButton *button) {
		[self _onGuestLogin];
	}];
	_guestButton.translatesAutoresizingMaskIntoConstraints	= NO;
	[self.contentView addSubview:_guestButton];
	
	_deregisterDeviceButton	= [SPButton buttonWithTitle:TITLE_HIVE_SOCIAL_REMOVE_LOGIN_INFO handler:^(SPButton *button) {
		[self _onDeregisterDeviceButton];
	}];
	_deregisterDeviceButton.translatesAutoresizingMaskIntoConstraints	= NO;
	[self.contentView addSubview:_deregisterDeviceButton];
	
	[self orientationChanged];
	
	[self showMenu];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated
{
	[super viewDidAppear:animated];
	
	[HiveSocialManager hiveAsyncRequest:@"device/registered" params:nil completion:^(id result, NSError *error) {
		if (error)
			return;
		
        self->_isRegistered	= [result[@"is_registered"] boolValue];
		
		[self.view setNeedsUpdateConstraints];
	}];
}

//- (void)viewDidLayoutSubviews
//{
//	[super viewDidLayoutSubviews];
//	
//	if (_allConstraints && [_allConstraints count] > 0) {
//		[self.view removeConstraints:_allConstraints];
//		[_allConstraints removeAllObjects];
//	}
//	
//	_allConstraints		= [@[] mutableCopy];
//	
//	id topLayoutGuide	= self.serverPathLabel;
//	
//	NSDictionary* views	= NSDictionaryOfVariableBindings(topLayoutGuide, _loginButton, _guestButton);
//	NSDictionary* metrics;
//	NSArray* constraints;
//	
//	if (UIInterfaceOrientationIsPortrait([UIApplication sharedApplication].statusBarOrientation)) {
//		metrics = @{@"buttonH" : @(32)};
//		constraints	= @[@"H:|-[_loginButton]-|", @"H:|-[_guestButton]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]-[_guestButton(==buttonH)]"
//						];
//	}
//	else {
//		metrics = @{@"buttonH" : @(28)};
//		constraints	= @[@"H:|-[_loginButton]-[_guestButton(==_loginButton)]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]",
//						@"V:[topLayoutGuide]-[_guestButton(==buttonH)]"
//						];
//	}
//	
//	for (NSString* str in constraints) {
//		[_allConstraints addObjectsFromArray:[NSLayoutConstraint constraintsWithVisualFormat:str options:0 metrics:metrics views:views]];
//	}
//	
//	[self.view addConstraints:_allConstraints];
//	
//	if (SYSTEM_VERSION_LESS_THAN(@"8.0")) {
//		[self.view layoutIfNeeded];
//	}
//}

//- (void)orientationChanged
//{
//	[super orientationChanged];
//	
//	if (_allConstraints && [_allConstraints count] > 0) {
//		[self.view removeConstraints:_allConstraints];
//		[_allConstraints removeAllObjects];
//	}
//	
//	_allConstraints		= [@[] mutableCopy];
//	
//	id topLayoutGuide	= self.serverPathLabel;
//	
//	NSDictionary* views	= NSDictionaryOfVariableBindings(topLayoutGuide, _loginButton, _guestButton);
//	NSDictionary* metrics;
//	NSArray* constraints;
//	
//	if (UIInterfaceOrientationIsPortrait([UIApplication sharedApplication].statusBarOrientation)) {
//		metrics = @{@"buttonH" : @(32)};
//		constraints	= @[@"H:|-[_loginButton]-|", @"H:|-[_guestButton]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]-[_guestButton(==buttonH)]"
//						];
//	}
//	else {
//		metrics = @{@"buttonH" : @(28)};
//		constraints	= @[@"H:|-[_loginButton]-[_guestButton(==_loginButton)]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]",
//						@"V:[topLayoutGuide]-[_guestButton(==buttonH)]"
//						];
//	}
//	
//	for (NSString* str in constraints) {
//		[_allConstraints addObjectsFromArray:[NSLayoutConstraint constraintsWithVisualFormat:str options:0 metrics:metrics views:views]];
//	}
//	
//	[self.view addConstraints:_allConstraints];
//	
//	if (SYSTEM_VERSION_LESS_THAN(@"8.0")) {
//		[self.view layoutIfNeeded];
//	}
//}

//- (void)viewDidLayoutSubviews
//{
//	if (SYSTEM_VERSION_LESS_THAN(@"8.0")) {
//		[self.view layoutIfNeeded];
//		
//		[self updateViewConstraints];
//	}
//}

- (void)updateViewConstraints
{
	[super updateViewConstraints];

	if (_allConstraints && [_allConstraints count] > 0) {
		[self.contentView removeConstraints:_allConstraints];
		[_allConstraints removeAllObjects];
	}
	
	_allConstraints	= [@[] mutableCopy];
	
	id topLayoutGuide;
	topLayoutGuide	= self.serverPathLabel;
	
	NSDictionary* views;
	NSDictionary* metrics = @{@"buttonH" : @(32)};
	NSArray* constraints;
	
	_guestButton.hidden				= YES;
	_deregisterDeviceButton.hidden	= YES;
	if (_isRegistered) {
		_deregisterDeviceButton.hidden	= NO;
		views	= NSDictionaryOfVariableBindings(topLayoutGuide, _loginButton, _deregisterDeviceButton);
		constraints	= @[@"H:|-[_loginButton]-|", @"H:|-[_deregisterDeviceButton]-|",
						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]-[_deregisterDeviceButton(==buttonH)]"
						];
	}
	else {
		_guestButton.hidden	= NO;
		views	= NSDictionaryOfVariableBindings(topLayoutGuide, _loginButton, _guestButton);
		constraints	= @[@"H:|-[_loginButton]-|", @"H:|-[_guestButton]-|",
						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]-[_guestButton(==buttonH)]"
						];
	}
	
//	if (UIInterfaceOrientationIsPortrait([UIApplication sharedApplication].statusBarOrientation)) {
//		metrics = @{@"buttonH" : @(32)};
//		constraints	= @[@"H:|-[_loginButton]-|", @"H:|-[_guestButton]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]-[_guestButton(==buttonH)]"
//						];
//	}
//	else {
//		metrics = @{@"buttonH" : @(28)};
//		constraints	= @[@"H:|-[_loginButton]-[_guestButton(==_loginButton)]-|",
//						@"V:[topLayoutGuide]-[_loginButton(==buttonH)]",
//						@"V:[topLayoutGuide]-[_guestButton(==buttonH)]"
//						];
//	}
	
	for (NSString* str in constraints) {
		[_allConstraints addObjectsFromArray:[NSLayoutConstraint constraintsWithVisualFormat:str options:0 metrics:metrics views:views]];
	}
	
	[self.contentView addConstraints:_allConstraints];
}


- (void)_onMemberLogin
{
	[HiveSocialManager hiveAuth:^(id result, NSError *error) {
        if (error || result[@"needGuestLogin"])
			return;
		
		MainUserViewController* vc	= [[MainUserViewController alloc] initWithType:WithUserInfoViewTypeRegular];
		self.navigationController.viewControllers	= @[vc];
	}];
}

- (void)_onGuestLogin
{
	[HiveSocialManager hiveAsyncRequest:@"guest/create" params:nil completion:^(id result, NSError *error) {
		if (error)
			return;
		[HiveSocialManager hiveAsyncRequest:@"guest/auth" params:@{@"guest_uid" : [HiveSocialManager sharedInstance].guestUid} completion:^(id pResult, NSError *pError) {
			if (pError)
				return;
			MainGuestUserViewController* vc	= [[MainGuestUserViewController alloc] initWithType:WithUserInfoViewTypeGuest];
			self.navigationController.viewControllers	= @[vc];
		}];
	}];
}

- (void)_onDeregisterDeviceButton
{
	[HiveSocialManager hiveLogout:^(id result, NSError *error) {
		[HiveSocialManager hiveAsyncRequest:@"device/deregister" params:nil completion:^(id result, NSError *error) {
            self->_isRegistered	= NO;
			
			[self.view setNeedsUpdateConstraints];
		}];
	}];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
