//
//  MainGuestUserViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 16..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "MainGuestUserViewController.h"
#import "HiveSocialManager.h"
#import "MainUserViewController.h"
#import "LoginViewController.h"

@interface MainGuestUserViewController ()
<UserViewDelegate>

@end

@implementation MainGuestUserViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
	self.title	= @"Main(Guest)";
	
	[self showMenu];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated
{
	[super viewDidAppear:animated];

	self.userGuestActionView.delegate	= self;
	
	self.userInfoView.usernameLabel.text	= [NSString stringWithFormat:@"Guest UID : %@", [HiveSocialManager sharedInstance].guestUid];
	
	self.userInfoView.facebookButton.hidden		= YES;
	self.userInfoView.googleplusButton.hidden	= YES;
	
	if ([[HiveSocialManager sharedInstance].picture length] > 0) {
		[SPImageCache getImageData:[HiveSocialManager sharedInstance].picture completion:^(NSData *imageData) {
			if (imageData) {
				self.userInfoView.profileImageView.image	= [UIImage imageWithData:imageData];
			}
		}];
	}
}

#pragma mark - UserViewDelegate Methods
- (void)didSelectButton:(SPButton *)button atUserView:(UserView *)userView
{
	if (![userView isMemberOfClass:[UserGuestActionView class]])
		return;
	
	UserGuestActionView* userGuestActionView = (UserGuestActionView *)userView;

	if (userGuestActionView.convertAccountButton == button) {
		[SPAlertView showAlertView:@"Warning" message:DESC_HIVE_CONVERT_ACCOUNT buttons:@[@"예"] at:self completion:^(id alertView, NSInteger buttonIndex) {
			if (buttonIndex == 0) {
				[HiveSocialManager hiveGuestAcquireUid:^(id result, NSError *error) {
					if (error)
						return;
					
					[HiveSocialManager hiveGuestBind:[HiveSocialManager sharedInstance].guestUid userId:result[@"uid"] completion:^(id pResult, NSError *pError) {
						if (pError)
							return;
						
						MainUserViewController* vc	= [[MainUserViewController alloc] initWithType:WithUserInfoViewTypeRegular];
						self.navigationController.viewControllers	= @[vc];
					}];
				}];
			}
			else {
				// cancel
			}
		}];
	}
	else if (userGuestActionView.faqButton == button) {
		[HiveSocialManager hiveShowDialog:@"inquiry" completion:^(id result, NSError *error) {
			
		}];
	}
	else if (userGuestActionView.loginButton == button) {
		LoginViewController* vc	= [[LoginViewController alloc] init];
		self.navigationController.viewControllers	= @[vc];
	}
    else if (userGuestActionView.userDeleteButton == button) {
        [HiveSocialManager hiveUserDelete:^(id result, NSError *error) {
            LoginViewController* vc    = [[LoginViewController alloc] init];
            self.navigationController.viewControllers    = @[vc];
        }];
    }
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
