//
//  MainUserViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "MainUserViewController.h"
#import "HiveSocialManager.h"

@interface MainUserViewController ()

@end

@implementation MainUserViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
	self.title	= @"Main";
	
	[self showMenu];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated
{
	[super viewDidAppear:animated];
	
	[HiveSocialManager hiveAsyncRequest:@"user/me" params:nil completion:^(id result, NSError *error) {
		if (error)
			return;
		
		self.userInfoView.usernameLabel.text	= [NSString stringWithFormat:@"HiveSocial ID : %@(%@)", [HiveSocialManager sharedInstance].username, [HiveSocialManager sharedInstance].userId];
		
		self.userInfoView.facebookButton.enabled		= ([[HiveSocialManager sharedInstance].fbid length] > 0);
		self.userInfoView.googleplusButton.enabled		= ([[HiveSocialManager sharedInstance].googleplusId length] > 0);
		
		if ([[HiveSocialManager sharedInstance].picture isKindOfClass:[NSString class]] && ([[HiveSocialManager sharedInstance].picture length] > 0)) {
			[SPImageCache getImageData:[HiveSocialManager sharedInstance].picture completion:^(NSData *imageData) {
				if (imageData) {
					self.userInfoView.profileImageView.image	= [UIImage imageWithData:imageData];
				}
			}];
		}
	}];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
