//
//  MoreViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 11..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "MoreViewController.h"
//#import <FacebookSDK/FacebookSDK.h>
//#import <GooglePlus/GooglePlus.h>
//#import <GoogleOpenSource/GoogleOpenSource.h>
#import "HiveSocialManager.h"
#import <AdSupport/AdSupport.h>

typedef NS_ENUM(NSInteger, SectionType) {
	SectionTypeVERSIONS,
	SectionTypeDEVICE,
	SectionTypeACCOUNT,
	SectionTypeOTHERS,
	SectionTypeMAX
};

typedef NS_ENUM(NSInteger, VersionRowType) {
	VersionRowTypeSAMPLE_VERSION,
	VersionRowTypeHIVE,
	VersionRowTypeAU,
	VersionRowTypeFACEBOOK,
	VersionRowTypeGOOGLEPLUS,
	VersionRowTypeMIN_OS,
	VersionRowTypeMAX
};

typedef NS_ENUM(NSInteger, DeviceRowType) {
	DeviceRowTypeDID,
	DeviceRowTypeMODEL,
	DeviceRowTypeOS,
	DeviceRowTypeMCC,
	DeviceRowTypeMNC,
	DeviceRowTypeMAC_ADDRESS,
	DeviceRowTypeIDFA,
	DeviceRowTypeIDFV,
	DeviceRowTypeDEVICE_NAME,
	DeviceRowTypePLATFORM_NAME,
	DeviceRowTypeSYSTEM_LANGUAGE,
	DeviceRowTypeMAX
};

typedef NS_ENUM(NSInteger, AccountRowType) {
	AccountRowTypeUID,
	AccountRowTypeID,
	AccountRowTypeFACEBOOK_ID,
	AccountRowTypeGOOGLEPLUS_ID,
	AccountRowTypeMAX
};

@interface MoreViewController ()

@end

@implementation MoreViewController

- (void)viewDidLoad {
    [super viewDidLoad];
	
	self.title	= @"More";
	
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	
	self.navigationItem.rightBarButtonItem	= [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(_onClose)];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return SectionTypeMAX;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
	switch (section) {
		case SectionTypeVERSIONS:	return VersionRowTypeMAX;
		case SectionTypeDEVICE:		return DeviceRowTypeMAX;
		case SectionTypeACCOUNT:	return AccountRowTypeMAX;
		case SectionTypeOTHERS:		return 0;
		default:
			return 0;
	}
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	static NSString* CellIdentifier = @"Cell";
	UITableViewCell* cell;
	
	// Configure the cell...
	cell	= [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (!cell) {
		cell	= [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue2 reuseIdentifier:CellIdentifier];
	}
	
	cell.detailTextLabel.font			= [UIFont fontWithName:SP_DEFAULT_FONT_NAME size:12];
	cell.detailTextLabel.numberOfLines	= 0;
	cell.detailTextLabel.lineBreakMode = NSLineBreakByCharWrapping;
	
	NSString* title		= @"";
	NSString* detail	= @"";
	
	if (indexPath.section == SectionTypeVERSIONS) {
		
		NSString* facebookSDKVersion	= @"";
		NSString* googleplusSDKVersion	= @"";
		
#ifdef FB_IOS_SDK_VERSION_STRING
		facebookSDKVersion	= [NSString stringWithFormat:@"v%@", FB_IOS_SDK_VERSION_STRING];
#endif // FB_IOS_SDK_VERSION_STRING
		
		googleplusSDKVersion = @"v1.7.1(maybe...)";
		
		switch (indexPath.row) {
			case VersionRowTypeSAMPLE_VERSION:	title = @"Sample App";	detail = SP_APP_VERSION;	break;
			case VersionRowTypeHIVE:			title =	@"HIVE";		detail = [HiveSocialManager getHiveSocialVersion];	break;
			case VersionRowTypeAU:				title = @"AU";			detail = [HiveSocialManager getAUVersion];	break;
			case VersionRowTypeFACEBOOK:		title = @"Facebook";	detail = facebookSDKVersion;			break;
			case VersionRowTypeGOOGLEPLUS:		title = @"GooglePlus";	detail = googleplusSDKVersion;			break;
			case VersionRowTypeMIN_OS:			title = @"Min OS";		detail = @"6.0";						break;
			default:
				break;
		}
		
		cell.textLabel.text			= title;
		cell.detailTextLabel.text	= detail;
	}
	else if (indexPath.section == SectionTypeDEVICE) {
		switch (indexPath.row) {
			case DeviceRowTypeDID:			title = @"DID";			detail = [HiveSocialManager sharedInstance].did;	break;
			case DeviceRowTypeMODEL:		title = @"Model";		detail = [SPUtility platformName];			break;
			case DeviceRowTypeOS:			title = @"OS";			detail = [SPUtility osVersion];				break;
			case DeviceRowTypeMCC:			title = @"MCC";			detail = @"";								break;
			case DeviceRowTypeMNC:			title = @"MNC";			detail = @"";								break;
			case DeviceRowTypeMAC_ADDRESS:	title = @"MacAddress";	detail = [SPUtility macAddress];				break;
			case DeviceRowTypeIDFA:			title = @"IDFA";		detail = [[ASIdentifierManager sharedManager] advertisingIdentifier].UUIDString;	break;
			case DeviceRowTypeIDFV:			title = @"IDFV";		detail = [SPUtility vendorIdentifier];		break;
			case DeviceRowTypeDEVICE_NAME:	title = @"DeviceName";	detail = [SPUtility deviceName];			break;
			case DeviceRowTypePLATFORM_NAME:	title = @"PlatformName";	detail = [SPUtility platformName];		break;
			case DeviceRowTypeSYSTEM_LANGUAGE:	title = @"System Language";	detail = [[NSLocale preferredLanguages] firstObject]; break;
			default:
				break;
		}
		
		cell.textLabel.text			= title;
		cell.detailTextLabel.text	= detail;
	}
	else if (indexPath.section == SectionTypeACCOUNT) {
		switch (indexPath.row) {
			case AccountRowTypeUID:	title = @"UID"; detail = [HiveSocialManager sharedInstance].uid;		break;
			case AccountRowTypeID:	title = @"ID";	detail = [HiveSocialManager sharedInstance].username; break;
			case AccountRowTypeFACEBOOK_ID: title = @"Facebook UserID";			detail = [HiveSocialManager sharedInstance].fbid;	break;
			case AccountRowTypeGOOGLEPLUS_ID:	title = @"GooglePlus UserID";	detail = [HiveSocialManager sharedInstance].googleplusId;	break;
			default:
				break;
		}
		
		cell.textLabel.text			= title;
		cell.detailTextLabel.text	= detail;
	}
	
	return cell;
}

#pragma mark - UITableViewDelegate Methods
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
	
	UITableViewCell* cell	= [tableView cellForRowAtIndexPath:indexPath];
	
	[SPAlertView showAlertView:cell.textLabel.text message:cell.detailTextLabel.text at:self];
}

#pragma mark -
- (void)_onClose
{
	[self dismissViewControllerAnimated:YES completion:nil];
}

@end
