//
//  SPButton.h
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import <UIKit/UIKit.h>

@class SPButton;

typedef NS_ENUM(NSInteger, SPItemAlignment) {
	SPItemAlignmentHorizontal,
	SPItemAlignmentVertical,
};

typedef void (^SPButtonHandler) (SPButton* button);

@interface SPButton : UIView
{
	BOOL _isTouched;
}

@property (nonatomic, copy) SPButtonHandler handler;

@property (readonly, nonatomic, strong) UIButton* button;

@property (readonly, nonatomic, strong) UIImageView* imageView;

@property (readonly, nonatomic, strong) UILabel* textLabel;

@property (nonatomic) SPItemAlignment itemAlignment;

@property (nonatomic) BOOL enabled;

@property (nonatomic, strong) NSString* title;

+ (SPButton *)button:(SPButtonHandler)handler;

+ (SPButton *)buttonWithTitle:(NSString *)title handler:(SPButtonHandler)handler;

+ (SPButton *)buttonWithImagePath:(NSString *)imagePath handler:(SPButtonHandler)handler;

+ (SPButton *)buttonWithTitle:(NSString *)title imagePath:(NSString *)imagePath handler:(SPButtonHandler)handler;

- (void)setText:(NSString *)text;

@end
