//
//  SPImageCache.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 14..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPImageCache.h"

@interface SPImageCache ()
{
	NSCache* _imageCache;
}
@end

@implementation SPImageCache

+ (void)getImageData:(NSString *)urlString completion:(SPImageCacheCompletion)completion
{
	[[SPImageCache sharedInstance] getImageData:urlString completion:completion];
}

+ (instancetype)sharedInstance
{
	static dispatch_once_t _once;
	static id _instance = nil;
	
	dispatch_once(&_once, ^{
		_instance	= [[self alloc] init];
	});
	
	return _instance;
}

- (instancetype)init
{
	self	= [super init];
	
	if (self) {
		_imageCache	= [[NSCache alloc] init];
	}
	
	return self;
}

- (void)getImageData:(NSString *)urlString completion:(SPImageCacheCompletion)completion
{
	NSData* cachedData	= [_imageCache objectForKey:urlString];
	
	if (cachedData) {
		if (completion)
			completion(cachedData);
	}
	else {
		dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
			NSData* data	= [NSData dataWithContentsOfURL:[NSURL URLWithString:urlString]];
			
			dispatch_async(dispatch_get_main_queue(), ^{
				if (data) {
                    [self->_imageCache setObject:data forKey:urlString];
					
					if (completion)
						completion(data);
				}
			});
		});
	}
}

@end
