//
//  SPLabel.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPLabel.h"

@implementation SPLabel

+ (instancetype)label:(NSString *)text
{
	return [self label:text border:NO];
}

+ (instancetype)label:(NSString *)text border:(BOOL)border;
{
	SPLabel* lb	= [[SPLabel alloc] init];
	lb.translatesAutoresizingMaskIntoConstraints	= NO;
	lb.textLabel.text	= text;
	
	if (border) {
		lb.layer.borderColor	= SP_LABEL_BORDER_COLOR.CGColor;
		lb.layer.borderWidth	= 3.0f;
	}
	
	return lb;
}

- (instancetype)init
{
	self	= [super init];
	
	if (self) {
		_textLabel	= [[UILabel alloc] init];
		_textLabel.translatesAutoresizingMaskIntoConstraints	= NO;
		_textLabel.textAlignment	= NSTextAlignmentCenter;
		_textLabel.textColor		= SP_LABEL_TEXT_COLOR;
		_textLabel.font				= [UIFont fontWithName:SP_DEFAULT_FONT_NAME size:14];
		_textLabel.adjustsFontSizeToFitWidth	= YES;
		_textLabel.minimumScaleFactor	= .8f;
		[self addSubview:_textLabel];
	}
	
	return self;
}

- (void)showBorder
{
	
}

- (void)layoutSubviews
{
	NSDictionary* views	= NSDictionaryOfVariableBindings(_textLabel);
	NSDictionary* metrics	= @{};
	NSArray* constraints;
	
	constraints	= @[@"H:|[_textLabel]|", @"V:|[_textLabel]|"];
	
	for (NSString* str in constraints) {
		[self addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:str options:0 metrics:metrics views:views]];
	}
	
	if (SYSTEM_VERSION_LESS_THAN(@"8.0")) {
		[super layoutSubviews];
	}
}


@end
