//
//  SPLogCell.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 14..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPLogCell.h"
#import "SPLogFrame.h"

@implementation SPLogCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
	self	= [super initWithStyle:style reuseIdentifier:reuseIdentifier];
	
	if (self) {
		_textView	= [[UITextView alloc] initWithFrame:CGRectZero];
		_textView.textAlignment	= NSTextAlignmentLeft;
		_textView.font			= [SPLogFrame logFont];
		_textView.editable		= NO;
		_textView.scrollEnabled	= NO;
		_textView.userInteractionEnabled	= NO;
		//		_textView.exclusiveTouch	= YES;
		_textView.layer.cornerRadius	= 5;
		[self.contentView addSubview:_textView];
		
		_dateLabel	= [[UILabel alloc] initWithFrame:CGRectZero];
		_dateLabel.textAlignment	= NSTextAlignmentLeft;
		_dateLabel.font				= [SPLogFrame dateFont];
		_dateLabel.backgroundColor	= [UIColor clearColor];
		//		_dateLabel.layer.borderColor	= [UIColor whiteColor].CGColor;
		//		_dateLabel.layer.borderWidth	= 1.0f;
		[self.contentView addSubview:_dateLabel];
	}
	
	return self;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (void)setLogText:(NSString *)logText dateString:(NSString *)dateString cellType:(SPLogCellType)logCellType
{
	_logText		= logText;
	_logCellType	= logCellType;
	
	CGSize size = CGSizeMake(CGRectGetWidth(self.contentView.frame) * 0.6, CGFLOAT_MAX);
	CGSize contentSize;
	CGRect frame;
	CGFloat padding	= 4;
	
	CGRect dateFrame;
	CGSize dateContentSize;
	
	if (_logCellType == SPLogCellTypeRequest) {
		_textView.autoresizingMask	= UIViewAutoresizingFlexibleRightMargin;
		_dateLabel.autoresizingMask	= UIViewAutoresizingFlexibleRightMargin;
		
		contentSize	= [SPLogFrame size:size string:logText];
		frame		= CGRectMake(padding, 0, contentSize.width, contentSize.height);
		
		dateContentSize	= [SPLogFrame size:CGSizeMake(CGRectGetWidth(self.contentView.frame) - contentSize.width, CGFLOAT_MAX) dateString:dateString];
		dateFrame		= CGRectMake(CGRectGetMaxX(frame) + padding, contentSize.height - dateContentSize.height,
									 dateContentSize.width, dateContentSize.height);
		_dateLabel.textAlignment	= NSTextAlignmentLeft;
	}
	else {
		_textView.autoresizingMask	= UIViewAutoresizingFlexibleLeftMargin;
		_dateLabel.autoresizingMask	= UIViewAutoresizingFlexibleLeftMargin;
		
		contentSize	= [SPLogFrame size:size string:logText];
		frame		= CGRectMake(CGRectGetWidth(self.contentView.frame) - contentSize.width - padding, 0, contentSize.width, contentSize.height);
		
		dateContentSize	= [SPLogFrame size:CGSizeMake(CGRectGetWidth(self.contentView.frame) - contentSize.width, CGFLOAT_MAX) dateString:dateString];
		dateFrame		= CGRectMake(CGRectGetMinX(frame) - dateContentSize.width - padding, contentSize.height - dateContentSize.height,
									 dateContentSize.width, dateContentSize.height);
		_dateLabel.textAlignment	= NSTextAlignmentRight;
	}
	
	frame.size.height += 8;
	
	_textView.frame	= frame;
	_textView.text	= logText;
	_textView.backgroundColor	= (_logCellType == SPLogCellTypeRequest) ? [UIColor whiteColor] : [UIColor yellowColor];
	
	_dateLabel.frame		= dateFrame;
	_dateLabel.text			= dateString;
}

- (void)setLogText:(NSString *)logText cellType:(SPLogCellType)logCellType
{
	[self setLogText:logText dateString:@"00:00 AM" cellType:logCellType];
}

@end
