//
//  SPLogFrame.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 14..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPLogFrame.h"

@implementation SPLogFrame

+ (UIFont *)logFont
{
	return [UIFont systemFontOfSize:12];
}

+ (CGSize)size:(CGSize)contentSize string:(NSString *)string
{
	NSString* adjustString	= string;
	if ([string length] > 150) {
		adjustString	= [string substringWithRange:NSMakeRange(0, 150)];
	}
	
	if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0")) {
		CGRect rect	= [adjustString boundingRectWithSize:CGSizeMake(contentSize.width, CGFLOAT_MAX)
										   options:NSStringDrawingUsesLineFragmentOrigin
										attributes:@{NSFontAttributeName : [self logFont]}
										   context:nil];
		
		rect.size.width += 16;
		rect.size.height += 8;
		
		if (rect.size.height > 200)
			rect.size.height	= 200;
		
		return rect.size;
	}
	else {
		CGSize size	= [adjustString sizeWithFont:[self logFont] constrainedToSize:CGSizeMake(contentSize.width, CGFLOAT_MAX) lineBreakMode:NSLineBreakByWordWrapping];
		
		return size;
	}
}

+ (UIFont *)dateFont
{
	return [UIFont systemFontOfSize:10];
}

+ (CGSize)size:(CGSize)contentSize dateString:(NSString *)dateString
{
	NSString* adjustString	= dateString;
	if ([dateString length] > 150) {
		adjustString	= [dateString substringWithRange:NSMakeRange(0, 150)];
	}
	
	if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0")) {
		CGRect rect	= [adjustString boundingRectWithSize:CGSizeMake(contentSize.width, CGFLOAT_MAX)
											   options:NSStringDrawingUsesLineFragmentOrigin
											attributes:@{NSFontAttributeName : [self dateFont]}
											   context:nil];
		
		rect.size.width += 16;
		//	rect.size.height += 8;
		
		return rect.size;
	}
	else {
		CGSize size	= [adjustString sizeWithFont:[self dateFont] constrainedToSize:CGSizeMake(contentSize.width, CGFLOAT_MAX) lineBreakMode:NSLineBreakByWordWrapping];
		
		return size;
	}
}

@end
