//
//  SPLogViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 14..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPLogViewController.h"
#import "SPLogFrame.h"
#import "SPLogCell.h"
#import "HiveSocialLog.h"
#import "LogDetailViewController.h"
#import "MainNavigationController.h"

@interface SPLogViewController ()

@property (nonatomic, strong) NSMutableArray* row;

@end

@implementation SPLogViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	self.tableView.backgroundColor	= [UIColor lightGrayColor];
	self.tableView.separatorStyle	= UITableViewCellSeparatorStyleNone;
	
	self.navigationItem.rightBarButtonItem	= [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemTrash target:self action:@selector(_onClear:)];
	
	[self _load];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_didChangeOrientation) name:UIDeviceOrientationDidChangeNotification object:nil];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear
{
//	[self _load];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_insertReload) name:HiveSocialFlowDataDidInsertNotification object:nil];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_updateReload) name:HiveSocialFlowDataDidUpdateNotification object:nil];
	
	[self _insertReload];
	[self _updateReload];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[[NSNotificationCenter defaultCenter] removeObserver:self name:HiveSocialFlowDataDidInsertNotification object:nil];
	[[NSNotificationCenter defaultCenter] removeObserver:self name:HiveSocialFlowDataDidUpdateNotification object:nil];
	
	[super viewWillDisappear:animated];
}

- (void)_didChangeOrientation
{
	[self.tableView reloadData];
}

- (void)_load
{
	_row	= [@[] mutableCopy];
//	for (HiveSocialLogData* logData in [[HiveSocialLog sharedInstance] getAllFlowData]) {
//		NSMutableDictionary* dict;
//		
//		dict	= [@{} mutableCopy];
//		
//		if (logData.requestString) {
//			dict[kLogText]	= logData.requestString;
//			dict[kLogDate]	= logData.requestDate;
//		}
//		[_row addObject:dict];
//		
//		dict	= [@{} mutableCopy];
//		
//		if (logData.responseString) {
//			dict[kLogText]	= logData.responseString;
//			dict[kLogDate]	= logData.responseDate;
//		}
//		
//		[_row addObject:dict];
//	}
	
	_row	= [NSMutableArray arrayWithArray:[[HiveSocialLog sharedInstance] getAllFlowData]];
	
	[CATransaction begin];
	
	[self.tableView reloadData];
	
	[CATransaction setCompletionBlock:^{
		[self scrollToBottom];
	}];
	
	[CATransaction commit];
}

- (void)_insertReload
{
	NSMutableArray* array	= [@[] mutableCopy];

	for (HiveSocialLogData* logData in [[HiveSocialLog sharedInstance] getInserted]) {
		[array addObjectsFromArray:@[[NSIndexPath indexPathForRow:([_row count] * 2) + 0 inSection:0],
									 [NSIndexPath indexPathForRow:([_row count] * 2) + 1 inSection:0]]];
		[_row addObject:logData];
	}
	
	[self.tableView beginUpdates];
	[self.tableView insertRowsAtIndexPaths:array withRowAnimation:UITableViewRowAnimationAutomatic];
	[self.tableView endUpdates];
	
	[self scrollToBottom];
}

- (void)_updateReload
{
	NSMutableArray* array	= [@[] mutableCopy];
	NSMutableArray* tmpRow	= [NSMutableArray arrayWithArray:_row];
	for (HiveSocialLogData* logData in [[HiveSocialLog sharedInstance] getUpdated]) {
		for (HiveSocialLogData* pLogData in _row) {
			if (logData.object != pLogData.object)
				continue;
			NSInteger idx = [_row indexOfObject:pLogData];
			[tmpRow replaceObjectAtIndex:idx withObject:logData];
			
			[array addObjectsFromArray:@[[NSIndexPath indexPathForRow:(idx * 2) + 0 inSection:0],
										 [NSIndexPath indexPathForRow:(idx * 2) + 1 inSection:0],
										 ]];
		}
	}
	
	_row	= tmpRow;
	
	[self.tableView beginUpdates];
	[self.tableView reloadRowsAtIndexPaths:array withRowAnimation:UITableViewRowAnimationAutomatic];
	[self.tableView endUpdates];
	
	[self scrollToBottom];
	
//	NSMutableArray* array	= [@[] mutableCopy];
//	
//	NSInteger max	= [_row count] - 1;
//	
//	for (NSInteger idx = max; max - idx < [[self.tableView visibleCells] count]; idx--) {
//		[array addObject:[NSIndexPath indexPathForRow:idx inSection:0]];
//	}
//	
//	[self.tableView beginUpdates];
//	[self.tableView reloadRowsAtIndexPaths:array withRowAnimation:UITableViewRowAnimationNone];
////	[self.tableView reloadData];
//	[self.tableView endUpdates];
//	
//	[self scrollToBottom];
}

//- (void)_reload
//{
//	NSMutableArray* array	= [@[] mutableCopy];
//	NSInteger currentRowIndex = [_row count];
//	
//	for (HiveSocialLogData* logData in [[HiveSocialLog sharedInstance] getNewOne]) {
//		NSMutableDictionary* dict;
//		
//		dict	= [@{} mutableCopy];
//		
//		if (logData.requestString) {
//			dict[kLogText]	= logData.requestString;
//			dict[kLogDate]	= logData.requestDate;
//		}
//		[_row addObject:dict];
//		[array addObject:[NSIndexPath indexPathForRow:currentRowIndex++ inSection:0]];
//		
//		dict	= [@{} mutableCopy];
//		
//		if (logData.responseString) {
//			dict[kLogText]	= logData.responseString;
//			dict[kLogDate]	= logData.responseDate;
//		}
//		
//		[_row addObject:dict];
//		[array addObject:[NSIndexPath indexPathForRow:currentRowIndex++ inSection:0]];
//	}
//	
//	[self.tableView beginUpdates];
//	[self.tableView insertRowsAtIndexPaths:array withRowAnimation:UITableViewRowAnimationAutomatic];
//	[self.tableView endUpdates];
//	
//	[self scrollToBottom];
//}

- (void)_onClear:(id)sender
{
	[[HiveSocialLog sharedInstance] deleteAllFlowData];
	
	[self _load];
}

- (void)scrollToBottom
{
	if (_row == nil || [_row count] == 0)
		return;
	
	[self.tableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:([_row count] * 2) - 1 inSection:0] atScrollPosition:UITableViewScrollPositionBottom animated:NO];
}

- (NSString *)getDateString:(NSInteger)row
{
	NSInteger offset	= row / 2;
	NSInteger tag		= row % 2;
	
	HiveSocialLogData* logData	= _row[offset];
	
	NSDate* date;
	
	if (tag == 0) {
		date	= logData.requestDate;
	}
	else {
		date	= logData.responseDate;
	}
	
	if (date == nil)
		return @"";
	
	NSDateFormatter* df	= [[NSDateFormatter alloc] init];
	[df setTimeStyle:NSDateFormatterMediumStyle];
	
	return [df stringFromDate:date];
}

- (NSString *)getString:(NSInteger)row
{
	NSInteger offset	= row / 2;
	NSInteger tag		= row % 2;
	
	HiveSocialLogData* logData	= _row[offset];
	
	if (tag == 0) {
		return logData.requestString ? logData.requestString : @"";
	}
	else {
		return logData.responseString ? logData.responseString : @"";
	}
	
	return @"";
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
//	return [_row count];
	return [_row count] * 2;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
	SPLogCell* cell;
	
	static NSString* CellIdentifier	= @"RequestCell";
	cell	= [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (!cell) {
		cell	= [[SPLogCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
	}
	cell.backgroundColor	= [UIColor lightGrayColor];
	
	cell.textLabel.text	= @"";
	
	cell.selectionStyle	= UITableViewCellSelectionStyleNone;

//	NSDictionary* dict	= _row[indexPath.row];
//	NSString* logText	= @"";
//	NSString* logDate	= @"";
//	
//	if ([[dict allKeys] containsObject:kLogText])
//		logText	= dict[kLogText];
//	if ([[dict allKeys] containsObject:kLogDate]) {
//		NSDateFormatter* df	= [[NSDateFormatter alloc] init];
//		[df setTimeStyle:NSDateFormatterMediumStyle];
//		logDate	= [df stringFromDate:dict[kLogDate]];
//	}
	
	[cell setLogText:[self getString:indexPath.row] dateString:[self getDateString:indexPath.row] cellType:(indexPath.row % 2 == 0) ? SPLogCellTypeRequest : SPLogCellTypeResponse];
	
	return cell;
}

#pragma mark - UITableViewDelegate Methods
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
	return [SPLogFrame size:CGSizeMake(CGRectGetWidth(self.view.frame) * 0.6, CGFLOAT_MAX) string:[self getString:indexPath.row]].height + 16;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
	[tableView deselectRowAtIndexPath:indexPath animated:NO];

//	NSArray* allFlowData	= [[HiveSocialLog sharedInstance] getAllFlowData];
	
//	HiveSocialLogData* logData	= allFlowData[offset];
	//
	//	if (type == 0) {
	//		NSLog(@"request cookie : %@", flowData.requestCookies);
	//	}
	//	else {
	//		NSLog(@"response cookie : %@", flowData.responseCookies);
	//	}
	
	HiveSocialLogData* logData	= _row[indexPath.row / 2];
	
	LogDetailViewController* vc	= [[LogDetailViewController alloc] init];
	vc.requestString		= logData.requestString;
	vc.responseString		= logData.responseString;
	
//	CookieViewController* vc	= [[CookieViewController alloc] initWithStyle:UITableViewStylePlain];
//	vc.cookies	= type == 0 ? flowData.requestCookies : flowData.responseCookies;
//	
//	[self.navigationController pushViewController:vc animated:YES];
	
	if (_delegate && [_delegate respondsToSelector:@selector(didSelectLog:)]) {
		[_delegate didSelectLog:vc];
	}
}

@end
