//
//  SPUtility.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 14..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPUtility.h"
#import <sys/types.h>
#import <sys/sysctl.h>
#import <sys/socket.h>
#import <net/if_dl.h>
#import <ifaddrs.h>

#ifndef IFT_ETHER
#define IFT_ETHER 0x6
#endif


@implementation SPUtility

+ (id)parseOrNil:(NSDictionary *)dictionary key:(NSString *)key
{
	if ([[dictionary allKeys] containsObject:key] && ![dictionary[key] isKindOfClass:[NSNull class]])
		return dictionary[key];
	
	return nil;
}

+ (NSString *)macAddress
{
	NSMutableString *macAddr = [NSMutableString stringWithString:@""];
	
	struct ifaddrs *addrs = NULL;
	getifaddrs(&addrs);
	
	struct ifaddrs *curAddr	= addrs;
	
	while (NULL != curAddr)
	{
		if ((AF_LINK == curAddr->ifa_addr->sa_family) &&
			(IFT_ETHER == ((struct sockaddr_dl*) curAddr->ifa_addr)->sdl_type) &&
			(strcmp("en0", curAddr->ifa_name) == 0))
		{
			struct sockaddr_dl* dlAddr	= (struct sockaddr_dl*) curAddr->ifa_addr;
			unsigned char* base	= (unsigned char*)& dlAddr->sdl_data[dlAddr->sdl_nlen];
			for (int i = 0 ; i < dlAddr->sdl_alen ; i++)
			{
				[macAddr appendFormat:@"%02x", base[i]];
			}
			break;
		}
		
		curAddr	= curAddr->ifa_next;
	}
	
	freeifaddrs(addrs);
	
	return macAddr;
}

+ (NSString *)deviceName
{
	const char *typeSpecifier = "hw.machine";
	size_t size = 0;
	sysctlbyname(typeSpecifier, NULL, &size, NULL, 0);
	
	char *answer = malloc(size);
	sysctlbyname(typeSpecifier, answer, &size, NULL, 0);
	
	NSString *results = [NSString stringWithUTF8String:answer];
	
	free(answer);
	return results;
}

+ (NSString *)platformName
{
	return @"ios";
}

+ (NSString *)osVersion
{
	return [[UIDevice currentDevice] systemVersion];
}

+ (NSString *)vendorIdentifier
{
	UIDevice *device = [UIDevice currentDevice];
	if (![device respondsToSelector:@selector(identifierForVendor)])
		return nil;
	return [[device identifierForVendor] UUIDString];
}

@end
