//
//  SPViewController.m
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import "SPViewController.h"
#import "MoreViewController.h"
#import "MainNavigationController.h"
#import "HiveSocialManager.h"
#import "C2SActiveUser.h"

#pragma mark -
@interface SPViewController ()
{
	SPButton* _moreButton;
}
@end

@implementation SPViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
	
	if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0")) {
		[[UIToolbar appearance] setBarTintColor:SP_NAVIGATION_BAR_COLOR];
	}
	else {
		[[UIToolbar appearance] setTintColor:SP_NAVIGATION_BAR_COLOR];
	}
	
	_moreButton	= [SPButton buttonWithTitle:TITLE_MORE handler:^(SPButton *button) {
		MoreViewController* vc	= [[MoreViewController alloc] initWithStyle:UITableViewStyleGrouped];
		[self.navigationController presentViewController:[[MainNavigationController alloc] initWithRootViewController:vc] animated:YES completion:nil];
	}];
	_moreButton.frame				= CGRectMake(0, 0, 80, 38);
	_moreButton.textLabel.textColor	= SP_BUTTON_TEXT_COLOR;
	_moreButton.backgroundColor		= SP_BUTTON_COLOR_TYPE01;
	
	[self setToolbarItems:@[[[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil],
							[[UIBarButtonItem alloc] initWithCustomView:_moreButton]]];
	
	[self.navigationController setToolbarHidden:NO];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateDidInfo) name:SPHiveSocialDidInitializeNotification object:nil];
	
	if ([HiveSocialManager sharedInstance].isInitialized) {
		[self updateDidInfo];
	}
	
    NSString *didString = [NSString stringWithUTF8String:CS_ActiveUserGetDID()];
    [HiveSocialManager sharedInstance].did	= didString;
    dispatch_async(dispatch_get_main_queue(), ^{
        SPLabel* label	= [SPLabel label:[NSString stringWithFormat:@"DID : %@", didString]];
        label.translatesAutoresizingMaskIntoConstraints	= YES;
        label.frame	= CGRectMake(0, 0, 200, 36);
        label.textLabel.textAlignment	= NSTextAlignmentLeft;
        label.textLabel.textColor	= [UIColor whiteColor];
        label.textLabel.backgroundColor	= [UIColor clearColor];
        
        [self setToolbarItems:nil];
        
        [self setToolbarItems:@[[[UIBarButtonItem alloc] initWithCustomView:label],
                                [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil],
                                [[UIBarButtonItem alloc] initWithCustomView:self->_moreButton]]];
    });
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(_didChangeOrientation) name:UIDeviceOrientationDidChangeNotification object:nil];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self name:SPHiveSocialDidInitializeNotification object:nil];
}

- (void)_didChangeOrientation
{
	[self orientationChanged];
}

- (void)orientationChanged
{
	//	dummy.
}

- (void)updateDidInfo
{
    NSString *didString = [NSString stringWithUTF8String:CS_ActiveUserGetDID()];
    [HiveSocialManager sharedInstance].did	= didString;
    dispatch_async(dispatch_get_main_queue(), ^{
        SPLabel* label	= [SPLabel label:[NSString stringWithFormat:@"DID : %@", didString]];
        label.translatesAutoresizingMaskIntoConstraints	= YES;
        label.frame	= CGRectMake(0, 0, 200, 36);
        label.textLabel.textAlignment	= NSTextAlignmentLeft;
        label.textLabel.textColor	= [UIColor whiteColor];
        label.textLabel.backgroundColor	= [UIColor clearColor];

        [self setToolbarItems:nil];

        [self setToolbarItems:@[[[UIBarButtonItem alloc] initWithCustomView:label],
                                [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil],
                                [[UIBarButtonItem alloc] initWithCustomView:self->_moreButton]]];
    });
		
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
