//
//  WithUserInfoViewController.h
//  HiveSampleV2
//
//  Created by LucidArkeo on 2015. 9. 9..
//  Copyright (c) 2015년 com2us. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "WithSettingsViewController.h"

@class UserView;
@class UserInfoView;
@class UserActionView;

@protocol UserViewDelegate <NSObject>

@optional
- (void)didSelectButton:(SPButton *)button atUserView:(UserView *)userView;
@end

@interface UserView : UIView

@property (nonatomic, assign) id <UserViewDelegate> delegate;

@end

//
//
//---------------------------------------------------
@interface UserInfoView : UserView
{
	NSMutableArray* _mainConstraints;
	NSMutableArray* _subConstraints;
}
@property (readonly, nonatomic, strong) UIImageView* profileImageView;

@property (readonly, nonatomic, strong) UILabel* usernameLabel;

@property (readonly, nonatomic, strong) SPButton* facebookButton;

@property (readonly, nonatomic, strong) SPButton* googleplusButton;

@end

//
//
//---------------------------------------------------
@interface UserActionView : UserView
{
	NSMutableArray* _allConstraints;
}

@property (readonly, nonatomic, strong) SPButton* friendsButton;

@property (readonly, nonatomic, strong) SPButton* inviteButton;

@property (readonly, nonatomic, strong) SPButton* etcButton;

@property (readonly, nonatomic, strong) SPButton* faqButton;

@property (readonly, nonatomic, strong) SPButton* logoutButton;

@property (readonly, nonatomic, strong) SPButton* csBotButton;

@property (readonly, nonatomic, strong) SPButton* userDeleteButton;

@end

//
//
//---------------------------------------------------
@interface UserGuestActionView : UserView
{
	NSMutableArray* _allConstraints;
}

@property (readonly, nonatomic, strong) SPButton* convertAccountButton;

@property (readonly, nonatomic, strong) SPButton* faqButton;

@property (readonly, nonatomic, strong) SPButton* loginButton;

@property (readonly, nonatomic, strong) SPButton* csBotButton;

@property (readonly, nonatomic, strong) SPButton* userDeleteButton;

@end

typedef NS_ENUM(NSInteger, WithUserInfoViewType) {
	WithUserInfoViewTypeRegular,
	WithUserInfoViewTypeGuest
};

@interface WithUserInfoViewController : WithSettingsViewController

@property (readonly, nonatomic) WithUserInfoViewType type;

@property (readonly, nonatomic, strong) UserInfoView* userInfoView;

@property (readonly, nonatomic, strong) UserActionView* userActionView;

@property (readonly, nonatomic, strong) UserGuestActionView* userGuestActionView;

- (instancetype)initWithType:(WithUserInfoViewType)type;

@end
