//
//  ActionController.h
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#ifndef ActionController_h
#define ActionController_h

#import "C2SModule.h"
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "DataManager.h"

//#import "keySample.h"  //DealCallback에 포함
//#import "LogController.h"  //DealCallback에 포함
//#import "InfoController.h"  //DealCallback에 포함

//IAP
#import "PostBoxActionController.h"


#define GET_ACTION_CONTROLLER [ActionController shareInstance]


typedef NS_ENUM(NSInteger, delegateState)
{
    DELEGATE_HANDLER,
    DELEGATE_RESULT
};

/*
typedef NS_ENUM(NSInteger, programState)
{
    STATE_NO_INITIALIZE,
    STATE_NO_LOGIN,
    STATE_GUEST_LOGIN,
    STATE_PLATFORM_LOGIN
};
*/

@interface ActionController : NSObject <C2SModuleResultDelegate, UIAlertViewDelegate>




+ (ActionController*)shareInstance;

//-----------------------------------------------------------------
// view로 데이터 전달/받기
//-----------------------------------------------------------------
-(NSMutableArray*)getRealGroupList;
-(NSMutableArray*)getGroupList;
-(NSMutableDictionary*)getCurrentGroup;
-(APIAction*)getCurrentAction;
-(Parameter*)getCurrentParam;
-(void)setCurrentGroup:(NSMutableDictionary*)group;
-(void)setCurrentAction:(APIAction*)action;
-(void)setCurrentParam:(Parameter*)param;

-(delegateState)getCurrentDelegate;
-(void)setCurrentDelegate;

-(void)setLoginLabel:(NSString*)Label;
-(NSString*)getLoginLabel;
-(void)setServerLabel:(NSString*)Label;
-(NSString*)getServerLabel;

-(NSDictionary*)getTempDic;


//-----------------------------------------------------------------
// 초기 설정
//-----------------------------------------------------------------

- (void) initialize;

//-----------------------------------------------------------------
// 함수 호출
//-----------------------------------------------------------------

- (void) callModuleApi;

//0. No Possible IOS - IOS에서는 지원 안함
-(void)func_NoIOS:(callBackNum)api;

//-----------------------------------------------------------------
// api 각각 호출
//-----------------------------------------------------------------

//1. Initialize
-(void)func_SocialInitialize:(NSMutableDictionary*)optionSelect;
-(void)func_SnsSetGuestUserInfo:(NSMutableDictionary*)optionSelect;

//2. Login
-(void)func_SnsLogin :(NSMutableDictionary*)optionSelect;
-(void)func_SnsGetLoginType:(NSMutableDictionary*)optionSelect;
-(void)func_SnsLogout:(NSMutableDictionary*)optionSelect;
-(void)func_SnsSelect:(NSMutableDictionary*)optionSelect;
-(void)func_SnsCustomSelect:(NSMutableDictionary*)optionSelect;

//3. Local Push
-(void)func_PushRegister :(NSMutableDictionary*)optionSelect;
-(void)func_PushUnregister :(NSMutableDictionary*)optionSelect;

//4. Push Description
-(void)func_PushDescription :(NSMutableDictionary*)optionSelect;

//5. User Info
-(void)func_SnsUser :(NSMutableDictionary*)optionSelect;

//6. Sns Post
-(void)func_SnsPost :(NSMutableDictionary*)optionSelect;

//7. Promotion
-(void)func_PromotionShow :(NSMutableDictionary*)optionSelect;
-(void)func_PromotionInfo :(NSMutableDictionary*)optionSelect;
-(void)func_PromotionGetOfferwallState:(NSMutableDictionary*)optionSelect;
-(void)func_PromotionAcquisition:(NSMutableDictionary*)optionSelect;

//8. Invite Friend
-(void)func_SnsFriends :(NSMutableDictionary*)optionSelect;
-(void)func_SnsMessage :(NSMutableDictionary*)optionSelect;
-(void)func_SnsSession :(NSMutableDictionary*)optionSelect;

//11. SNS Webview
-(void)func_SnsShow :(NSMutableDictionary*)optionSelect;

//12. Terms + adult + socialShow/info
-(void)func_SocialShow:(NSMutableDictionary*)optionSelect;
-(void)func_SocialInfo :(NSMutableDictionary*)optionSelect;

//13. Marketing Tracking
-(void)func_TrackerSetEnable :(NSMutableDictionary*)optionSelect;
-(void)func_TrackerSendEvent :(NSMutableDictionary*)optionSelect;

//15. Engagement
//-(void)func_EngagementGetEvents :(NSMutableDictionary*)optionSelect;
-(void)func_EngagementConsumeCoupon :(NSMutableDictionary*)optionSelect;

//16. HIVE Promotion
-(void)func_HivePromotionShow :(NSMutableDictionary*)optionSelect;
-(void)func_HivePromotionInfo :(NSMutableDictionary*)optionSelect;
-(void)func_HivePromotionSetAdditionalInfo :(NSMutableDictionary*)optionSelect;
-(void)func_HivePromotionGetOfferwallState :(NSMutableDictionary*)optionSelect;

//17. SetGameInfo
-(void)func_SocialSetGameInfo :(NSMutableDictionary*)optionSelect;



@end

#endif /* ActionController_h */


