//
//  ActionController.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "ActionController.h"


@interface ActionController()
{
    DataManager* dataMain;
    NSMutableArray* realGroupList;
    NSMutableArray* groupList;
    NSMutableDictionary* currentGroup;
    APIAction* currentAction;
    Parameter* currentParam;
    delegateState currentDelegate;
    //programState currentState;
    NSNumber* selectOK;
    
    NSString* loginLabel;
    NSString* serverLabel;
    
    NSString* tempInfo;
    NSMutableDictionary* tempSelect;
    NSMutableDictionary* tempDic;
    NSMutableDictionary* receiptList;
    
    id tempData;
    
}

@end

@implementation ActionController

// 여러곳에서 동시에 호출을 대비
+ (ActionController*)shareInstance
{
    static ActionController* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
        [instance initialize];
    });
    
    return instance;
}


//-----------------------------------------------------------------
// 모듈 설정(delegate, init)
//-----------------------------------------------------------------

-(id)init
{
    [C2SModuleSocial SetCommonResultDelegate:self]; //Result Delegate Setting
    receiptList = [[NSMutableDictionary alloc]init];
    return [super init];
}


-(void)C2SModuleResult : (C2SModuleApi)api parameter:(NSDictionary *)arg error:(NSError *)error{
    // public callback
    NSString* name = C2SModuleApiString(api);
    if(error ==nil){
        switch(api){
            case C2SModuleApi_SocialInitialize:{
                [self resultDelegateResult:currentAction.name api:CB_SOCIAL_INITIALIZE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappDescription:{
                [self resultDelegateResult:name api:CB_INAPP_DESCRIPTION resultArg:arg resultError:error];
            } break;
            case C2SModuleApi_SnsSession:{
                [self resultDelegateResult:currentAction.name api:CB_SNS_SESSION resultArg:arg resultError:error];
            } break;
            case C2SModuleApi_SnsLogin:{
                NSDictionary* interworkArg = [arg objectForKey:@"interworkArg"];
                if(interworkArg!=nil){
                    [self func_InterWorkLogin:arg];
                    [self callbackPopUp:@"C2SModuleApi_SnsLogin" message:[self setListText:arg]];
                }
                else if([arg[KEY_TYPE] isEqualToString:PARAM_VALUE_SELECT])
                {
                    tempSelect[@"currentVid"] = arg[PARAM_LOGIN_CURRENTVID];
                    tempSelect[@"usedVid"] = arg[PARAM_LOGIN_USEDVID];
                    selectOK = @YES;
                    
                    [self resultDelegateResult:name api:CB_SNS_SELECT resultArg:arg resultError:error];
                }
                else{
                    if([arg[KEY_TYPE] isEqualToString:@"guest"])
                        tempInfo = PARAM_LOGIN_VALUE_GUEST;
                    else
                        tempInfo = PARAM_LOGIN_VALUE_PLATFORM;
                    
                    [self resultDelegateResult:name api:CB_SNS_LOGIN resultArg:arg resultError:error];
                }
            }break;
            case C2SModuleApi_SnsLogout:{
                [self resultDelegateResult:currentAction.name api:CB_SNS_LOGOUT resultArg:arg resultError:error];
            }break;
                
            case C2SModuleApi_PushRegister:{
                [self resultDelegateResult:currentAction.name api:CB_PUSH_REGISTER resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_PushUnregister:{
                [self resultDelegateResult:currentAction.name api:CB_PUSH_UNREGISTER resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_PushDescription:{
                [self resultDelegateResult:currentAction.name api:CB_PUSH_DESCRIPTION resultArg:arg resultError:error];
            }break;
                
            case C2SModuleApi_SnsUser:{
                [self resultDelegateResult:name api:CB_SNS_USER resultArg:arg resultError:error];
            }break;
            
            case C2SModuleApi_SnsPost:{
                [self resultDelegateResult:name api:CB_SNS_POST resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_PromotionShow:{
                bool isInterworkStart = [[arg objectForKey:@"isInterworkStart"] boolValue];
                if(isInterworkStart==true)
                    [self callbackPopUp:@"C2SModuleApi_PromotionShow" message:nil];
                
                [self resultDelegateResult:name api:CB_PROMOTION_SHOW resultArg:arg resultError:error];
            } break;
            case C2SModuleApi_PromotionInfo:{
                [self resultDelegateResult:currentAction.name api:CB_PROMOTION_INFO resultArg:arg resultError:error];
            } break;
            case C2SModuleApi_PromotionAcquisition:{
                [self resultDelegateResult:name api:CB_PROMOTION_ACQUISITION resultArg:arg resultError:error];
                if (currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION) {
                    dispatch_async(dispatch_get_main_queue(), ^{
                        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:self->currentAction.name message:nil delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:@"Link 보기",@"Stage 캠페인 보기", @"Each 캠페인 보기", nil];
                        
                        //qrcode 파싱
                        NSData* qrcode = [self hexadecialStringToData:arg[PARAM_PROMOTION_QRCODE]];
                        
                        UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                        imageView.contentMode = UIViewContentModeCenter;
                        imageView.image = [UIImage imageWithData:qrcode];
                        
                        if (floor(NSFoundationVersionNumber) > NSFoundationVersionNumber_iOS_6_1) {
                            [alert setValue:imageView forKey:@"accessoryView"];
                        }else{
                            [alert addSubview:imageView];
                        }
                        
                        alert.tag = 0;
                        [alert show];
                    });
                    tempData = arg;
                }
            } break;
            case C2SModuleApi_SnsFriends:{
                [self resultDelegateResult:name api:CB_SNS_FRIENDS resultArg:arg resultError:error];
            } break;
            case C2SModuleApi_SnsMessage:{
                NSDictionary* interworkArg = [arg objectForKey:@"interworkArg"];
                if(interworkArg!=nil)
                    [self callbackPopUp:@"C2SModuleApi_SnsMessage" message:[self setListText:arg]];
                
                [self resultDelegateResult:name api:CB_SNS_MESSAGE resultArg:arg resultError:error];
            } break;
                
            case C2SModuleApi_SnsShow:{
                NSDictionary* interworkArg = [arg objectForKey:@"interworkArg"];
                if(interworkArg!=nil)
                    [self callbackPopUp:@"C2SModuleApi_SnsShow" message:[self setListText:arg]];
                
                [self resultDelegateResult:name api:CB_SNS_SHOW resultArg:arg resultError:error];
            }break;
                
            case C2SModuleApi_SocialShow:{
                [self resultDelegateResult:name api:CB_SOCIAL_SHOW resultArg:arg resultError:error];
            }break;
             /*
            case C2SModuleApi_TrackingSetEnable:{
                [self resultDelegateResult:currentAction.name api:CB_TRACKER_SETENABLE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_TrackingSendEvent:{
                [self resultDelegateResult:currentAction.name api:CB_TRACKER_SENDEVENT resultArg:arg resultError:error];
            }break;*/
            /*
            case C2SModuleApi_InterworkStart:{
                NSDictionary* interworkArg = [arg objectForKey:@"interworkArg"];
                if(interworkArg!=nil)
                    [self callbackPopUp:@"C2SModuleApi_InterworkStart" message:[self setListText:arg]];
            } break;
            case C2SModuleApi_InterworkDelegate:{
                NSDictionary* interworkArg = [arg objectForKey:@"interworkArg"];
                if(interworkArg!=nil)
                    [self callbackPopUp:@"C2SModuleApi_InterworkDelegate" message:[self setListText:arg]];
            } break;
            */
            case C2SModuleApi_HiveIAPInitialize:{
                [self resultDelegateResult:name api:CB_HIVEIAP_INITIALIZE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HiveIAPInfo:{
                if([arg[PARAM_VALUE_TYPE] isEqualToString:PARAM_HIVEIAP_SHOPINFO]){
                    tempDic = arg.mutableCopy;
                    [self resultDelegateResult:currentAction.name api:CB_HIVEIAP_INFO_SHOP resultArg:arg resultError:error];
                }
                else
                    [self resultDelegateResult:currentAction.name api:CB_HIVEIAP_INFO resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HiveIAPShow:{}break;
            case C2SModuleApi_HiveIAPPurchase:{
                [self resultDelegateResult:currentAction.name api:CB_HIVEIAP_PURCHASE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HiveIAPRestore:{
                [self resultDelegateResult:currentAction.name api:CB_HIVEIAP_RESTORE resultArg:arg resultError:error];
            }break;
            
            // 1.10.0 Engagement
            case C2SModuleApi_EngagementProcessScheme:{
                //[self callbackPopUp:@"C2SModuleApi_EngagementProcessScheme" message:[self setListText:arg]];
                [self resultDelegateResult:name api:CB_ENGAGEMENT_PROCESSSCHEME resultArg:arg resultError:error];
            }break;
                /*
            case C2SModuleApi_EngagementGetEvents:{
                [self resultDelegateResult:name api:CB_ENGAGEMENT_GETEVENTS resultArg:arg resultError:error];
            }break;
                 */
            case C2SModuleApi_EngagementConsumeCoupon:{
                [self resultDelegateResult:name api:CB_ENGAGEMENT_CONSUMECOUPON resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_EngagementStart:{
                //[self callbackPopUp:@"C2SModuleApi_EngagementStart" message:[self setListText:arg]];
                [self resultDelegateResult:name api:CB_ENGAGEMENT_START resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_EngagementEnd:{
                [self resultDelegateResult:name api:CB_ENGAGEMENT_END resultArg:arg resultError:error];
            }break;
            
            // 1.10.0 SocialInfo
            case C2SModuleApi_SocialInfo:{
                [self resultDelegateResult:currentAction.name api:CB_SOCIAL_INFO resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_EngagementGameScheme:{
                [self resultDelegateResult:name api:CB_ENGAGEMENT_GAMESCHEME resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HivePromotionShow:{
                [self resultDelegateResult:name api:CB_HIVEPROMOTION_SHOW resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HivePromotionInfo:{
                [self resultDelegateResult:name api:CB_HIVEPROMOTION_INFO resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HivePromotionGetOfferwallState:{
                [self resultDelegateResult:name api:CB_HIVEPROMOTION_GETOFFERWALLSTATE resultArg:arg resultError:error];
            }break;
            
            case C2SModuleApi_InappCheckPromotePurchase:{
                [self resultDelegateResult:name api:CB_INAPP_CHECKPROMOTEPURCHASE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HiveIAPCheckPromotePurchase:{
                [self resultDelegateResult:name api:CB_HIVEIAP_CHECKPROMOTEPURCHASE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_PromotionCompanion:{
                [self resultDelegateResult:name api:CB_ETC resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_PromotionPlayback:{
                [self resultDelegateResult:name api:CB_ETC resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_HivePromotionPlayback:{
                [self resultDelegateResult:name api:CB_ETC resultArg:arg resultError:error];
            }break;
			case C2SModuleApi_PromotionGetBannerInfo:{
                [self resultDelegateResult:name api:CB_PROMOTION_GETBANNERINFO resultArg:arg resultError:error];
			}break;
            case C2SModuleApi_InappV4Initialize:{
                [self resultDelegateResult:name api:CB_INAPPV4_INITIALIZE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4ItemInfo:{
                tempDic = arg.mutableCopy;
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_ITEMINFO resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4Purchase:{
                if(arg[@"receipt"])
                    [self refreshReceiptList:@[arg[@"receipt"]]];
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_PURCHASE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4Restore:{
                if(arg[@"receiptList"])
                    [self refreshReceiptList:arg[@"receiptList"]];
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_RESTORE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4TransactionFinish:{
                if(arg[@"pid"])
                    [self finishSuccessProcess:arg[@"pid"]];
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_FINISH resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4CheckPromotePurchase:{
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_CHECKPROMOTEPURCHASE resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4GetSelectedMarket:{
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_GETSELECTEDMARKET resultArg:arg resultError:error];
            }break;
            case C2SModuleApi_InappV4GetAccountUuid:{
                [self resultDelegateResult:currentAction.name api:CB_INAPPV4_GETACCOUNTUUID resultArg:arg resultError:error];
            }
            default:{
                [self resultDelegateResult:name api:CB_ETC resultArg:arg resultError:error];
            }
                break;
        }
    }
    else{
        [GET_LOG_CONTROLLER errorLogSend:error name:name result:(int)currentDelegate];
    }
}


//result popup
-(void)callbackPopUp : (NSString*)title message:(NSString*)msg
{
    dispatch_async(dispatch_get_main_queue(), ^{
        UIAlertView *noClick = [[UIAlertView alloc] initWithTitle:title message:msg delegate:self cancelButtonTitle:nil otherButtonTitles:@"Close", nil];
        
        [noClick show];
    });
}

//Dictionary list를 text로 변환
-(NSString*)setListText:(NSDictionary*)arg
{
    NSMutableString* dict = [[NSMutableString alloc] init];
    for(NSString* key in arg.allKeys)
    {
        NSString* Dic = [[NSString alloc] initWithFormat:@"[%@] : %@\n", key, [arg objectForKey:key]];
        [dict insertString:Dic atIndex:dict.length];
    }
    
    return dict;
}




//-----------------------------------------------------------------
// view로 데이터 전달
//-----------------------------------------------------------------

//진짜 그룹 리스트
-(NSMutableArray*)getRealGroupList
{
    return realGroupList;
}

//그룸 리스트
-(NSMutableArray*)getGroupList
{
    return groupList;
}
//현재 그룹 -> actionView
-(NSMutableDictionary*)getCurrentGroup
{
    return currentGroup;
}
//현재 액션 -> paramView
-(APIAction*)getCurrentAction
{
    return currentAction;
}
// 현재 param
-(Parameter*)getCurrentParam
{
    return currentParam;
}
-(void)setCurrentGroup:(NSMutableDictionary*)group
{
    currentGroup = group;
}
-(void)setCurrentAction:(APIAction*)action
{
    currentAction = action;
}
-(void)setCurrentParam:(Parameter *)param
{
    currentParam = param;
}

//현재 delegate
-(delegateState)getCurrentDelegate
{
    return currentDelegate;
}
-(void)setCurrentDelegate
{
    if(currentDelegate == DELEGATE_RESULT)
        currentDelegate = DELEGATE_HANDLER;
    else
        currentDelegate = DELEGATE_RESULT;
}

-(void)setLoginLabel:(NSString*)Label
{
    loginLabel = Label;
}
-(NSString*)getLoginLabel
{
    return loginLabel;
}
-(void)setServerLabel:(NSString*)Label
{
    serverLabel = Label;
}
-(NSString*)getServerLabel
{
    return serverLabel;
}

-(NSDictionary*)getTempDic
{
    return tempDic;
}



//-----------------------------------------------------------------
// 초기 설정
//-----------------------------------------------------------------

- (void) initialize
{
    dataMain = [[DataManager alloc]init];
    [dataMain makeDatas];
    //initialize
    currentGroup = dataMain.apiGroup[GROUP_NUM_SOCIAL_INITIALIZE];
    //첫번째 action
    currentAction = currentGroup[KEY_ACTIONLIST][0];
    currentDelegate = DELEGATE_HANDLER;
    
    realGroupList = dataMain.apiGroup;
    
    //groupList는 메인에서 쓰는 거니까 initialize, login 제외
    NSMutableArray* list = [[NSMutableArray alloc]init];
    for(int i=0;i<[dataMain.apiGroup count];i++){
        if(i>GROUP_NUM_SNS_LOGIN)
            [list addObject:dataMain.apiGroup[i]];
    }
    
    groupList = list;
    
    //info
    [GET_INFO_CONTROLLER initInfoList];
    
    tempSelect = [[NSMutableDictionary alloc]init];
    selectOK = @NO;

}

//-----------------------------------------------------------------
// 함수 호출
//-----------------------------------------------------------------

- (void) callModuleApi
{
    NSMutableDictionary* optionSelect = [[NSMutableDictionary alloc]init];
    
    for(Parameter *param in currentAction.paramList){
        [optionSelect setObject:param.value forKey:param.name];
    }
    
    switch (currentAction.num) {
        case ACTION_NUM_SOCIAL_INITIALIZE:{
            [GET_INFO_CONTROLLER setInfoData:INFO_APPID_NAME data:optionSelect[PARAM_INIT_APPID]];
            [GET_INFO_CONTROLLER setInfoData:INFO_SERVERID_NAME data:optionSelect[PARAM_INIT_SERVERID]];
            [GET_INFO_CONTROLLER setInfoData:INFO_GAMELANGUAGE_NAME data:optionSelect[PARAM_INIT_GAMELANGUAGE]];
            if(currentDelegate == DELEGATE_RESULT)
                [GET_INFO_CONTROLLER setInfoData:INFO_RESULT_NAME data:@"Delegate"];
            else
                [GET_INFO_CONTROLLER setInfoData:INFO_RESULT_NAME data:@"Handler"];

            [[NSUserDefaults standardUserDefaults] setObject:optionSelect[PARAM_INIT_APPID] forKey:@"HiveSDKSample_AppID"];
            [[NSUserDefaults standardUserDefaults] synchronize];
            
            [self func_SocialInitialize:(NSMutableDictionary*)optionSelect];
        }break;
        
        case ACTION_NUM_SNS_SETGUESTUSERINFO:{
            dispatch_async(dispatch_get_main_queue(), ^{
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:self->currentAction.name message:@"vid#sessionToken" delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:@"호출", nil];
                
                alert.alertViewStyle = UIAlertViewStylePlainTextInput;
                
                alert.tag =2;
                [alert show];
            });

        }break;
            
        case ACTION_NUM_SNS_LOGIN:{
            [self func_SnsLogin:(NSMutableDictionary*)optionSelect];
        }break;
        case ACTION_NUM_SNS_GETLOGINTYPE:{
            [self func_SnsGetLoginType:(NSMutableDictionary*)optionSelect];

        }break;
        case ACTION_NUM_SNS_LOGOUT: {
            [self func_SnsLogout:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_SNS_SELECT: {
            if([selectOK boolValue])
                [self func_SnsSelect:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_SNS_CUSTOMSELECT:{
            if([selectOK boolValue]){
                NSError* error = nil;
                [C2SModuleSns User:@{@"vid":tempSelect[@"usedVid"]} error:&error completionHandler:^(NSDictionary *resultArg,  NSError *resultError) {
                    if(resultError==nil){
                        self->tempSelect[@"hiveId"] = resultArg[@"list"][0][@"nickName"];
                    
                        NSString* selectStr = [NSString stringWithFormat:@"Guest User : %@\n%@ : %@", self->tempSelect[@"currentVid"],self->tempSelect[@"hiveId"],self->tempSelect[@"usedVid"]];
                        dispatch_async(dispatch_get_main_queue(), ^{
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:self->currentAction.name message:selectStr delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:self->tempSelect[@"currentVid"], self->tempSelect[@"usedVid"], nil];
                        
                            alert.tag =1;
                            [alert show];
                        });
                    }
                }];
            }
            
        }break;
            
        case ACTION_NUM_PUSH_REGISTER: {
            [self func_PushRegister:(NSMutableDictionary*)optionSelect];
        }break;
        case ACTION_NUM_PUSH_UNREGISTER: {
            [self func_PushUnregister:(NSMutableDictionary*)optionSelect];
        }break;
        case ACTION_NUM_PUSH_DESCRIPTION: {
            [self func_PushDescription:(NSMutableDictionary*)optionSelect];
        }break;
        
        case ACTION_NUM_SNS_USER:
        case ACTION_NUM_SNS_USER_FB:
        case ACTION_NUM_SNS_USER_MESSAGE: {
            [self func_SnsUser:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_SNS_POST_FB:
        case ACTION_NUM_SNS_POST_GP: {
            [self func_SnsPost:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_PROMOTION_SHOW_NOTICE_FF:
        case ACTION_NUM_PROMOTION_SHOW_NOTICE_FT:
        case ACTION_NUM_PROMOTION_SHOW_EVENT_FF:
        case ACTION_NUM_PROMOTION_SHOW_EVENT_FT:
        case ACTION_NUM_PROMOTION_SHOW_FULLBANNER:
        case ACTION_NUM_PROMOTION_SHOW_OFFERWALL:
        case ACTION_NUM_PROMOTION_SHOW_NOTICEONLY:
        case ACTION_NUM_PROMOTION_SHOW_CUSTOMWEBVIEW:
        case ACTION_NUM_PROMOTION_SHOW_REVIEW:
        case ACTION_NUM_PROMOTION_SHOW_MOREGAMES:
        case ACTION_NUM_PROMOTION_SHOW_REVIEWEX: {
            [self func_PromotionShow:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_PROMOTION_INFO_BADGE_NOTICE:
        case ACTION_NUM_PROMOTION_INFO_BADGE_EVENT:
        case ACTION_NUM_PROMOTION_INFO_BADGE_NOTICEONLY:
        case ACTION_NUM_PROMOTION_INFO_BADGE_CUSTOMWEBVIEW:
        case ACTION_NUM_PROMOTION_INFO_VIEW_NOTICE:
        case ACTION_NUM_PROMOTION_INFO_VIEW_EVENT:
        case ACTION_NUM_PROMOTION_INFO_VIEW_FULLBANNER:
        case ACTION_NUM_PROMOTION_INFO_VIEW_NOTICEONLY:
        case ACTION_NUM_PROMOTION_INFO_VIEW_CUSTOMWEBVIEW: {
            [self func_PromotionInfo:(NSMutableDictionary*)optionSelect];
        }break;
        case ACTION_NUM_PROMOTION_INFO_GETOFFERWALLSTATE: {
            [self func_PromotionGetOfferwallState:(NSMutableDictionary*)optionSelect];
        }break;
		case ACTION_NUM_PROMOTION_INFO_GETBANNERINFO: {
			[self func_PromotionGetBannerInfo:(NSMutableDictionary*)optionSelect];
		}break;
        case ACTION_NUM_PROMOTION_ACQUISITION:
        case ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SAVE:
        case ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SHARE:
        case ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE:
        case ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE:
        case ACTION_NUM_PROMOTION_ACQUISITION_HIVELINK_SHARE:
        case ACTION_NUM_PROMOTION_ACQUISITION_SENDER_INFO:
        {
            [self func_PromotionAcquisition:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_SNS_FRIENDS_HIVE_GAME:
        case ACTION_NUM_SNS_FRIENDS_HIVE_OTHER:
        case ACTION_NUM_SNS_FRIENDS_HIVE_ALL:
        case ACTION_NUM_SNS_FRIENDS_FB_RECEIVEDINVITE:
            //1.10.2b update
        case ACTION_NUM_SNS_FRIENDS_FB_FRIENDSLIST: {
            [self func_SnsFriends:(NSMutableDictionary*)optionSelect];
        }break;
        case ACTION_NUM_SNS_MESSAGE:
        case ACTION_NUM_SNS_MESSAGE_FB_INVITEDIALOG: {
            [self func_SnsMessage:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SNS_SESSION:
        case ACTION_NUM_SNS_SESSIONFB:{
            [self func_SnsSession:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SNS_SHOW_HOME:
        case ACTION_NUM_SNS_SHOW_USER:
        case ACTION_NUM_SNS_SHOW_CAFE:
        case ACTION_NUM_SNS_SHOW_EDIT:
        case ACTION_NUM_SNS_SHOW_FIND:
        case ACTION_NUM_SNS_SHOW_INQUIRY:
        case ACTION_NUM_SNS_SHOW_MESSAGE:
		case ACTION_NUM_SNS_SHOW_CHATBOT:{
            [self func_SnsShow:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_SHOW_TERMS:
        case ACTION_NUM_SOCIAL_SHOW_ADULTAUTH:
        case ACTION_NUM_SOCIAL_SHOW_NOTICE:{
            [self func_SocialShow:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_INFO_NOTICE:
        case ACTION_NUM_SOCIAL_INFO_PERMISSION:{
            [self func_SocialInfo:(NSMutableDictionary *)optionSelect];
        }break;
            
        case ACTION_NUM_TRACKER_SETENABLE: {
            [self func_TrackerSetEnable:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_TRACKER_SENDEVENT:
        case ACTION_NUM_TRACKER_SENDEVENTR:{
            [self func_TrackerSendEvent:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEIAP_POSTBOX:{
            [self func_HiveIAPPostBox:(NSMutableDictionary *)optionSelect];
        }break;
            /*
        case ACTION_NUM_ENGAGEMENT_GETEVENTS:{
            [self func_EngagementGetEvents:(NSMutableDictionary*)optionSelect];

        }break;
             */
        case ACTION_NUM_ENGAGEMENT_CONSUMECOUPON:{
             [self func_EngagementConsumeCoupon:(NSMutableDictionary*)optionSelect];
        }break;
            
        case ACTION_NUM_ENGAGEMENT_READY:{
            [self func_EngagementReady:(NSMutableDictionary *)optionSelect];
        }break;
        //1.12.0 update
        case ACTION_NUM_HIVEPROMOTION_REVIEWEX:
        case ACTION_NUM_HIVEPROMOTION_REVIEW:
        case ACTION_NUM_HIVEPROMOTION_OFFERWALL:
        case ACTION_NUM_HIVEPROMOTION_DIRECT:
        case ACTION_NUM_HIVEPROMOTION_SPOT:
        case ACTION_NUM_HIVEPROMOTION_CUSTOMBOARD:
        case ACTION_NUM_HIVEPROMOTION_CUSTOMVIEW:
        case ACTION_NUM_HIVEPROMOTION_NOTICE:
        case ACTION_NUM_HIVEPROMOTION_BANNER:
        case ACTION_NUM_HIVEPROMOTION_NEWS:{
            [self func_HivePromotionShow:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEPROMOTIONINFO_VIEW_SPOT:
        case ACTION_NUM_HIVEPROMOTIONINFO_VIEW_DIRECT:
        case ACTION_NUM_HIVEPROMOTIONINFO_VIEW_CUSTOMVIEW:
        case ACTION_NUM_HIVEPROMOTIONINFO_VIEW_CUSTOMBOARD:
        case ACTION_NUM_HIVEPROMOTIONINFO_BADGE:{
            [self func_HivePromotionInfo:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEPROMOTIONINFO_SETADDITIONALINFO:{
            [self func_HivePromotionSetAdditionalInfo:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEPROMOTIONINFO_GETOFFERWALLSTATE:{
            [self func_HivePromotionGetOfferwallState:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEPROMOTIONINFO_GETBANNERINFO:{
            [self func_HivePromotionGetBannerInfo:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_HIVEPROMOTIONINFO_UPDATEPROMOTIONINFO:{
            [self func_HivePromotionUpdatePromotionData:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_SETGAMEINFO:{
            [self func_SocialSetGameInfo:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_SETGAMEINFO_SETEMERGENCYMODE:{
            [self func_SocialSetGameInfoSetEmergencyMode:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_GETHIVECOUNTRYCODE:{
            [self func_SocialGetHiveCountryCode:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_GETCHANNEL:{
            [self func_SocialGetChannel:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_SETCHANNEL:{
            [self func_SocialSetChannel:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_SOCIAL_SENDDATA:{
            [self func_SocialSendData:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_ITEMINFO:{
            [self func_InappV4ItemInfo:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_PURCHASE:{
            [self func_InappV4Purchase:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_RESTORE:{
            [self func_InappV4Restore:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_FINISH:{
            [self func_InappV4Finish:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_ALLFINISH:{
            [self func_InappV4AllFinish:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_CHECKPROMOTEPURCHASE: {
            [self func_InappV4CheckPromotePurchase:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_GETSELECTEDMARKET:{
            [self func_InappV4GetSelectedMarket:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_GETACCOUNTUUID:{
            [self func_InappV4GetAccountUuid:(NSMutableDictionary *)optionSelect];
        }break;
        case ACTION_NUM_INAPPV4_POSTBOX:{
            [self func_InappV4PostBox:(NSMutableDictionary *)optionSelect];
        }break;
        default:{} break;
    }

}

//0. No Possible IOS - IOS에서는 지원 안함
-(void)func_NoIOS:(callBackNum)api
{
    NSError* error = [NSError errorWithDomain:@"Sample" code:1 userInfo:@{NSLocalizedDescriptionKey:@"iOS에서는 지원하지 않습니다."}];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:api resultArg:nil resultError:error];
    }
    else
        [self resultDelegateResult:currentAction.name api:api resultArg:nil resultError:error];

}

//-----------------------------------------------------------------
// api 각각 호출
//-----------------------------------------------------------------

//0. completionHandler
-(void)completionHandlerResult:(callBackNum)api resultArg:(NSDictionary *)resultArg resultError:(NSError*)resultError
{
    if(resultError ==nil){
        NSString* dictName = [[NSString alloc] initWithFormat:@"%@ 성공", currentAction.name];
        
        if(api == CB_SOCIAL_INITIALIZE){
            [self setServerLabel:tempInfo];
            [GET_INFO_CONTROLLER setInfoData:INFO_SERVER_NAME data:tempInfo];
        }
        else if (api == CB_SNS_LOGIN){
            [self setLoginLabel:tempInfo];
            [GET_INFO_CONTROLLER setInfoData:INFO_LOGIN_NAME data:tempInfo];
            selectOK = @NO;
        }
        
        [GET_LOG_CONTROLLER setResultLog:dictName];
        
        NSLog(@"Handler:%@\n",resultArg);
        [GET_LOG_CONTROLLER callbackLogSend:currentAction.eName parameter:resultArg result:DELEGATE_HANDLER];
        [DealCallback resultDelegate:api resultArg:(NSDictionary*)resultArg];
    }
    else{
        [GET_LOG_CONTROLLER errorLogSend:resultError name:currentAction.eName result:(int)currentDelegate];
    }
}
//0. resultDelegate
-(void)resultDelegateResult:(NSString*)name api:(callBackNum)api resultArg:(NSDictionary *)resultArg resultError:(NSError*)resultError
{
    if(resultError ==nil){
        NSString* dictName = [[NSString alloc] initWithFormat:@"%@ 성공", name];
        
        if(api == CB_SOCIAL_INITIALIZE){
            [self setServerLabel:tempInfo];
            [GET_INFO_CONTROLLER setInfoData:INFO_SERVER_NAME data:tempInfo];
        }
        else if (api == CB_SNS_LOGIN){
            [self setLoginLabel:tempInfo];
            [GET_INFO_CONTROLLER setInfoData:INFO_LOGIN_NAME data:tempInfo];
            selectOK = @NO;
        }
        
        [GET_LOG_CONTROLLER setResultLog:dictName];
        NSLog(@"ResultDelegate:%@\n",resultArg);
        [GET_LOG_CONTROLLER callbackLogSend:name parameter:resultArg result:DELEGATE_RESULT];
        [DealCallback resultDelegate:api resultArg:(NSDictionary*)resultArg];
    }
    else{
        [GET_LOG_CONTROLLER errorLogSend:resultError name:currentAction.eName result:(int)currentDelegate];
    }
}


//1. Initialize
-(void)func_SocialInitialize:(NSMutableDictionary*)optionSelect {
    
    NSError* error = nil;
    
    //서버
    //NSDictionary* argSns;
    //인앱 상품 등록
    NSDictionary* argInapp;
    //push
    NSDictionary* argPush;
    //promotion
    NSDictionary* argPromotion;
    
    
    //Tracker 초기화 - appid platformsample
//    NSDictionary* MAT = @{TRACK_ADVERTISERID:MAT_ADVERTISERID,
//                          TRACK_CONVERSIONKEY:MAT_CONVERSIONKEY,
//                          TRACK_MATCHING:@{
//                                  TRACK_INSTALL:MAT_INSTALL,
//                                  TRACK_UPDATE:MAT_UPDATE,
//                                  TRACK_PURCHASE:MAT_PURCHASE,
//                                  TRACK_TUTORIALCOMPLETE:MAT_TUTORIALCOMPLETE
//                                  }
//                          };
    
    //Adjust 초기화 - appid misample
    NSDictionary* Adjust = @{TRACK_APPTOKEN:ADJUST_APPTOKEN,
                             TRACK_APPSECRETINFO:@{
                                     TRACK_SECRETID:ADJUST_SECRETID,
                                     TRACK_INFO1:ADJUST_INFO1,
                                     TRACK_INFO2:ADJUST_INFO2,
                                     TRACK_INFO3:ADJUST_INFO3,
                                     TRACK_INFO4:ADJUST_INFO4
                                     },
                             TRACK_MATCHING:@{
                                     TRACK_UPDATE:ADJUST_UPDATE,
                                     TRACK_PURCHASE:ADJUST_PURCHASE,
                                     TRACK_TUTORIALCOMPLETE:ADJUST_TUTORIALCOMPLETION
                                     }
                             };
    
    //Partytrack 초기화 - appid misample(android???)
    NSDictionary* Partytrack = @{TRACK_APPID:PARTY_APPID,
                                 TRACK_APPKEY:PARTY_APPKEY,
                                 TRACK_MATCHING:@{
                                         TRACK_TUTORIALCOMPLETE:PARTY_TUTORIALCOMPLETE
                                         }
                                 };
    
    // Singular update
    
    NSDictionary* Singular = @{TRACK_APIKEY:SINGULAR_APIKEY,
                          TRACK_SECRETKEY:SINGULAR_SECRETKEY,
                          TRACK_MATCHING:@{
                                  TRACK_INSTALL:SINGULAR_INSTALL,
                                  TRACK_UPDATE:SINGULAR_UPDATE,
                                  TRACK_PURCHASE:SINGULAR_PURCHASE,
                                  TRACK_TUTORIALCOMPLETE:SINGULAR_TUTORIALCOMPLETE
                                  }
                          };
    
    // AppsFlyer update
    
    NSDictionary* AppsFlyer = @{TRACK_KEY:APPSFLYER_KEY,
                                TRACK_ITUNESAPPID:APPSFLYER_ITUNESAPPID,
                          TRACK_MATCHING:@{
                                  TRACK_INSTALL:APPSFLYER_INSTALL,
                                  TRACK_UPDATE:APPSFLYER_UPDATE,
                                  TRACK_TUTORIALCOMPLETE:APPSFLYER_TUTORIALCOMPLETE
                                  }
                          };
    
    NSDictionary* argTracking = @{
                                  //INIT_DEBUGMODE : @true,
                                  //INIT_MAT:MAT,
                                  INIT_ADJUST:Adjust,
                                  INIT_PARTYTRACK:Partytrack,
                                  INIT_SINGULAR:Singular,
                                  INIT_APPSFLYER: AppsFlyer
                                  };
    
    
    NSDictionary* argSocialTemp;
    NSMutableDictionary* argSocial = [[NSMutableDictionary alloc]init];
    

    
    if([optionSelect[PARAM_INIT_USESANDBOX] boolValue]){
        tempInfo = KEY_SANDBOXSERVER;
    }
    else if(optionSelect[PARAM_INIT_USEDEVELOP]!=nil){
        if([optionSelect[PARAM_INIT_USEDEVELOP] boolValue]){
            tempInfo = KEY_STAGINGSERVER;
        }
        else
            tempInfo = KEY_LIVESERVER;
    }
    
    NSString* useIAP;
    
    if([optionSelect[PARAM_INIT_USEHIVEIAP] boolValue]){
        argInapp = @{INIT_SHOWLOG:@true};
        useIAP = INIT_HIVEIAP;
    }
    else if([optionSelect[PARAM_INIT_USEINAPPV4] boolValue]){
        argInapp = @{INIT_SHOWLOG:@true};
        useIAP = INIT_INAPPV4;
    }
    else{
        argInapp = @{INIT_SHOWLOG:@true,
                     INIT_PIDLIST:[DataManager getPidList]};
        useIAP = INIT_INAPP;
    }
    
    NSString* usePromotion;
    //1.12.0 - hivePromotion
    if([optionSelect[PARAM_INIT_USEHIVEPROMOTION] boolValue]){
        usePromotion = PARAM_INIT_USEHIVEPROMOTION;
    }
    else{
        usePromotion = PARAM_INIT_PROMOTION;
    }
     
    //push
    argPush = @{INIT_SHOWLOG:@true};
    //promotion
    argPromotion = @{INIT_SHOWLOG:@true};
    
    argSocialTemp = @{
                  PARAM_INIT_SHOWNOTICE:optionSelect[PARAM_INIT_SHOWNOTICE],
                  PARAM_INIT_SHOWLOG:optionSelect[PARAM_INIT_SHOWLOG],
                  PARAM_INIT_USESANDBOX:optionSelect[PARAM_INIT_USESANDBOX],
                  PARAM_INIT_USEDEVELOP:optionSelect[PARAM_INIT_USEDEVELOP],
                  PARAM_INIT_APPID:optionSelect[PARAM_INIT_APPID],
                  PARAM_INIT_SERVERID:optionSelect[PARAM_INIT_SERVERID],
                  PARAM_INIT_GAMELANGUAGE:optionSelect[PARAM_INIT_GAMELANGUAGE],
                  useIAP:argInapp,
                  INIT_PUSH:argPush,
                  usePromotion:argPromotion,
                  INIT_TRACKING:argTracking,
                  PARAM_INIT_SHOWPERMISSIONVIEW:optionSelect[PARAM_INIT_SHOWPERMISSIONVIEW],
                  PARAM_INIT_USE_HERCULES:optionSelect[PARAM_INIT_USE_HERCULES]
                  };
    
    [argSocial setDictionary:argSocialTemp];
    
    // 1.13.0 - timeout Seconds
    if(![optionSelect[PARAM_INIT_TIMEOUTSECONDS] isEqualToString:@""]){
        [argSocial setValue:[NSNumber numberWithInt:[optionSelect[PARAM_INIT_TIMEOUTSECONDS] intValue]] forKey:PARAM_INIT_TIMEOUTSECONDS];
    }
    
    // 1.17.1 - appid 수정
    if([optionSelect[PARAM_INIT_APPID] isEqualToString:@""]){
        [argSocial removeObjectForKey:PARAM_INIT_APPID];
    }

    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:argSocial];

    if(currentDelegate == DELEGATE_HANDLER){
        //initialize 호출
        [C2SModuleSocial Initialize:argSocial error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError){
            [self completionHandlerResult:CB_SOCIAL_INITIALIZE resultArg:resultArg resultError:resultError];
        }];
    }
    else{
        [C2SModuleSocial Initialize:argSocial error:&error];
    }
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}

//1.10.1 추가 (훌라이)
-(void)func_SnsSetGuestUserInfo:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_SNS_SETGUESTUSERINFO resultArg:@{@"return":[C2SModuleSns SetGuestUserInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_SNS_SETGUESTUSERINFO resultArg:@{@"return":[C2SModuleSns SetGuestUserInfo:optionSelect error:&error]?@YES:@NO} resultError:nil];

    
}

//2. Login
-(void)func_SnsLogin:(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    NSMutableDictionary* arg = [[NSMutableDictionary alloc] init];
    
    tempInfo = optionSelect[PARAM_VALUE_TYPE];
    
    if([optionSelect[PARAM_VALUE_TYPE] isEqualToString:PARAM_LOGIN_VALUE_PLATFORM])
        [arg setObject:@"" forKey:PARAM_VALUE_TYPE];
    else
        [arg setObject:@"guest" forKey:PARAM_VALUE_TYPE];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Login:@{PARAM_VALUE_TYPE:arg[PARAM_VALUE_TYPE]} error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError){
            if([resultArg[KEY_TYPE] isEqualToString:PARAM_VALUE_SELECT])
            {
                self->tempSelect[@"currentVid"] = resultArg[PARAM_LOGIN_CURRENTVID];
                self->tempSelect[@"usedVid"] = resultArg[PARAM_LOGIN_USEDVID];
                self->selectOK = @YES;
                
                [self completionHandlerResult:CB_SNS_SELECT resultArg:resultArg resultError:resultError];
            }
            else{
                if([resultArg[KEY_TYPE] isEqualToString:@"guest"])
                    self->tempInfo = PARAM_LOGIN_VALUE_GUEST;
                else
                    self->tempInfo = PARAM_LOGIN_VALUE_PLATFORM;
                
                [self completionHandlerResult:CB_SNS_LOGIN resultArg:resultArg resultError:resultError];
            }
        }];
    }
    else{
        [C2SModuleSns Login:@{PARAM_VALUE_TYPE:arg[PARAM_VALUE_TYPE]} error:&error];
    
    }
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}

-(void)func_InterWorkLogin:(NSDictionary*)resultArg
{
    NSString* resultType = resultArg[KEY_TYPE];
    if([resultType isEqualToString:PARAM_VALUE_SELECT])
    {
        NSString* currentVid = resultArg[PARAM_LOGIN_CURRENTVID];
        NSString* usedVid = resultArg[PARAM_LOGIN_USEDVID];
        
        NSDictionary* currentUserData = @{@"Name":@"Guest User",
                                          @"Level":@"1",
                                          @"Gold":@"0G",
                                          @"Cash":@"0C"};
        NSDictionary* usedUserData = @{@"Name":@"Hive User",
                                       @"Level":@"10",
                                       @"Gold":@"1000G",
                                       @"Cash":@"100C"};
        
        NSError* error1;
        
        NSDictionary* arg2 = @{KEY_TYPE:PARAM_VALUE_SELECT,
                               PARAM_LOGIN_CURRENTVIDDATA:@{PARAM_VALUE_VID:currentVid,PARAM_VALUE_DATA:currentUserData},
                               PARAM_LOGIN_USEDVIDDATA:@{PARAM_VALUE_VID:usedVid,PARAM_VALUE_DATA:usedUserData}};
        
        [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg2];
        
        if(currentDelegate == DELEGATE_HANDLER){
            [C2SModuleSns Login:arg2 error:&error1 completionHandler:^(NSDictionary *selectResultArg, NSError *selectResultError) {
                [self completionHandlerResult:CB_SNS_LOGIN resultArg:selectResultArg resultError:selectResultError];
            }];
        }
        else
            [C2SModuleSns Login:arg2 error:&error1];
    }
    
}

-(void)func_SnsSelect:(NSMutableDictionary*)optionSelect
{
    NSString* currentVid = tempSelect[@"currentVid"];
    NSString* usedVid = tempSelect[@"usedVid"];
    
    NSDictionary* currentUserData = @{@"Name":@"Guest User",
                                      @"Level":@"1",
                                      @"Gold":@"0G",
                                      @"Cash":@"0C"};
    NSDictionary* usedUserData = @{@"Name":@"Hive User",
                                   @"Level":@"10",
                                   @"Gold":@"1000G",
                                   @"Cash":@"100C"};
    
    optionSelect[PARAM_LOGIN_CURRENTVIDDATA] = @{PARAM_VALUE_VID:currentVid,PARAM_VALUE_DATA:currentUserData};
    optionSelect[PARAM_LOGIN_USEDVIDDATA] = @{PARAM_VALUE_VID:usedVid,PARAM_VALUE_DATA:usedUserData};
    
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Login:optionSelect error:&error completionHandler:^(NSDictionary *selectResultArg, NSError *selectResultError) {
            [self completionHandlerResult:CB_SNS_LOGIN resultArg:selectResultArg resultError:selectResultError];
        }];
    }
    else
        [C2SModuleSns Login:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SnsCustomSelect:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    [tempSelect removeObjectForKey:@"selectVid"];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Login:optionSelect error:&error completionHandler:^(NSDictionary *selectResultArg, NSError *selectResultError) {
            [self completionHandlerResult:CB_SNS_LOGIN resultArg:selectResultArg resultError:selectResultError];
        }];
    }
    else
        [C2SModuleSns Login:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}


-(void)func_SnsGetLoginType:(NSMutableDictionary*)optionSelect {
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_SNS_GETLOGINTYPE resultArg:@{@"return":[C2SModuleSns GetLoginType]} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_SNS_GETLOGINTYPE resultArg:@{@"return":[C2SModuleSns GetLoginType]} resultError:nil];
}

-(void)func_SnsLogout:(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Logout:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_LOGOUT resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Logout:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)removeCookie{ }

//3. Local Push
-(void)func_PushRegister :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;

    [optionSelect setObject:[NSNumber numberWithInt:[optionSelect[PARAM_PUSH_PUSHID] intValue]] forKey:PARAM_PUSH_PUSHID];
    [optionSelect setObject:[NSNumber numberWithInt:[optionSelect[PARAM_PUSH_AFTER] intValue]] forKey:PARAM_PUSH_AFTER];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];

    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModulePush Register:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError){
            [self completionHandlerResult:CB_PUSH_REGISTER resultArg:resultArg resultError:resultError];
        }];
    }
    else{
        [C2SModulePush Register:optionSelect error:&error];
    }
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_PushUnregister :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;

    NSArray* arr = [optionSelect[PARAM_PUSH_PUSHID] componentsSeparatedByString:@","];
    NSMutableArray* arrInt = [[NSMutableArray alloc]init];
    for(NSString* str in arr)
        [arrInt addObject: [NSNumber numberWithInt:[str intValue]]];
    
    NSDictionary* arg = @{PARAM_PUSH_PUSHID:arrInt};

    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModulePush Unregister: arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError){
            [self completionHandlerResult:CB_PUSH_UNREGISTER resultArg:resultArg resultError:resultError];
        }];
    }
    else{
        [C2SModulePush Unregister:arg error:&error];
    }

    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//4. Push Description
-(void)func_PushDescription :(NSMutableDictionary*)optionSelect {
    
    NSError* error = nil;
    
    NSMutableDictionary* arg = [[NSMutableDictionary alloc]init];
    
    if(![optionSelect[PARAM_PUSH_USENOTICE] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:[NSNumber numberWithBool:[optionSelect[PARAM_PUSH_USENOTICE] intValue]] forKey:PARAM_PUSH_USENOTICE];
    if(![optionSelect[PARAM_PUSH_USENIGHT] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:[NSNumber numberWithBool:[optionSelect[PARAM_PUSH_USENIGHT] intValue]] forKey:PARAM_PUSH_USENIGHT];
    if(![optionSelect[PARAM_PUSH_OPERATIONREMOTE] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:[NSNumber numberWithBool:[optionSelect[PARAM_PUSH_OPERATIONREMOTE] intValue]] forKey:PARAM_PUSH_OPERATIONREMOTE];
    if(![optionSelect[PARAM_PUSH_OPERATIONLOCAL] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:[NSNumber numberWithBool:[optionSelect[PARAM_PUSH_OPERATIONLOCAL] intValue]] forKey:PARAM_PUSH_OPERATIONLOCAL];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModulePush Description:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_PUSH_DESCRIPTION resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModulePush Description:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//5. User Info
-(void)func_SnsUser :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    NSMutableDictionary* arg = [[NSMutableDictionary alloc]init];
    
    if([optionSelect[PARAM_VALUE_TYPE] isEqualToString:PARAM_VALUE_NA]){
        NSArray* arr = [optionSelect[PARAM_VALUE_VID] componentsSeparatedByString:@","];

        if([arr[0] isEqualToString:@""])
            arg=nil;
        else{
            [arg setObject:arr forKey:PARAM_VALUE_VID];
            //[dic setObject:optionSelect[PARAM_VALUE_TYPE] forKey:PARAM_VALUE_TYPE];
        }
    }
    else{
        [arg setObject:optionSelect[PARAM_VALUE_TYPE] forKey:PARAM_VALUE_TYPE];
        
        if(![optionSelect[PARAM_USER_FACEBOOKID] isEqualToString:@""] && optionSelect[PARAM_USER_FACEBOOKID])
            [arg setObject:optionSelect[PARAM_USER_FACEBOOKID] forKey:PARAM_USER_FACEBOOKID];
    }
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns User:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_USER resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns User:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//6. Sns Post
-(void)func_SnsPost :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    NSMutableDictionary* arg= [[NSMutableDictionary alloc]init];
    
    [arg setObject:optionSelect[PARAM_VALUE_SERVICE] forKey:PARAM_VALUE_SERVICE];
    
    if([optionSelect[PARAM_VALUE_SERVICE] isEqualToString:PARAM_VALUE_FACEBOOK]){
        [arg setObject:optionSelect[PARAM_POST_APPLINKURL] forKey:PARAM_POST_APPLINKURL];
    }
    else{
        [arg setObject:optionSelect[PARAM_POST_MESSAGE] forKey:PARAM_POST_MESSAGE];
    }

    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Post:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_POST resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Post:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//7. Promotion
-(void)func_PromotionShow :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    NSDictionary* arg;
    
    switch (currentAction.num) {
        case ACTION_NUM_PROMOTION_SHOW_MOREGAMES:{
            [self func_NoIOS:CB_PROMOTION_SHOW];
            return;
        }break;
        case ACTION_NUM_PROMOTION_SHOW_EVENT_FF:
        case ACTION_NUM_PROMOTION_SHOW_EVENT_FT:
        case ACTION_NUM_PROMOTION_SHOW_NOTICE_FF:
        case ACTION_NUM_PROMOTION_SHOW_NOTICE_FT:{
            arg = @{PARAM_VALUE_TYPE:optionSelect[PARAM_VALUE_TYPE],
                    PARAM_PROMOTION_FORCED:optionSelect[PARAM_PROMOTION_FORCED],
                    PARAM_PROMOTION_ADDITIONALINFO:optionSelect[PARAM_PROMOTION_ADDITIONALINFO]
                    };
        }break;
        case ACTION_NUM_PROMOTION_SHOW_CUSTOMWEBVIEW:{
            arg = @{PARAM_VALUE_TYPE:optionSelect[PARAM_VALUE_TYPE],
                    PARAM_PROMOTION_VIEWID:[NSNumber numberWithInt:[optionSelect[PARAM_PROMOTION_VIEWID]intValue]],
                    PARAM_PROMOTION_ADDITIONALINFO:optionSelect[PARAM_PROMOTION_ADDITIONALINFO]
                    };
        }break;
        case ACTION_NUM_PROMOTION_SHOW_REVIEW:
        case ACTION_NUM_PROMOTION_SHOW_REVIEWEX:{
            arg = @{PARAM_VALUE_TYPE:optionSelect[PARAM_VALUE_TYPE]
                    };
        }break;
        default:{
            arg = @{PARAM_VALUE_TYPE:optionSelect[PARAM_VALUE_TYPE],
                    PARAM_PROMOTION_ADDITIONALINFO:optionSelect[PARAM_PROMOTION_ADDITIONALINFO]
                    };
        }break;
    }

    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModulePromotion Show:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_PROMOTION_SHOW resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModulePromotion Show:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}
-(void)func_PromotionInfo :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    //NSMutableDictionary* arg=[[NSMutableDictionary alloc]init];
    
    
    if(currentAction.num == ACTION_NUM_PROMOTION_INFO_BADGE_CUSTOMWEBVIEW || currentAction.num == ACTION_NUM_PROMOTION_INFO_VIEW_CUSTOMWEBVIEW)
        [optionSelect setObject:[NSNumber numberWithInt:[optionSelect[PARAM_PROMOTION_VIEWID] intValue]] forKey:PARAM_PROMOTION_VIEWID];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModulePromotion Info:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_PROMOTION_INFO resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModulePromotion Info:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}
-(void)func_PromotionGetOfferwallState:(NSMutableDictionary*)optionSelect {
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];

    [self func_NoIOS:CB_PROMOTION_GETOFFERWALLSTATE];
}

-(void)func_PromotionGetBannerInfo:(NSMutableDictionary *)optionSelect{
    NSError* error = nil;
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
	
	if(currentDelegate == DELEGATE_HANDLER) {
		[C2SModulePromotion GetBannerInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
			[self completionHandlerResult:CB_PROMOTION_GETBANNERINFO resultArg:resultArg resultError:resultError];
		}];
	} else {
		[C2SModulePromotion GetBannerInfo:optionSelect error:&error];
	}
	
	if (error != nil) {
		[GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
	}
	
}
//1.9.0
-(void)func_PromotionAcquisition:(NSMutableDictionary*)optionSelect{
    NSError* error = nil;
    
    NSMutableDictionary* arg = [[NSMutableDictionary alloc]init];
    
    if(currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION){
        //1.13.0 update
        [arg setObject:optionSelect[PARAM_ACQUISITION_ADDITIONALINFO] forKey:PARAM_ACQUISITION_ADDITIONALINFO];
        
        [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];
        if(currentDelegate == DELEGATE_HANDLER){
            [C2SModulePromotion Acquisition:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
                [self completionHandlerResult:CB_PROMOTION_ACQUISITION resultArg:resultArg resultError:resultError];

                if(resultError==nil){
                    dispatch_async(dispatch_get_main_queue(), ^{
                        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:self->currentAction.name message:nil delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:@"Link 보기",@"Stage 캠페인 보기", @"Each 캠페인 보기", nil];
                        
                         //qrcode 파싱
                         NSData* qrcode = [self hexadecialStringToData:resultArg[PARAM_PROMOTION_QRCODE]];
                        
                         UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                         imageView.contentMode = UIViewContentModeCenter;
                         imageView.image = [UIImage imageWithData:qrcode];
                         
                         if (floor(NSFoundationVersionNumber) > NSFoundationVersionNumber_iOS_6_1) {
                             [alert setValue:imageView forKey:@"accessoryView"];
                         }else{
                             [alert addSubview:imageView];
                         }
                        
                        alert.tag = 0;
                        [alert show];
                    });
                    self->tempData = resultArg;
                }
            }];
        }
        else
            [C2SModulePromotion Acquisition:arg error:&error];
        
    }
    else{
        [C2SModulePromotion Acquisition:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            if(resultError==nil){
                
                /*
                NSError* error2;
                NSMutableDictionary* arg_ = [[NSMutableDictionary alloc]init];

                NSString* message=nil;
            
                if(currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE)
                    message = resultArg[PARAM_PROMOTION_INVITECOMMONLINK];
            
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:currentAction.name message:message delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:currentAction.name, nil];
                 
                //link 공유
                if(currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE){
                    [arg_ setObject:PARAM_PROMOTION_LINKSHARE forKey:PARAM_VALUE_TYPE];
                    [arg_ setObject:resultArg[PARAM_PROMOTION_INVITECOMMONLINK] forKey:PARAM_VALUE_URL];
                
                    alert.tag = 1;
                    [alert show];
                }
                //qrcode
                else{
                    if(currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SAVE){
                        [arg_ setObject:PARAM_PROMOTION_QRCODESAVE forKey:PARAM_VALUE_TYPE];
                        [arg_ setObject:resultArg[PARAM_PROMOTION_QRCODE] forKey:PARAM_VALUE_DATA];
                        alert.tag=2;
                    }
                    else{
                        [arg_ setObject:PARAM_PROMOTION_QRCODESHARE forKey:PARAM_VALUE_TYPE];
                        [arg_ setObject:resultArg[PARAM_PROMOTION_QRCODE] forKey:PARAM_VALUE_DATA];
                        alert.tag=3;
                    }
                    //qrcode 파싱
                    NSData* qrcode = [self hexadecialStringToData:resultArg[PARAM_PROMOTION_QRCODE]];
                
                    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                    imageView.contentMode = UIViewContentModeCenter;
                    imageView.image = [UIImage imageWithData:qrcode];
                
                    if (floor(NSFoundationVersionNumber) > NSFoundationVersionNumber_iOS_6_1) {
                        [alert setValue:imageView forKey:@"accessoryView"];
                    }else{
                        [alert addSubview:imageView];
                    }
                    [alert show];
                }

                tempData = arg_;
                */

                
                NSError* error2;
                NSMutableDictionary* arg_ = [[NSMutableDictionary alloc]init];
                
                
                if(self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_HIVELINK_SHARE){
                    optionSelect[PARAM_PROMOTION_LINKSHAREURL] = resultArg[@"inviteHivemsgLink"];
                    [self func_SnsMessage:optionSelect];
                }
                else{
                    if(self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE || self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE){
                        [arg_ setObject:PARAM_PROMOTION_LINKSHARE forKey:PARAM_VALUE_TYPE];
                        [arg_ setObject:resultArg[PARAM_PROMOTION_INVITECOMMONLINK] forKey:PARAM_VALUE_URL];
                        //1.10.3 update
                        if(self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE)
                            [arg_ setObject:optionSelect[PARAM_VALUE_MESSAGE] forKey:PARAM_VALUE_MESSAGE];
                        optionSelect[PARAM_VALUE_URL] = resultArg[@"inviteCommonLink"];

                    }
                    //qrcode
                    else if (self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SAVE || self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SHARE){
                        optionSelect[PARAM_VALUE_DATA] = resultArg[@"qrcode"];
                        if(self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SAVE){
                            dispatch_async(dispatch_get_main_queue(), ^{
                                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:self->currentAction.name message:nil delegate:self    cancelButtonTitle:@"닫기" otherButtonTitles:nil, nil];
                                [alert show];
                            });
                        
                            [arg_ setObject:PARAM_PROMOTION_QRCODESAVE forKey:PARAM_VALUE_TYPE];
                            [arg_ setObject:resultArg[PARAM_PROMOTION_QRCODE] forKey:PARAM_VALUE_DATA];
                        }
                        else{
                            [arg_ setObject:PARAM_PROMOTION_QRCODESHARE forKey:PARAM_VALUE_TYPE];
                            [arg_ setObject:resultArg[PARAM_PROMOTION_QRCODE] forKey:PARAM_VALUE_DATA];
                        }
                    }
                    // 초대자 정보 획득
                    else if (self->currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_SENDER_INFO) {
                        [arg_ setObject:PARAM_PROMOTION_SENDER_INFO forKey:PARAM_VALUE_TYPE];
                    }
                
                    [GET_LOG_CONTROLLER requestLogSend:self->currentAction.eName parameter:arg_];
                
                    if(self->currentDelegate == DELEGATE_HANDLER){
                        [C2SModulePromotion Acquisition:arg_ error:&error2 completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
                            [self completionHandlerResult:CB_PROMOTION_ACQUISITION resultArg:resultArg resultError:resultError];
                        }];
                    }
                    else
                        [C2SModulePromotion Acquisition:arg_ error:&error2];
                    
                }
            }
        }];
    }
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

- (NSData*)hexadecialStringToData : (NSString*)command
{
    command = [command stringByReplacingOccurrencesOfString:@" " withString:@""];
    NSMutableData *commandToSend= [[NSMutableData alloc] init];
    unsigned char whole_byte;
    char byte_chars[3] = {'\0','\0','\0'};
    int i;
    for (i=0; i < [command length]/2; i++) {
        byte_chars[0] = [command characterAtIndex:i*2];
        byte_chars[1] = [command characterAtIndex:i*2+1];
        whole_byte = strtol(byte_chars, NULL, 16);
        [commandToSend appendBytes:&whole_byte length:1];
    }
    
    return commandToSend;
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    
    if (alertView.tag>0) {
        
    }
    else if(alertView.tag==0){
        switch (buttonIndex) {
            case 1:{
                NSString* linkString = [NSString stringWithFormat:@"inviteCommonLink : \n%@\ninviteHivemsgLink : \n%@", tempData[@"inviteCommonLink"],tempData[@"inviteHivemsgLink"]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Link 보기" message:linkString delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:nil, nil];
                    [alert show];
                });
            }
                break;
            case 2:{
                dispatch_async(dispatch_get_main_queue(), ^{
                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Stage 캠페인 보기" message:nil delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:nil, nil];
                    
                    for (NSDictionary *campaigns in self->tempData[@"stageCampaigns"]) {
                        [alert addButtonWithTitle:campaigns[@"title"]];
                    }
                    
                    alert.tag = -1;
                    [alert show];
                });
            }
                break;
            case 3:{
                dispatch_async(dispatch_get_main_queue(), ^{
                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Each 캠페인 보기" message:nil delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:nil, nil];
                    
                    for (NSDictionary *campaigns in self->tempData[@"eachCampaigns"]) {
                        [alert addButtonWithTitle:campaigns[@"title"]];
                    }
                    
                    alert.tag = -2;
                    [alert show];
                });
            }
                break;
            default:
                break;
        }
    
    }
    else if(alertView.tag<0)
    {
        switch (buttonIndex) {
            case 0:{
            }break;
            default:{
                NSDictionary* campaigns;
        
                if(alertView.tag == -1)
                    campaigns = tempData[@"stageCampaigns"][buttonIndex-1];
                else
                    campaigns = tempData[@"eachCampaigns"][buttonIndex-1];
                
                NSString *campaignMessage = [NSString stringWithFormat:@"Count : %@\nLimit : %@\nOrder : %@\nDesc : %@\nItem : %@", campaigns[@"count"], campaigns[@"limit"], campaigns[@"order"], campaigns[@"desc"], campaigns[@"item"]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:campaigns[@"title"]
                                                            message:campaignMessage delegate:self cancelButtonTitle:@"닫기" otherButtonTitles:nil];
                    
                    /*
                    //img 파싱
                    NSData* img = [NSData dataWithContentsOfURL:[NSURL URLWithString:campaigns[@"imgURL"]]];
                    
                    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                    imageView.contentMode = UIViewContentModeCenter;
                    imageView.image = [UIImage imageWithData:img];
                    
                    if (floor(NSFoundationVersionNumber) > NSFoundationVersionNumber_iOS_6_1) {
                        [alert setValue:imageView forKey:@"accessoryView"];
                    }else{
                        [alert addSubview:imageView];
                    }
                     */
                    
                    [alert show];
                });
            }break;
        }
    }
}

- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex
{
    if (alertView.tag>0) {
        //1.10.1 customSelect
        if(alertView.tag==1){
            if(buttonIndex==1)
                tempSelect[@"selectVid"] = tempSelect[@"currentVid"];
            else if (buttonIndex==2)
                tempSelect[@"selectVid"] = tempSelect[@"usedVid"];
            
            if(nil!=tempSelect[@"selectVid"])
                [self func_SnsCustomSelect:@{PARAM_VALUE_TYPE:PARAM_LOGIN_VALUE_CUSTOMSELECT, PARAM_LOGIN_SELECTVID:tempSelect[@"selectVid"]}.mutableCopy];
        }
        //1.10.1 SetGuestUserInfo
        else if(alertView.tag ==2){
            if(buttonIndex==1){
                
                NSMutableDictionary* optionSelect = [[NSMutableDictionary alloc]init];
                
                UITextField* vidSessionToken = [alertView textFieldAtIndex:0];
                
                NSArray* strArray = [vidSessionToken.text componentsSeparatedByString:@"#"];
                
                optionSelect[PARAM_GUESTVID] = strArray[0];
                if(strArray.count>1)
                    optionSelect[PARAM_GUESTSESSIONTOKEN] = strArray[1];
                
                
                [self func_SnsSetGuestUserInfo:(NSMutableDictionary*)optionSelect];
            
            }
        }
    }
}

//8. Invite Friend
-(void)func_SnsFriends :(NSMutableDictionary*)optionSelect {
    
    NSMutableDictionary* arg = [[NSMutableDictionary alloc] init];
    NSError* error = nil;
        
    if(![optionSelect[PARAM_VALUE_SERVICE] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:optionSelect[PARAM_VALUE_SERVICE] forKey:PARAM_VALUE_SERVICE];
    if(![optionSelect[PARAM_VALUE_TYPE] isEqualToString:PARAM_VALUE_NA])
        [arg setObject:optionSelect[PARAM_VALUE_TYPE] forKey:PARAM_VALUE_TYPE];
    
    if([optionSelect[PARAM_VALUE_TYPE] isEqualToString:PARAM_FRIENDS_RECEIVEDINVITE])
        [arg setObject:[NSNumber numberWithInt:[optionSelect[PARAM_FRIENDS_LIMIT] intValue]] forKey:PARAM_FRIENDS_LIMIT];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Friends:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_FRIENDS resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Friends:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SnsMessage :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    NSMutableDictionary* arg= [[NSMutableDictionary alloc]init];

    if(![optionSelect[PARAM_VALUE_SERVICE] isEqualToString :PARAM_VALUE_FACEBOOK]){
        NSArray* arrVid = [optionSelect[PARAM_VALUE_VID] componentsSeparatedByString:@","];
    
        arg[PARAM_MESSAGE_INVITE] = optionSelect[PARAM_MESSAGE_INVITE];
        arg[PARAM_MESSAGE_THUMBNAILURL] = optionSelect[PARAM_MESSAGE_THUMBNAILURL];
        arg[PARAM_MESSAGE_MESSAGE] = optionSelect[PARAM_MESSAGE_MESSAGE];
        arg[PARAM_MESSAGE_IMAGEURL] = optionSelect[PARAM_MESSAGE_IMAGEURL];
        arg[PARAM_MESSAGE_USEPUSH] = optionSelect[PARAM_MESSAGE_USEPUSH];
        
        if(currentAction.num == ACTION_NUM_PROMOTION_ACQUISITION_HIVELINK_SHARE){
            arg[PARAM_PROMOTION_LINKSHARE] = optionSelect[PARAM_PROMOTION_LINKSHARE];
            arg[PARAM_PROMOTION_LINKSHAREURL] = optionSelect[PARAM_PROMOTION_LINKSHAREURL];
        }
        
        if([arrVid[0] isEqualToString:PARAM_VALUE_BLANK])
            arg[optionSelect[PARAM_MESSAGE_VIDORUID]] = @[@"0"];
        else
            arg[optionSelect[PARAM_MESSAGE_VIDORUID]] = arrVid;
        
        if([arg[optionSelect[PARAM_MESSAGE_VIDORUID]][0] isEqualToString:@"0"]){
            if([optionSelect[PARAM_MESSAGE_VIDORUID] isEqualToString:PARAM_VALUE_VID]){
                if([serverLabel isEqualToString:KEY_LIVESERVER])
                    arg[PARAM_VALUE_VID] = @"62360491";
                else if([serverLabel isEqualToString:KEY_STAGINGSERVER])
                    arg[PARAM_VALUE_VID] = @"9619";
                else if([serverLabel isEqualToString:KEY_SANDBOXSERVER])
                    arg[PARAM_VALUE_VID] = @"40073329";
            }
            else{
                if([serverLabel isEqualToString:KEY_LIVESERVER])
                    arg[PARAM_VALUE_UID] = @"172945352";
                else if([serverLabel isEqualToString:KEY_STAGINGSERVER])
                    arg[PARAM_VALUE_UID] = @"64647753";
                else if([serverLabel isEqualToString:KEY_SANDBOXSERVER])
                    arg[PARAM_VALUE_UID] = @"60";
            }
        }
    }
    else{
        arg[PARAM_VALUE_SERVICE] = optionSelect[PARAM_VALUE_SERVICE];
        arg[PARAM_VALUE_TYPE] = optionSelect[PARAM_VALUE_TYPE];
        arg[PARAM_MESSAGE_MESSAGE] = optionSelect[PARAM_MESSAGE_MESSAGE];
    }
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Message:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_MESSAGE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Message:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}
-(void)func_SnsSession :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    NSMutableDictionary* arg = [[NSMutableDictionary alloc] init];
    
    if([optionSelect[PARAM_VALUE_SERVICE] isEqualToString:PARAM_VALUE_NA])
        arg = nil;
    else
        [arg setObject:optionSelect[PARAM_VALUE_SERVICE] forKey:PARAM_VALUE_SERVICE];
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:arg];

    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Session:arg error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_SESSION resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Session:arg error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//11. SNS Webview
-(void)func_SnsShow :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];

    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSns Show:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SNS_SHOW resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSns Show:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}

//12. Terms + adult + socialShow/info
-(void)func_SocialShow:(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];

    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSocial Show:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SOCIAL_SHOW resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSocial Show:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SocialInfo:(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSocial Info:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SOCIAL_INFO resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSocial Info:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//13. Marketing Tracking
-(void)func_TrackerSetEnable :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_TRACKER_SETENABLE resultArg:@{@"return":[C2SModuleTracker SetEnable:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_TRACKER_SETENABLE resultArg:@{@"return":[C2SModuleTracker SetEnable:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_TrackerSendEvent :(NSMutableDictionary*)optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_TRACKER_SENDEVENT resultArg:@{@"return":[C2SModuleTracker SendEvent:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_TRACKER_SENDEVENT resultArg:@{@"return":[C2SModuleTracker SendEvent:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//14. HiveIAP

//POST BOX!!!!
-(void)func_HiveIAPPostBox :(NSMutableDictionary*)optionSelect{
    [GET_POSTBOX_ACTIONCONTROLLER callThePostBox:true];
}


//15. Engagement
/*
-(void)func_EngagementGetEvents :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleEngagement GetEvents:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_ENGAGEMENT_GETEVENTS resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleEngagement GetEvents:optionSelect error:&error];
}
*/
-(void)func_EngagementConsumeCoupon :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleEngagement ConsumeCoupon:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_ENGAGEMENT_CONSUMECOUPON resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleEngagement ConsumeCoupon:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}

-(void)func_EngagementReady:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_ENGAGEMENT_READY resultArg:@{@"return":[C2SModuleEngagement SetReady:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_ENGAGEMENT_READY resultArg:@{@"return":[C2SModuleEngagement SetReady:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//16. HIVE Promotion
-(void)func_HivePromotionShow :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;

    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleHivePromotion Show:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_HIVEPROMOTION_SHOW resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleHivePromotion Show:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];

}
-(void)func_HivePromotionInfo :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleHivePromotion Info:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_HIVEPROMOTION_INFO resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleHivePromotion Info:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_HivePromotionSetAdditionalInfo :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_HIVEPROMOTION_SETADDITIONALINFO resultArg:@{@"return":[C2SModuleHivePromotion SetAdditionalInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_HIVEPROMOTION_SETADDITIONALINFO resultArg:@{@"return":[C2SModuleHivePromotion SetAdditionalInfo:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_HivePromotionGetOfferwallState :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleHivePromotion GetOfferwallState:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_HIVEPROMOTION_GETOFFERWALLSTATE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleHivePromotion GetOfferwallState:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_HivePromotionGetBannerInfo:(NSMutableDictionary *)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if (currentDelegate == DELEGATE_HANDLER) {
        [C2SModuleHivePromotion GetBannerInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_HIVEPROMOTION_GETBANNERINFO resultArg:resultArg resultError:resultError];
        }];
    } else {
        [C2SModuleHivePromotion GetBannerInfo:optionSelect error:&error];
    }
    
    if (error !=nil) {
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
    }
}

-(void)func_HivePromotionUpdatePromotionData :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
//    if(currentDelegate == DELEGATE_HANDLER){
//        [self completionHandlerResult:CB_HIVEPROMOTION_UPDATEPROMOTIONDATA resultArg:@{@"return":[C2SModuleHivePromotion UpdatePromotionData:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
//    }
//    else
//        [self resultDelegateResult:currentAction.name api:CB_HIVEPROMOTION_UPDATEPROMOTIONDATA resultArg:@{@"return":[C2SModuleHivePromotion UpdatePromotionData:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

// 17. SetGameInfo
-(void)func_SocialSetGameInfo :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_SOCIAL_SETGAMEINFO resultArg:@{@"return":[C2SModuleSocial SetGameInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO, PARAM_INIT_SERVERID:optionSelect[PARAM_INIT_SERVERID], PARAM_INIT_GAMELANGUAGE:optionSelect[PARAM_INIT_GAMELANGUAGE],  PARAM_INIT_CHANNEL:optionSelect[PARAM_INIT_CHANNEL]} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_SOCIAL_SETGAMEINFO resultArg:@{@"return":[C2SModuleSocial SetGameInfo:optionSelect error:&error]?@YES:@NO, PARAM_INIT_SERVERID:optionSelect[PARAM_INIT_SERVERID], PARAM_INIT_GAMELANGUAGE:optionSelect[PARAM_INIT_GAMELANGUAGE], PARAM_INIT_CHANNEL:optionSelect[PARAM_INIT_CHANNEL]} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SocialSetGameInfoSetEmergencyMode:(NSMutableDictionary *)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];

    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleSocial SetGameInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_SOCIAL_SETGAMEINFO resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleSocial SetGameInfo:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SocialGetHiveCountryCode :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_ETC resultArg:@{@"return":[C2SModuleSocial GetHiveCountry]} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_ETC resultArg:@{@"return":[C2SModuleSocial GetHiveCountry]} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SocialSetChannel :(NSMutableDictionary *)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER) {
        [self resultDelegateResult:currentAction.name api:CB_SOCIAL_SETCHANNEL resultArg:@{@"return":[C2SModuleSocial SetChannel:optionSelect error:&error]?@YES:@NO, PARAM_INIT_CHANNEL:optionSelect[PARAM_INIT_CHANNEL]} resultError:nil];
    }
}

-(void)func_SocialGetChannel :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_ETC resultArg:@{@"return":[C2SModuleSocial GetChannel]} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_ETC resultArg:@{@"return":[C2SModuleSocial GetChannel]} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)func_SocialSendData :(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [self completionHandlerResult:CB_ETC resultArg:@{@"return":[C2SModuleSocial SendData:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {}]?@YES:@NO} resultError:nil];
    }
    else
        [self resultDelegateResult:currentAction.name api:CB_ETC resultArg:@{@"return":[C2SModuleSocial SendData:optionSelect error:&error]?@YES:@NO} resultError:nil];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

//18. InappV4
-(void)func_InappV4ItemInfo :(NSMutableDictionary*)optionSelect{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 ItemInfo:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            self->tempDic = resultArg.mutableCopy;
            [self completionHandlerResult:CB_INAPPV4_ITEMINFO resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 ItemInfo:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_InappV4Purchase :(NSMutableDictionary*)optionSelect{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 Purchase:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            if(resultError == nil && resultArg[@"receipt"])
                [self refreshReceiptList:@[resultArg[@"receipt"]]];
            [self completionHandlerResult:CB_INAPPV4_PURCHASE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 Purchase:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_InappV4Restore :(NSMutableDictionary*)optionSelect{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 Restore:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            if(resultError == nil && resultArg[@"receiptList"])
                [self refreshReceiptList:resultArg[@"receiptList"]];
            [self completionHandlerResult:CB_INAPPV4_RESTORE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 Restore:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void)refreshReceiptList:(NSArray*)dict {
    // pid 파라미터 설정해주기
    
    [receiptList removeAllObjects];
    
    for(NSDictionary* receipt in dict)
        [receiptList setObject:receipt forKey:receipt[@"product"][@"marketPid"]];
    
    NSArray* actionList = [GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST];
    for (APIAction* action in actionList) {
        if(action.num == ACTION_NUM_INAPPV4_FINISH || action.num == ACTION_NUM_INAPPV4_ALLFINISH){
            for(Parameter* para in action.paramList){
                if([para.name isEqualToString:PARAM_INAPPV4_PID]){
                    para.value = receiptList.allKeys[0];
                    para.selectList = receiptList.allKeys;
                    break;
                }
            }
        }
    }
}

-(void)func_InappV4Finish :(NSMutableDictionary*)optionSelect{
    // 영수증 검증!
    NSDictionary* receipt = receiptList[optionSelect[@"pid"]];

    if(receipt){
        BOOL isSub = [receipt[@"product"][@"productType"] isEqualToString:PARAM_INAPPV4_SUBSCRIPTION];
        
        [GET_LOG_CONTROLLER requestLogSend:@"Request Verify" parameter:optionSelect];

        [GET_POSTBOX_ACTIONCONTROLLER postBoxIapVerify:receipt[@"bypassInfo"] isSub:isSub completionHandler:^(NSString *pid) {
            if(pid!=nil && ![pid isEqualToString:@""] && !isSub)
                [self finishProduct:@{@"pid":pid, @"isPurchaseSuccess":@YES}];
            else{
                NSLog(@"finishIapVerifyProcess error");
                [self finishProduct:@{@"pid":optionSelect[@"pid"], @"isPurchaseSuccess":@NO}];
            }
        }];
        if(isSub)
            [self finishProduct:@{@"pid":optionSelect[@"pid"], @"isPurchaseSuccess":@YES}];
    } else {
        [GET_LOG_CONTROLLER requestLogSend:@"Not Exist pid receipt" parameter:optionSelect];
    }
}

-(void) finishProduct:optionSelect {
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 TransactionFinish:optionSelect error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            if(resultError==nil && resultArg[@"pid"]){
                [self finishSuccessProcess:resultArg[@"pid"]];
            }
            [self completionHandlerResult:CB_INAPPV4_PURCHASE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 TransactionFinish:optionSelect error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}

-(void) finishSuccessProcess:(NSString*)pid {
    [receiptList removeObjectForKey:pid];

    for(Parameter* para in [self getCurrentAction].paramList){
        if([para.name isEqualToString:PARAM_INAPPV4_PID]){
            if(receiptList.count>0){
                para.value = receiptList.allKeys[0];
                para.selectList = receiptList.allKeys;
            }
            else {
                para.value = PARAM_VALUE_BLANK;
                para.selectList = @[PARAM_VALUE_BLANK];
            }
            break;
        }
    }
}

-(void)func_InappV4AllFinish :(NSMutableDictionary*)optionSelect{
    if(receiptList.count>0){
        for(NSString* pid in receiptList){
            [self func_InappV4Finish:@{@"pid":pid}.mutableCopy];
        }
    } else {
        [GET_LOG_CONTROLLER requestLogSend:@"Not Exist pid receipt" parameter:optionSelect];
    }
}


-(void)func_InappV4CheckPromotePurchase:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 CheckPromotePurchase:nil error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_INAPPV4_CHECKPROMOTEPURCHASE resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 CheckPromotePurchase:nil error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_InappV4GetSelectedMarket:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 GetSelectedMarket:nil error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_INAPPV4_GETSELECTEDMARKET resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 GetSelectedMarket:nil error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}
-(void)func_InappV4GetAccountUuid:(NSMutableDictionary*)optionSelect
{
    NSError* error = nil;
    
    [GET_LOG_CONTROLLER requestLogSend:currentAction.eName parameter:optionSelect];
    
    if(currentDelegate == DELEGATE_HANDLER){
        [C2SModuleInappV4 GetAccountUuid:nil error:&error completionHandler:^(NSDictionary *resultArg, NSError *resultError) {
            [self completionHandlerResult:CB_INAPPV4_GETACCOUNTUUID resultArg:resultArg resultError:resultError];
        }];
    }
    else
        [C2SModuleInappV4 GetAccountUuid:nil error:&error];
    
    if(error != nil)
        [GET_LOG_CONTROLLER errorLogSend:error name:currentAction.eName result:2];
}


//POST BOX!!!!
-(void)func_InappV4PostBox :(NSMutableDictionary*)optionSelect{
    [GET_POSTBOX_ACTIONCONTROLLER callThePostBox:true];
}

@end
