//
//  UIViewController+ActionListView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "ActionListView.h"

@interface ActionListView ()
{
    NSMutableArray* actionList;
}
@end

@implementation ActionListView

-(void)viewDidLoad
{
    [super viewDidLoad];
    _logLabel.text = [GET_LOG_CONTROLLER getResultLog];

    NSMutableDictionary* group= [GET_ACTION_CONTROLLER getCurrentGroup];
    actionList = group[KEY_ACTIONLIST];
    
    _viewTitle.title = group[KEY_NAME];
    
    _loginState.text = [GET_ACTION_CONTROLLER getLoginLabel];
    _serverState.text = [GET_ACTION_CONTROLLER getServerLabel];
    
    actionTableView.delegate = self;
    actionTableView.dataSource = self;
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated
{
    [actionTableView reloadData];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [actionList count];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}

//- (NSString*)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
//    return [mainMenu objectAtIndex:section];
//}


- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    ActionListViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"ActionCell"];
    
    APIAction *dict = [actionList objectAtIndex:indexPath.row];
    
    [cell setName:dict];
    
    return cell;
}

- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //누르면 실행!!
    APIAction *dict = [actionList objectAtIndex:indexPath.row];

    [GET_ACTION_CONTROLLER setCurrentAction:dict];
    NSString* dictName = [[NSString alloc] initWithFormat:@"%@의 기능", dict.name];
    [GET_LOG_CONTROLLER setResultLog:dictName];
    [GET_ACTION_CONTROLLER callModuleApi];
}

- (IBAction)goBack:(id)sender {
    [GET_LOG_CONTROLLER clearLog:0];
    [self performSegueWithIdentifier:@"groupScene" sender:self];
}

- (IBAction)logMore:(id)sender {
    [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_ACTION];
    [self performSegueWithIdentifier:@"logView" sender:self];

}



@end




@implementation ActionListViewCell

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

-(void)setName:(APIAction*)actionData
{
    _myAction = actionData;
    
    _actionName.text = actionData.name;
    _actionEName.text = actionData.eName;
}

- (IBAction)actionParamSetting:(id)sender {
    
    [GET_ACTION_CONTROLLER setCurrentAction:_myAction];
    
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while(rootViewController.presentedViewController)
    {
        rootViewController = rootViewController.presentedViewController;
    }
    
    [rootViewController performSegueWithIdentifier:@"parameterScene" sender:self];
}



@end
