//
//  UIViewController+DataManager.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "DataManager.h"
#import <Foundation/NSJSONSerialization.h>


@interface DataManager()
{
    
}

@end

@implementation DataManager

// 메인 데이터 설정 ------------------------------------------------
-(void) makeDatas
{
    self.apiGroup = [[NSMutableArray alloc]init];
    
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_SOCIAL_INITIALIZE groupNumber:GROUP_NUM_SOCIAL_INITIALIZE]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_SNS_LOGIN groupNumber:GROUP_NUM_SNS_LOGIN]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_PUSH_MESSAGE groupNumber:GROUP_NUM_PUSH_MESSAGE]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_USER_INFO groupNumber:GROUP_NUM_USER_INFO]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_SNS_POST groupNumber:GROUP_NUM_SNS_POST]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_PROMOTION groupNumber:GROUP_NUM_PROMOTION]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_PROMOTION_INFO groupNumber:GROUP_NUM_PROMOTION_INFO]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_PROMOTION_ACQUISITION groupNumber:GROUP_NUM_PROMOTION_ACQUISITION]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_FRIEND_INVITE groupNumber:GROUP_NUM_FRIEND_INVITE]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_SNS_WEBVIEW groupNumber:GROUP_NUM_SNS_WEBVIEW]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_MARKETINGTRACKER groupNumber:GROUP_NUM_MARKETINGTRACKER]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_HIVEIAP groupNumber:GROUP_NUM_HIVEIAP]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_ENGAGEMENT groupNumber:GROUP_NUM_ENGAGEMENT]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_HIVEPROMOTION groupNumber:GROUP_NUM_HIVEPROMOTION]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_HIVEPROMOTION_INFO groupNumber:GROUP_NUM_HIVEPROMOTION_INFO]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_SOCIAL_SETGAMEINFO groupNumber:GROUP_NUM_SOCIAL_SETGAMEINFO]];
    [self.apiGroup addObject:[self setGroupAction:GROUP_NAME_INAPPV4 groupNumber:GROUP_NUM_INAPPV4]];
}

-(NSMutableDictionary*)setGroupAction :(NSString*)name groupNumber:(groupNum)groupNumber
{
    NSMutableDictionary* group = [[NSMutableDictionary alloc] init];
    
    [group setObject:name forKey:KEY_NAME];
    [group setObject:[NSNumber numberWithInt:groupNumber] forKey:KEY_NUM];
    [group setObject:[self setActionList:groupNumber] forKey:KEY_ACTIONLIST];
    
    return group;
}

-(NSMutableArray*)setActionList:(groupNum)groupNumber
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    switch(groupNumber)
    {
        case GROUP_NUM_SOCIAL_INITIALIZE: actionList=[self setActionListInit]; break;
        case GROUP_NUM_SNS_LOGIN: actionList=[self setActionListLogin]; break;
        case GROUP_NUM_PUSH_MESSAGE: actionList=[self setActionListPushMessage]; break;
        case GROUP_NUM_USER_INFO: actionList=[self setActionListUserInfo]; break;
        case GROUP_NUM_SNS_POST: actionList=[self setActionListSnsPost]; break;
        case GROUP_NUM_PROMOTION: actionList=[self setActionListPromotion]; break;
        case GROUP_NUM_PROMOTION_INFO: actionList=[self setActionListPromotionInfo]; break;
        case GROUP_NUM_PROMOTION_ACQUISITION: actionList=[self setActionListPromotionAcquisition]; break;
        case GROUP_NUM_FRIEND_INVITE: actionList=[self setActionListFriendInvite]; break;
        case GROUP_NUM_SNS_WEBVIEW: actionList=[self setActionListSnsWebview]; break;
        case GROUP_NUM_MARKETINGTRACKER: actionList=[self setActionListMarketingTracker]; break;
        case GROUP_NUM_HIVEIAP: actionList=[self setActionListHiveIAP]; break;
        case GROUP_NUM_ENGAGEMENT: actionList=[self setActionListEngagement]; break;
        case GROUP_NUM_HIVEPROMOTION: actionList=[self setActionListHivePromotion]; break;
        case GROUP_NUM_HIVEPROMOTION_INFO: actionList=[self setActionListHivePromotionInfo]; break;
        case GROUP_NUM_SOCIAL_SETGAMEINFO: actionList=[self setActionListSocialSetGameInfo]; break;
        case GROUP_NUM_INAPPV4: actionList=[self setActionListInappV4]; break;
    }
    
    return actionList;
}

+(NSMutableArray*)getPidList
{
    NSMutableArray* pidList = [[NSMutableArray alloc]init];
    
    //여기에 지금 사용할 pid 추가
    [pidList addObject:KEY_PID1];
    [pidList addObject:KEY_PID2];
    [pidList addObject:KEY_PID3];
    
    return pidList;
}

// 각 group별 action 세팅 ------------------------------------------------
-(NSMutableArray*)setActionListInit
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //init
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_SHOWLOG value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USEDEVELOP value:@false type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USESANDBOX value:@false type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_APPID value:PARAM_INIT_DEFAULTAPPID type:PARAM_TYPE_INPUT selectList: @[PARAM_INIT_DEFAULTAPPID,PARAM_INIT_DEFAULTKRITIKAAPPID,PARAM_INIT_DEFAULTBUNDLEAPPID, PARAM_INIT_DEFAULTMIAPPID, PARAM_INIT_DEFAULTMIIAPAPPID,PARAM_VALUE_DIRECTINPUT]]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_SERVERID value:PARAM_INIT_DEFAULTSERVERID type:PARAM_TYPE_INPUT selectList: @[PARAM_INIT_DEFAULTSERVERID,PARAM_VALUE_DIRECTINPUT]]];
    //1.12.0 update
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_GAMELANGUAGE value:PARAM_INIT_DEFAULTGAMELANGUAGE type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USEHIVEPROMOTION value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USEHIVEIAP value:@false type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USEINAPPV4 value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_SHOWNOTICE value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_TIMEOUTSECONDS value:PARAM_INIT_TIMEOUTSECONDS_DEFAULT type:PARAM_TYPE_NUMBER]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_SHOWPERMISSIONVIEW value:@true type:PARAM_TYPE_CHECKBOX]];
    // 1.20.2
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_USE_HERCULES value:@true type:PARAM_TYPE_CHECKBOX]];


    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_INITIALIZE eName:ACTION_ENAME_SOCIAL_INITIALIZE num:ACTION_NUM_SOCIAL_INITIALIZE paramList:paramList]];
    
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_GUESTVID value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_GUESTSESSIONTOKEN value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SETGUESTUSERINFO eName:ACTION_ENAME_SNS_SETGUESTUSERINFO num:ACTION_NUM_SNS_SETGUESTUSERINFO paramList:paramList2]];
    
    //socialShowRequestPermission - nonedit 1
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_PERMISSION type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_INFO_PERMISSION eName:ACTION_ENAME_SOCIAL_INFO_PERMISSION num:ACTION_NUM_SOCIAL_INFO_PERMISSION paramList:paramList3]];

    return actionList;
}

-(NSMutableArray*)setActionListLogin
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];

    //로그인
    NSMutableArray* paramList = [[NSMutableArray alloc]init];

    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_LOGIN_VALUE_PLATFORM type:PARAM_TYPE_DROPDOWN selectList: @[PARAM_LOGIN_VALUE_GUEST,PARAM_LOGIN_VALUE_PLATFORM]]];
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_LOGIN eName:ACTION_ENAME_SNS_LOGIN num:ACTION_NUM_SNS_LOGIN paramList:paramList]];
    
    //GetLoginType
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_GETLOGINTYPE eName:ACTION_ENAME_SNS_GETLOGINTYPE num:ACTION_NUM_SNS_GETLOGINTYPE]];
    
    //로그아웃
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_LOGOUT eName:ACTION_ENAME_SNS_LOGOUT num:ACTION_NUM_SNS_LOGOUT paramList:paramList4]];

    //1.10.1 select / customSelect
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_LOGIN_VALUE_SELECT type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_LOGIN_CURRENTVIDDATA value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_LOGIN_USEDVIDDATA value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SELECT eName:ACTION_ENAME_SNS_SELECT num:ACTION_NUM_SNS_SELECT paramList:paramList2]];
    
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_LOGIN_VALUE_CUSTOMSELECT type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_LOGIN_SELECTVID value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_CUSTOMSELECT eName:ACTION_ENAME_SNS_CUSTOMSELECT num:ACTION_NUM_SNS_CUSTOMSELECT paramList:paramList3]];
    
    return actionList;
}

-(NSMutableArray*)setActionListPushMessage
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //푸시 등록 - NUMBER2 text 3개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];

    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_PUSHID value:@"12345" type:PARAM_TYPE_NUMBER]];
    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_TITLE value:@"Push_Register : Test Title" type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_MESSAGE value:@"Push_Register : Test Push Message" type:PARAM_TYPE_TEXT ]];
    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_SOUND value:@"" type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_AFTER value:@"5" type:PARAM_TYPE_NUMBER ]];
    [paramList addObject:[Parameter setParameterData:PARAM_PUSH_GROUP_ID value:@"a" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PUSH_REGISTER eName:ACTION_ENAME_PUSH_REGISTER num:ACTION_NUM_PUSH_REGISTER paramList:paramList]];
    
    //푸시 해제 - TEXT 1개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];

    [paramList2 addObject:[Parameter setParameterData:PARAM_PUSH_PUSHID value:@"12345" type:PARAM_TYPE_TEXT]];
     
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PUSH_UNREGISTER eName:ACTION_ENAME_PUSH_UNREGISTER num:ACTION_NUM_PUSH_UNREGISTER paramList:paramList2]];
    
    //푸시 설정 - dropdown 2개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];

    [paramList3 addObject:[Parameter setParameterData:PARAM_PUSH_USENOTICE value:PARAM_VALUE_NA type:PARAM_TYPE_DROPDOWN selectList: @[PARAM_VALUE_NA, PARAM_VALUE_1, PARAM_VALUE_0]]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PUSH_USENIGHT value:PARAM_VALUE_NA type:PARAM_TYPE_DROPDOWN selectList: @[PARAM_VALUE_NA, PARAM_VALUE_1, PARAM_VALUE_0]]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PUSH_OPERATIONREMOTE value:PARAM_VALUE_NA type:PARAM_TYPE_DROPDOWN selectList: @[PARAM_VALUE_NA, PARAM_VALUE_1, PARAM_VALUE_0]]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PUSH_OPERATIONLOCAL value:PARAM_VALUE_NA type:PARAM_TYPE_DROPDOWN selectList: @[PARAM_VALUE_NA, PARAM_VALUE_1, PARAM_VALUE_0]]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PUSH_DESCRIPTION eName:ACTION_ENAME_PUSH_DESCRIPTION num:ACTION_NUM_PUSH_DESCRIPTION paramList:paramList3]];
    
    return actionList;
}

-(NSMutableArray*)setActionListUserInfo
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //하이브 유저 정보보기 - NonEdit 1개, TEXT 1개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];

    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_VID value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_USER eName:ACTION_ENAME_SNS_USER num:ACTION_NUM_SNS_USER paramList:paramList]];
    
    //페이스북 유저 정보보기 - NonEdit 1개, NUMBER 1개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_USER_FACEBOOKID value:PARAM_VALUE_BLANK type:PARAM_TYPE_NUMBER]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_USER_FB eName:ACTION_ENAME_SNS_USER_FB num:ACTION_NUM_SNS_USER_FB paramList:paramList2]];

    //메세지 보기 - NonEdit 1개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];

    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_USER_MESSGAE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_USER_MESSAGE eName:ACTION_ENAME_SNS_USER_MESSAGE num:ACTION_NUM_SNS_USER_MESSAGE paramList:paramList3]];

    
    return actionList;
}

-(NSMutableArray*)setActionListSnsPost
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    /*
    //Hive에 포스팅 - NonEdit 1개 text 3개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];

    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_POST_MESSAGE value:@"Sns_Post : Test Message" type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_POST_IMAGEURL value:PARAM_POST_IMAGEURL_DEFAULT type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_POST_VIDEOURL value:PARAM_POST_VIDEOURL_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_POST_HIVE eName:ACTION_ENAME_SNS_POST_HIVE num:ACTION_NUM_SNS_POST_HIVE paramList:paramList]];
     */
    
    //facebook에 포스팅 - NONEDIT 1개 TEXT 3개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    /*
    [paramList2 addObject:[Parameter setParameterData:PARAM_POST_MESSAGE value:@"Sns_Post : Test Message" type:PARAM_TYPE_TEXT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_POST_TITLE value:@"Sns_Post : Test Title" type:PARAM_TYPE_TEXT]];
     */
    [paramList2 addObject:[Parameter setParameterData:PARAM_POST_APPLINKURL value:PARAM_POST_APPLINKURL_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_POST_FB eName:ACTION_ENAME_SNS_POST_FB num:ACTION_NUM_SNS_POST_FB paramList:paramList2]];
    
    
    //google+에 포스팅 - nonedit 1개 text 1개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_GOOGLEPLUS type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_POST_MESSAGE value:@"Test Sns_Post Message" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_POST_GP eName:ACTION_ENAME_SNS_POST_GP num:ACTION_NUM_SNS_POST_GP paramList:paramList3]];

    
    return actionList;
}

-(NSMutableArray*)setActionListPromotion
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //notice - nonedit 2개 text 1개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_NOTICE type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_PROMOTION_FORCED value:PARAM_VALUE_FALSE type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_NOTICE_FF eName:ACTION_ENAME_PROMOTION_SHOW_NOTICE_FF num:ACTION_NUM_PROMOTION_SHOW_NOTICE_FF paramList:paramList]];
    
    //forced notice - nonedit 2개 text 1개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_NOTICE type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_PROMOTION_FORCED value:PARAM_VALUE_TRUE type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_NOTICE_FT eName:ACTION_ENAME_PROMOTION_SHOW_NOTICE_FT num:ACTION_NUM_PROMOTION_SHOW_NOTICE_FT paramList:paramList2]];
    
    //event - nonedit 2개 text 1개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_EVENT type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PROMOTION_FORCED value:PARAM_VALUE_FALSE type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_EVENT_FF eName:ACTION_ENAME_PROMOTION_SHOW_EVENT_FF num:ACTION_NUM_PROMOTION_SHOW_EVENT_FF paramList:paramList3]];
    
    //forced event - nonedit 2개 text 1개
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_EVENT type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_PROMOTION_FORCED value:PARAM_VALUE_TRUE type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_EVENT_FT eName:ACTION_ENAME_PROMOTION_SHOW_EVENT_FT num:ACTION_NUM_PROMOTION_SHOW_EVENT_FT paramList:paramList4]];
    
    //fullBanner - nonedit 1개 text 1개
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_FULLBANNER type:PARAM_TYPE_NONEDIT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_FULLBANNER eName:ACTION_ENAME_PROMOTION_SHOW_FULLBANNER num:ACTION_NUM_PROMOTION_SHOW_FULLBANNER paramList:paramList5]];
    
    //fullBanner Legacy - nonedit 1개 text 1개
    NSMutableArray* paramList12 = [[NSMutableArray alloc]init];
    
    [paramList12 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_FULLBANNERLEGACY type:PARAM_TYPE_NONEDIT]];
    [paramList12 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_FULLBANNERLEGACY eName:ACTION_ENAME_PROMOTION_SHOW_FULLBANNERLEGACY num:ACTION_NUM_PROMOTION_SHOW_FULLBANNER paramList:paramList12]];
    
    //offerwall - nonedit 1개 text 1개
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];
    
    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_OFFERWALL type:PARAM_TYPE_NONEDIT]];
    [paramList6 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_OFFERWALL eName:ACTION_ENAME_PROMOTION_SHOW_OFFERWALL num:ACTION_NUM_PROMOTION_SHOW_OFFERWALL paramList:paramList6]];
    
    //noticeOnly - nonedit 1개 text 1개
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_NOTICEONLY type:PARAM_TYPE_NONEDIT]];
    [paramList7 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_NOTICEONLY eName:ACTION_ENAME_PROMOTION_SHOW_NOTICEONLY num:ACTION_NUM_PROMOTION_SHOW_NOTICEONLY paramList:paramList7]];
    
    //customWebview - nonedit 1개 text 1개 NUMBER 1개
    NSMutableArray* paramList8 = [[NSMutableArray alloc]init];
    
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_CUSTOMWEBVIEW type:PARAM_TYPE_NONEDIT]];
    [paramList8 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:@"310000" type:PARAM_TYPE_NUMBER]];
    [paramList8 addObject:[Parameter setParameterData:PARAM_PROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_CUSTOMWEBVIEW eName:ACTION_ENAME_PROMOTION_SHOW_CUSTOMWEBVIEW num:ACTION_NUM_PROMOTION_SHOW_CUSTOMWEBVIEW paramList:paramList8]];
    
    //review - nonedit 1개
    NSMutableArray* paramList9 = [[NSMutableArray alloc]init];
    
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_REVIEW type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_REVIEW eName:ACTION_ENAME_PROMOTION_SHOW_REVIEW num:ACTION_NUM_PROMOTION_SHOW_REVIEW paramList:paramList9]];
    
    //moreGames - nonedit 1개
    NSMutableArray* paramList10 = [[NSMutableArray alloc]init];
    
    [paramList10 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_MOREGAMES type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_MOREGAMES eName:ACTION_ENAME_PROMOTION_SHOW_MOREGAMES num:ACTION_NUM_PROMOTION_SHOW_MOREGAMES paramList:paramList10]];
    
    //reviewEx - nonedit 1개
    NSMutableArray* paramList11 = [[NSMutableArray alloc]init];
    
    [paramList11 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_REVIEWEX type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_SHOW_REVIEWEX eName:ACTION_ENAME_PROMOTION_SHOW_REVIEWEX num:ACTION_NUM_PROMOTION_SHOW_REVIEW paramList:paramList11]];
    
    
    return actionList;
}

-(NSMutableArray*)setActionListPromotionInfo
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //badge - notice / nonedit 2개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_BADGE type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_NOTICE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_BADGE_NOTICE eName:ACTION_ENAME_PROMOTION_INFO_BADGE_NOTICE num:ACTION_NUM_PROMOTION_INFO_BADGE_NOTICE paramList:paramList]];
    
    //badge - event / nonedit 2개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_BADGE type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_EVENT type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_BADGE_EVENT eName:ACTION_ENAME_PROMOTION_INFO_BADGE_EVENT num:ACTION_NUM_PROMOTION_INFO_BADGE_EVENT paramList:paramList2]];
    
    //badge - noticeOnly / nonedit 2개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_BADGE type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_NOTICEONLY type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_BADGE_NOTICEONLY eName:ACTION_ENAME_PROMOTION_INFO_BADGE_NOTICEONLY num:ACTION_NUM_PROMOTION_INFO_BADGE_NOTICEONLY paramList:paramList3]];
    
    //badge - customWebview / nonedit 1, number 1
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_BADGE type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:@"310000" type:PARAM_TYPE_NUMBER]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_BADGE_CUSTOMWEBVIEW eName:ACTION_ENAME_PROMOTION_INFO_BADGE_CUSTOMWEBVIEW num:ACTION_NUM_PROMOTION_INFO_BADGE_CUSTOMWEBVIEW paramList:paramList4]];
    
    //view - fullBanner / nonedit 2
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_VIEW type:PARAM_TYPE_NONEDIT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_FULLBANNER type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_VIEW_FULLBANNER eName:ACTION_ENAME_PROMOTION_INFO_VIEW_FULLBANNER num:ACTION_NUM_PROMOTION_INFO_VIEW_FULLBANNER paramList:paramList5]];
    
    //view - notice / nonedit 2
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];
    
    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_VIEW type:PARAM_TYPE_NONEDIT]];
    [paramList6 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_NOTICE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_VIEW_NOTICE eName:ACTION_ENAME_PROMOTION_INFO_VIEW_NOTICE num:ACTION_NUM_PROMOTION_INFO_VIEW_NOTICE paramList:paramList6]];
    
    //view - event / nonedit 2
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_VIEW type:PARAM_TYPE_NONEDIT]];
    [paramList7 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_EVENT type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_VIEW_EVENT eName:ACTION_ENAME_PROMOTION_INFO_VIEW_EVENT num:ACTION_NUM_PROMOTION_INFO_VIEW_EVENT paramList:paramList7]];
    
    //view - noticeOnly / nonedit 2
    NSMutableArray* paramList8 = [[NSMutableArray alloc]init];
    
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_VIEW type:PARAM_TYPE_NONEDIT]];
    [paramList8 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:PARAM_PROMOTION_NOTICEONLY type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_VIEW_NOTICEONLY eName:ACTION_ENAME_PROMOTION_INFO_VIEW_NOTICEONLY num:ACTION_NUM_PROMOTION_INFO_VIEW_NOTICEONLY paramList:paramList8]];
    
    //view - customWebview / nonedit 1 number 1
    NSMutableArray* paramList9 = [[NSMutableArray alloc]init];
    
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_VIEW type:PARAM_TYPE_NONEDIT]];
    [paramList9 addObject:[Parameter setParameterData:PARAM_PROMOTION_VIEWID value:@"310000" type:PARAM_TYPE_NUMBER]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_INFO_VIEW_CUSTOMWEBVIEW eName:ACTION_ENAME_PROMOTION_INFO_VIEW_CUSTOMWEBVIEW num:ACTION_NUM_PROMOTION_INFO_VIEW_CUSTOMWEBVIEW paramList:paramList9]];
    
    //Getofferwallstate / nothing
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_GETOFFERWALLSTATE eName:ACTION_ENAME_PROMOTION_GETOFFERWALLSTATE num:ACTION_NUM_PROMOTION_INFO_GETOFFERWALLSTATE]];

	// BannerInfo
    NSMutableArray* paramList10 = [[NSMutableArray alloc]init];
    
    [paramList10 addObject:[Parameter setParameterData:PARAM_PROMOTION_CAMPAGINTYPE value:PARAM_VALUE_EVENT type:PARAM_TYPE_INPUT selectList:@[PARAM_VALUE_ALL, PARAM_VALUE_EVENT, PARAM_VALUE_NOTICE, PARAM_VALUE_DIRECTINPUT]]];
    [paramList10 addObject:[Parameter setParameterData:PARAM_PROMOTION_BANNERTYPE value:PARAM_VALUE_GREAT type:PARAM_TYPE_INPUT selectList:@[PARAM_VALUE_GREAT, PARAM_VALUE_SMALL, PARAM_VALUE_ROLLING, PARAM_VALUE_DIRECTINPUT]]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTIONINFO_GETBANNERINFO eName:ACTION_ENAME_PROMOTIONINFO_GETBANNERINFO num:ACTION_NUM_PROMOTION_INFO_GETBANNERINFO paramList:paramList10]];
    
	
    return actionList;
}


-(NSMutableArray*)setActionListPromotionAcquisition
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_ACQUISITION_ADDITIONALINFO value:PARAM_ACQUISITION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION eName:ACTION_ENAME_PROMOTION_ACQUISITION num:ACTION_NUM_PROMOTION_ACQUISITION paramList:paramList]];
    
    NSMutableArray* paramList1 = [[NSMutableArray alloc]init];
    
    [paramList1 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_QRCODESAVE type:PARAM_TYPE_NONEDIT]];
    [paramList1 addObject:[Parameter setParameterData:PARAM_VALUE_DATA value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_QRCODE_SAVE eName:ACTION_ENAME_PROMOTION_ACQUISITION_QRCODE_SAVE num:ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SAVE paramList:paramList1]];
    
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_QRCODESHARE type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_DATA value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_QRCODE_SHARE eName:ACTION_ENAME_PROMOTION_ACQUISITION_QRCODE_SHARE num:ACTION_NUM_PROMOTION_ACQUISITION_QRCODE_SHARE paramList:paramList2]];
    
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_LINKSHARE type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_URL value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_LINK_SHARE eName:ACTION_ENAME_PROMOTION_ACQUISITION_LINK_SHARE num:ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE paramList:paramList3]];
    
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_PROMOTION_LINKSHARE type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_URL value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_MESSAGE value:@"Test Message : Link Share!\n" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE eName:ACTION_ENAME_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE num:ACTION_NUM_PROMOTION_ACQUISITION_LINK_SHARE_MESSAGE paramList:paramList4]];
    
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_VIDORUID value:PARAM_VALUE_VID type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_VALUE_VID, PARAM_VALUE_UID]]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_VID value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_MESSAGE value:@"Sns_Message : Test Message" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_IMAGEURL value:@"http://image-glb.qpyou.cn/hubweb/avatar_img/public/puzzle_01_s.png" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_THUMBNAILURL value:@"http://image-glb.qpyou.cn/hubweb/avatar_img/public/puzzle_01_s.png" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_USEPUSH value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_INVITE value:@false type:PARAM_TYPE_CHECKBOX]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_PROMOTION_LINKSHARE value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_PROMOTION_LINKSHAREURL value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];

    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_HIVELINK_SHARE eName:ACTION_ENAME_PROMOTION_ACQUISITION_HIVELINK_SHARE num:ACTION_NUM_PROMOTION_ACQUISITION_HIVELINK_SHARE paramList:paramList5]];

    [actionList addObject:[APIAction setAPIData:ACTION_NAME_PROMOTION_ACQUISITION_SENDER_INFO eName:ACTION_ENAME_PROMOTION_ACQUISITION_SENDER_INFO num:ACTION_NUM_PROMOTION_ACQUISITION_SENDER_INFO]];
    
    return actionList;
}

-(NSMutableArray*)setActionListFriendInvite
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //HIVE 게임 친구 - NONEDIT 2
    NSMutableArray* paramList = [[NSMutableArray alloc]init];

    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_FRIENDS_GAME type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_FRIENDS_HIVE_GAME eName:ACTION_ENAME_SNS_FRIENDS_HIVE_GAME num:ACTION_NUM_SNS_FRIENDS_HIVE_GAME paramList:paramList]];
    
    
    //HIVE 안 게임 친구 - NONEDIT 2
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_FRIENDS_OTHER type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_FRIENDS_HIVE_OTHER eName:ACTION_ENAME_SNS_FRIENDS_HIVE_OTHER num:ACTION_NUM_SNS_FRIENDS_HIVE_OTHER paramList:paramList2]];
    
    
    //HIVE 전체 친구 - NONEDIT 2
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_FRIENDS_ALL type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_FRIENDS_HIVE_ALL eName:ACTION_ENAME_SNS_FRIENDS_HIVE_ALL num:ACTION_NUM_SNS_FRIENDS_HIVE_ALL paramList:paramList3]];
    
    
    //FACEBOOK 초대한 유저 정보 - NONEDIT 2 NUMBER 1
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_FRIENDS_RECEIVEDINVITE type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_FRIENDS_LIMIT value:@"1" type:PARAM_TYPE_NUMBER]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_FRIENDS_FB_RECEIVEDINVITE eName:ACTION_ENAME_SNS_FRIENDS_FB_RECEIVEDINVITE num:ACTION_NUM_SNS_FRIENDS_FB_RECEIVEDINVITE paramList:paramList4]];
    
    
    //HIVE 메세지 보내기 - TEXT 5 CHECKBOX 3
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_VIDORUID value:PARAM_VALUE_VID type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_VALUE_VID, PARAM_VALUE_UID]]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_VID value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    //[paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_UID value:PARAM_VALUE_BLANK type:PARAM_TYPE_TEXT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_MESSAGE value:@"Sns_Message : Test Message" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_IMAGEURL value:@"http://image-glb.qpyou.cn/hubweb/avatar_img/public/puzzle_01_s.png" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_THUMBNAILURL value:@"http://image-glb.qpyou.cn/hubweb/avatar_img/public/puzzle_01_s.png" type:PARAM_TYPE_TEXT ]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_USEPUSH value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_MESSAGE_INVITE value:@true type:PARAM_TYPE_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_MESSAGE eName:ACTION_ENAME_SNS_MESSAGE num:ACTION_NUM_SNS_MESSAGE paramList:paramList5]];
    
    
    
    //FACEBOOK 메세지 보내기 - NONEDIT 2 TEXT 1
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];

    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_MESSAGE_INVITEDIALOG type:PARAM_TYPE_NONEDIT]];
    [paramList6 addObject:[Parameter setParameterData:PARAM_MESSAGE_MESSAGE value:@"Sns_Message : Test Message" type:PARAM_TYPE_TEXT ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_MESSAGE_FB_INVITEDIALOG eName:ACTION_ENAME_SNS_MESSAGE_FB_INVITEDIALOG num:ACTION_NUM_SNS_MESSAGE_FB_INVITEDIALOG paramList:paramList6]];

    
    //하이브 세션 확인 - nonedit 1
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_NA type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SESSION eName:ACTION_ENAME_SNS_SESSION num:ACTION_NUM_SNS_SESSION paramList:paramList7]];
    
    
    //Facebook 세션 확인 - nonedit 1
    NSMutableArray* paramList8 = [[NSMutableArray alloc]init];
    
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SESSIONFB eName:ACTION_ENAME_SNS_SESSIONFB num:ACTION_NUM_SNS_SESSIONFB paramList:paramList8]];
    
    //FACEBOOK 친구 정보 - NONEDIT 2
    NSMutableArray* paramList9 = [[NSMutableArray alloc]init];
    
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_FRIENDS_FRIENDSLIST type:PARAM_TYPE_NONEDIT]];
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_SERVICE value:PARAM_VALUE_FACEBOOK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_FRIENDS_FB_FRIENDSLIST eName:ACTION_ENAME_SNS_FRIENDS_FB_FRIENDSLIST num:ACTION_NUM_SNS_FRIENDS_FB_FRIENDSLIST paramList:paramList9]];
    
    return actionList;
}

-(NSMutableArray*)setActionListSnsWebview
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    //home - nonedit 1
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_HOME type:PARAM_TYPE_NONEDIT]];

    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_HOME eName:ACTION_ENAME_SNS_SHOW_HOME num:ACTION_NUM_SNS_SHOW_HOME paramList:paramList]];
    
    
    //user - nonedit 1
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_USER type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_USER eName:ACTION_ENAME_SNS_SHOW_USER num:ACTION_NUM_SNS_SHOW_USER paramList:paramList2]];

    
    //cafe - nonedit 1
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_CAFE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_CAFE eName:ACTION_ENAME_SNS_SHOW_CAFE num:ACTION_NUM_SNS_SHOW_CAFE paramList:paramList3]];
    
    
    //edit/profile/picture - nonedit 1
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_EDIT type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_EDIT eName:ACTION_ENAME_SNS_SHOW_EDIT num:ACTION_NUM_SNS_SHOW_EDIT paramList:paramList4]];
    
    
    //find_friends - nonedit 1
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_FIND type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_FIND eName:ACTION_ENAME_SNS_SHOW_FIND num:ACTION_NUM_SNS_SHOW_FIND paramList:paramList5]];
    
    
    //inquiry - nonedit 1
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];
    
    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_INQUIRY type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_INQUIRY eName:ACTION_ENAME_SNS_SHOW_INQUIRY num:ACTION_NUM_SNS_SHOW_INQUIRY paramList:paramList6]];
    
	// chatbot - nonedit 1 text 1
	NSMutableArray *paramList12 = [[NSMutableArray alloc] init];
	[paramList12 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_CHATBOT type:PARAM_TYPE_NONEDIT]];
    [paramList12 addObject:[Parameter setParameterData:PARAM_VALUE_ADDITIONALINFO value:PARAM_WEBVIEW_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
	
	[actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_CHATBOT eName:ACTION_ENAME_SNS_SHOW_CHATBOT num:ACTION_NUM_SNS_SHOW_CHATBOT paramList:paramList12]];
    
    //memory - nonedit 1 number 1
    NSMutableArray* paramList8 = [[NSMutableArray alloc]init];
    
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_MESSAGE type:PARAM_TYPE_NONEDIT]];
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_UID value:PARAM_VALUE_BLANK type:PARAM_TYPE_NUMBER ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SNS_SHOW_MESSAGE eName:ACTION_ENAME_SNS_SHOW_MESSAGE num:ACTION_NUM_SNS_SHOW_MESSAGE paramList:paramList8]];
    
    
    //terms - nonedit 1
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_TERMS type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SHOW_TERMS eName:ACTION_ENAME_SOCIAL_SHOW_TERMS num:ACTION_NUM_SOCIAL_SHOW_TERMS paramList:paramList7]];
    
    
    //1.10.0
    //adultAuth - nonedit 1
    NSMutableArray* paramList9 = [[NSMutableArray alloc]init];
    
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_ADULTAUTH type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SHOW_ADULTAUTH eName:ACTION_ENAME_SOCIAL_SHOW_ADULTAUTH num:ACTION_NUM_SOCIAL_SHOW_ADULTAUTH paramList:paramList9]];
    
    //socialShowNotice - nonedit 1
    NSMutableArray* paramList10 = [[NSMutableArray alloc]init];
    
    [paramList10 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_NOTICE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SHOW_NOTICE eName:ACTION_ENAME_SOCIAL_SHOW_NOTICE num:ACTION_NUM_SOCIAL_SHOW_NOTICE paramList:paramList10]];
    
    //socialInfoNotice - nonedit 1
    NSMutableArray* paramList11 = [[NSMutableArray alloc]init];
    
    [paramList11 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_WEBVIEW_NOTICE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_INFO_NOTICE eName:ACTION_ENAME_SOCIAL_INFO_NOTICE num:ACTION_NUM_SOCIAL_INFO_NOTICE paramList:paramList11]];
    
    
    return actionList;
}

-(NSMutableArray*)setActionListMarketingTracker
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    // 이벤트 설정 - checkbox 3
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_TRACKER_ADJUST value:@true type:PARAM_TYPE_CHECKBOX]];
//    [paramList addObject:[Parameter setParameterData:PARAM_TRACKER_PARTYTRACK value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_TRACKER_SINGULAR value:@true type:PARAM_TYPE_CHECKBOX]];
    [paramList addObject:[Parameter setParameterData:PARAM_TRACKER_APPSFLYER value:@true type:PARAM_TYPE_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_TRACKER_SETENABLE eName:ACTION_ENAME_TRACKER_SETENABLE num:ACTION_NUM_TRACKER_SETENABLE paramList:paramList]];

    
    // 이벤트 발생 - dropdown 1
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_TRACKER_EVENT value:TRACK_TUTORIALCOMPLETE type:PARAM_TYPE_DROPDOWN selectList:@[TRACK_TUTORIALCOMPLETE]]];
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_TRACKER_SENDEVENT eName:ACTION_ENAME_TRACKER_SENDEVENT num:ACTION_NUM_TRACKER_SENDEVENT paramList:paramList2]];
    
    /* Unity에서 호출 가능
    // 이벤트 발생(revenue) - text4 number 1
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_TRACKER_TITLE value:@"Tracker_SendEvent : Test Title" type:PARAM_TYPE_TEXT ]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_TRACKER_DESCRIPTION value:@"Tracker_SendEvent : Test Description" type:PARAM_TYPE_TEXT ]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_TRACKER_CURRENCY value:@"KRW" type:PARAM_TYPE_TEXT ]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_TRACKER_PRICE value:@"1000" type:PARAM_TYPE_NUMBER ]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_TRACKER_ITEMCOUNT value:@"1" type:PARAM_TYPE_NUMBER ]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_TRACKER_SENDEVENTR eName:ACTION_ENAME_TRACKER_SENDEVENTR num:ACTION_NUM_TRACKER_SENDEVENTR paramList:paramList3]];
    */
    
    
    return actionList;
}

//Hive IAP
-(NSMutableArray*)setActionListHiveIAP
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    // postbox - 없음
    [actionList addObject:[APIAction setAPIData:@"우편함" eName:@"(구매확인을 위해 임시로 만든 우편함)" num:ACTION_NUM_HIVEIAP_POSTBOX]];
    
    
    return actionList;
}

// 1.10.0 Engagement
-(NSMutableArray*)setActionListEngagement
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    /*
    // GetEvents - 없음
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_ENGAGEMENT_GETEVENTS eName:ACTION_ENAME_ENGAGEMENT_GETEVENTS num:ACTION_NUM_ENGAGEMENT_GETEVENTS]];
    */
    
    // ConsumeCoupon - text 3개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_ENGAGEMENT_COUPONID value:@"COUPONTEST" type:PARAM_TYPE_TEXT]];

    [paramList addObject:[Parameter setParameterData:PARAM_ENGAGEMENT_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_ENGAGEMENT_CONSUMECOUPON eName:ACTION_ENAME_ENGAGEMENT_CONSUMECOUPON num:ACTION_NUM_ENGAGEMENT_CONSUMECOUPON paramList:paramList]];
    
    // 1.11.0 Engagement Ready Button
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_ENGAGEMENT_READY eName:ACTION_ENAME_ENGAGEMENT_READY num:ACTION_NUM_ENGAGEMENT_READY]];
    return actionList;
}

// 1.12.0 Hive Promotion
-(NSMutableArray*)setActionListHivePromotion
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    
    // Show 9개 - type:nonedit(news, banner, notice, customView, customBoard, spot, direct,offerwall,review) / contentKey:edit(customView~direct까지) text(300001) / forced : switch (news~notice까지)
    
    //news
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_NEWS type:PARAM_TYPE_NONEDIT]];
    [paramList addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_FORCED value:PARAM_VALUE_0 type:PARAM_TYPE_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_NEWS eName:ACTION_ENAME_HIVEPROMOTION_NEWS num:ACTION_NUM_HIVEPROMOTION_NEWS paramList:paramList]];
    
    //banner
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_BANNER type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_FORCED value:PARAM_VALUE_0 type:PARAM_TYPE_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_BANNER eName:ACTION_ENAME_HIVEPROMOTION_BANNER num:ACTION_NUM_HIVEPROMOTION_BANNER paramList:paramList2]];
    
    //notice
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_NOTICE type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_FORCED value:PARAM_VALUE_0 type:PARAM_TYPE_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_NOTICE eName:ACTION_ENAME_HIVEPROMOTION_NOTICE num:ACTION_NUM_HIVEPROMOTION_NOTICE paramList:paramList3]];
    
    //customView
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_CUSTOMVIEW type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"310000" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_CUSTOMVIEW eName:ACTION_ENAME_HIVEPROMOTION_CUSTOMVIEW num:ACTION_NUM_HIVEPROMOTION_CUSTOMVIEW paramList:paramList4]];
    
    //customboard
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_CUSTOMBOARD type:PARAM_TYPE_NONEDIT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"200007" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_CUSTOMBOARD eName:ACTION_ENAME_HIVEPROMOTION_CUSTOMBOARD num:ACTION_NUM_HIVEPROMOTION_CUSTOMBOARD paramList:paramList5]];
    
    //spot
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];
    
    [paramList6 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_SPOT type:PARAM_TYPE_NONEDIT]];
    [paramList6 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"1004" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_SPOT eName:ACTION_ENAME_HIVEPROMOTION_SPOT num:ACTION_NUM_HIVEPROMOTION_SPOT paramList:paramList6]];
    
    //direct
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_DIRECT type:PARAM_TYPE_NONEDIT]];
    [paramList7 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"209019" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_DIRECT eName:ACTION_ENAME_HIVEPROMOTION_DIRECT num:ACTION_NUM_HIVEPROMOTION_DIRECT paramList:paramList7]];
    
    //offerwall
    NSMutableArray* paramList8 = [[NSMutableArray alloc]init];
    
    [paramList8 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_OFFERWALL type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_OFFERWALL eName:ACTION_ENAME_HIVEPROMOTION_OFFERWALL num:ACTION_NUM_HIVEPROMOTION_OFFERWALL paramList:paramList8]];
    
    //review
    NSMutableArray* paramList9 = [[NSMutableArray alloc]init];
    
    [paramList9 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_REVIEW type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_REVIEW eName:ACTION_ENAME_HIVEPROMOTION_REVIEW num:ACTION_NUM_HIVEPROMOTION_REVIEW paramList:paramList9]];
    
    //reviewEx
    NSMutableArray* paramList10 = [[NSMutableArray alloc]init];
    
    [paramList10 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_REVIEWEX type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTION_SHOW_REVIEWEX eName:ACTION_ENAME_HIVEPROMOTION_SHOW_REVIEWEX num:ACTION_NUM_HIVEPROMOTION_REVIEW paramList:paramList10]];
    
    
    return actionList;
}

// 1.12.0 Hive Promotion
-(NSMutableArray*)setActionListHivePromotionInfo
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    // Info - type : dropdown(badge, customView, customBoard, spot, direct) / contentKey:edit text(300001) (view 한정)
    
    // badge
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_BADGE type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_BADGE eName:ACTION_ENAME_HIVEPROMOTIONINFO_BADGE num:ACTION_NUM_HIVEPROMOTIONINFO_BADGE paramList:paramList]];
    
    //customView
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_CUSTOMVIEW type:PARAM_TYPE_NONEDIT]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"310000" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_VIEW_CUSTOMVIEW eName:ACTION_ENAME_HIVEPROMOTIONINFO_VIEW_CUSTOMVIEW num:ACTION_NUM_HIVEPROMOTIONINFO_VIEW_CUSTOMVIEW paramList:paramList2]];
    
    //customboard
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];
    
    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_CUSTOMBOARD type:PARAM_TYPE_NONEDIT]];
    [paramList3 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"200007" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_VIEW_CUSTOMBOARD eName:ACTION_ENAME_HIVEPROMOTIONINFO_VIEW_CUSTOMBOARD num:ACTION_NUM_HIVEPROMOTIONINFO_VIEW_CUSTOMBOARD paramList:paramList3]];
    
    //spot
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_SPOT type:PARAM_TYPE_NONEDIT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"1004" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_VIEW_SPOT eName:ACTION_ENAME_HIVEPROMOTIONINFO_VIEW_SPOT num:ACTION_NUM_HIVEPROMOTIONINFO_VIEW_SPOT paramList:paramList4]];
    
    //direct
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_HIVEPROMOTION_DIRECT type:PARAM_TYPE_NONEDIT]];
    [paramList5 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CONTENTKEY value:@"209019" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_VIEW_DIRECT eName:ACTION_ENAME_HIVEPROMOTIONINFO_VIEW_DIRECT num:ACTION_NUM_HIVEPROMOTIONINFO_VIEW_DIRECT paramList:paramList5]];
    
    
    // SetAdditionalInfo - json string
    NSMutableArray* paramList6 = [[NSMutableArray alloc]init];
    
    [paramList6 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_ADDITIONALINFO value:PARAM_PROMOTION_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_SETADDITIONALINFO eName:ACTION_ENAME_HIVEPROMOTIONINFO_SETADDITIONALINFO num:ACTION_NUM_HIVEPROMOTIONINFO_SETADDITIONALINFO paramList:paramList6]];
    
    // GetOfferwallState - no param
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_GETOFFERWALLSTATE eName:ACTION_ENAME_HIVEPROMOTIONINFO_GETOFFERWALLSTATE num:ACTION_NUM_HIVEPROMOTIONINFO_GETOFFERWALLSTATE]];
    
    
    // GetBannerInfo - all, event, notice
    NSMutableArray* paramList7 = [[NSMutableArray alloc]init];
    
    [paramList7 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_CAMPAGINTYPE value:PARAM_VALUE_EVENT type:PARAM_TYPE_INPUT selectList:@[PARAM_VALUE_ALL, PARAM_VALUE_EVENT, PARAM_VALUE_NOTICE, PARAM_VALUE_DIRECTINPUT]]];
    [paramList7 addObject:[Parameter setParameterData:PARAM_HIVEPROMOTION_BANNERTYPE value:PARAM_VALUE_GREAT type:PARAM_TYPE_INPUT selectList:@[PARAM_VALUE_GREAT, PARAM_VALUE_SMALL, PARAM_VALUE_ROLLING, PARAM_VALUE_DIRECTINPUT]]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_GETBANNERINFO eName:ACTION_ENAME_HIVEPROMOTIONINFO_GETBANNERINFO num:ACTION_NUM_HIVEPROMOTIONINFO_GETBANNERINFO paramList:paramList7]];
    
    // UpdatePromotionData
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_HIVEPROMOTIONINFO_UPDATEPROMOTIONDATA eName:ACTION_ENAME_HIVEPROMOTIONINFO_UPDATEPROMOTIONDATA num:ACTION_NUM_HIVEPROMOTIONINFO_UPDATEPROMOTIONINFO]];
    
    return actionList;
}

// 1.12.0 Social Set Game Info
-(NSMutableArray*)setActionListSocialSetGameInfo
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    
    // SetGameInfo
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_SERVERID value:@"kr" type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_GAMELANGUAGE value:@"ko" type:PARAM_TYPE_TEXT]];
    [paramList addObject:[Parameter setParameterData:PARAM_INIT_CHANNEL value:@"C2S" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SETGAMEINFO eName:ACTION_ENAME_SOCIAL_SETGAMEINFO num:ACTION_NUM_SOCIAL_SETGAMEINFO paramList:paramList]];
    
    // SetGameInfo - set emergencyMode
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:@"emergencyMode" value:PARAM_VALUE_TRUE type:PARAM_TYPE_NONEDIT_CHECKBOX]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SETEMERGENCYMODE eName:ACTION_ENAME_SOCIAL_SETEMERGENCYMODE num:ACTION_NUM_SOCIAL_SETGAMEINFO_SETEMERGENCYMODE paramList:paramList2]];
    
    // GetHiveCountry - no param
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_GETHIVECOUNTRYCODE eName:ACTION_ENAME_SOCIAL_GETHIVECOUNTRYCODE num:ACTION_NUM_SOCIAL_GETHIVECOUNTRYCODE]];
    
    // SendData - type, funnelsId, optionTag
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_SENDDATA_FUNNELSLOGS type:PARAM_TYPE_TEXT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_SENDDATA_FUNNELSID value:@"700" type:PARAM_TYPE_TEXT]];
    [paramList4 addObject:[Parameter setParameterData:PARAM_SENDDATA_OPTIONTAG value:@"test" type:PARAM_TYPE_TEXT]];

    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SENDDATA eName:ACTION_ENAME_SOCIAL_SENDDATA num:ACTION_NUM_SOCIAL_SENDDATA paramList:paramList4]];
    
    // GetChannel - no param
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_GETCHANNEL eName:ACTION_ENAME_SOCIAL_GETCHANNEL num:ACTION_NUM_SOCIAL_GETCHANNEL]];
    
    // SetChannel - Channel Code
    NSMutableArray* paramList5 = [[NSMutableArray alloc] init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_INIT_CHANNEL value:@"C2S" type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_SOCIAL_SETCHANNEL eName:ACTION_ENAME_SOCIAL_SETCHANNEL num:ACTION_NUM_SOCIAL_SETCHANNEL paramList:paramList5]];
    
    return actionList;
}


// 1.18.4 InappV4
-(NSMutableArray*)setActionListInappV4
{
    NSMutableArray* actionList = [[NSMutableArray alloc]init];
    
    // itemInfo - nonedit 1개, input 1개, text 2개
    NSMutableArray* paramList = [[NSMutableArray alloc]init];
    
    [paramList addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_INAPPV4_CONSUMABLE type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_INAPPV4_CONSUMABLE, PARAM_INAPPV4_SUBSCRIPTION]]];
   
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_ITEMINFO eName:ACTION_ENAME_INAPPV4_ITEMINFO num:ACTION_NUM_INAPPV4_ITEMINFO paramList:paramList]];
    
    // purchase - dropdown 2개, text 1개
    NSMutableArray* paramList2 = [[NSMutableArray alloc]init];
    
    [paramList2 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_INAPPV4_CONSUMABLE type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_INAPPV4_CONSUMABLE, PARAM_INAPPV4_SUBSCRIPTION]]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_HIVEIAP_PID value:PARAM_VALUE_BLANK type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_VALUE_BLANK]]];
    [paramList2 addObject:[Parameter setParameterData:PARAM_HIVEIAP_ADDITIONALINFO value:PARAM_HIVEIAP_ADDITIONALINFO_DEFAULT type:PARAM_TYPE_TEXT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_PURCHASE eName:ACTION_ENAME_INAPPV4_PURCHASE num:ACTION_NUM_INAPPV4_PURCHASE paramList:paramList2]];

    
    // restore - dropdown 1개
    NSMutableArray* paramList3 = [[NSMutableArray alloc]init];

    [paramList3 addObject:[Parameter setParameterData:PARAM_VALUE_TYPE value:PARAM_INAPPV4_CONSUMABLE type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_INAPPV4_CONSUMABLE, PARAM_INAPPV4_SUBSCRIPTION]]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_RESTORE eName:ACTION_ENAME_INAPPV4_RESTORE num:ACTION_NUM_INAPPV4_RESTORE paramList:paramList3]];

    
    // finish - dropdown 1개
    NSMutableArray* paramList4 = [[NSMutableArray alloc]init];
    
    [paramList4 addObject:[Parameter setParameterData:PARAM_HIVEIAP_PID value:PARAM_VALUE_BLANK type:PARAM_TYPE_DROPDOWN selectList:@[PARAM_VALUE_BLANK]]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_FINISH eName:ACTION_ENAME_INAPPV4_FINISH num:ACTION_NUM_INAPPV4_FINISH paramList:paramList4]];
    
    
    // all finish - dropdown 1개
    NSMutableArray* paramList5 = [[NSMutableArray alloc]init];
    
    [paramList5 addObject:[Parameter setParameterData:PARAM_HIVEIAP_PID value:PARAM_VALUE_BLANK type:PARAM_TYPE_NONEDIT]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_ALLFINISH eName:ACTION_ENAME_INAPPV4_ALLFINISH num:ACTION_NUM_INAPPV4_ALLFINISH paramList:paramList5]];

    
    //구매 요청 확인
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_CHECKPROMOTEPURCHASE eName:ACTION_ENAME_INAPPV4_CHECKPROMOTEPURCHASE num:ACTION_NUM_INAPPV4_CHECKPROMOTEPURCHASE]];
    
    //구매 요청 확인
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_GETSELECTEDMARKET eName:ACTION_ENAME_INAPPV4_GETSELECTEDMARKET num:ACTION_NUM_INAPPV4_GETSELECTEDMARKET]];
    
    [actionList addObject:[APIAction setAPIData:ACTION_NAME_INAPPV4_GETACCOUNTUUID eName:ACTION_ENAME_INAPPV4_GETACCOUNTUUID num:ACTION_NUM_INAPPV4_GETACCOUNTUUID]];
    
    
    // postbox - 없음
    [actionList addObject:[APIAction setAPIData:@"우편함" eName:@"(구매확인을 위해 임시로 만든 우편함)" num:ACTION_NUM_INAPPV4_POSTBOX]];
    
    
    return actionList;
}



// API 정보 읽기 ------------------------------------------------
-(APIAction*) getAPIAction:(actionNum)aNum
{
    for(NSMutableDictionary* group in self.apiGroup){
        for(NSMutableArray* actionList in group){
            for(APIAction* action in actionList){
                if(action.num == aNum)
                    return action;
            }
        }
    }
    
    return nil;
}

// Paramater Data 수정 ------------------------------------------------
-(void) setParamValue:(actionNum)aNum name:(NSString*)name data:(id)data
{
    for(NSMutableDictionary* group in self.apiGroup){
        for(NSMutableArray* actionList in group){
            for(APIAction* action in actionList){
                if(action.num == aNum){
                    for(Parameter* param in action.paramList){
                        if([param.name isEqualToString:name])
                            param.value = data;
                    }
                }
            }
        }
    }
}

@end

