//
//  DealCallback.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "DealCallback.h"


@interface DealCallback()
{
    
}

@end

@implementation DealCallback

+(void)resultDelegate:(callBackNum)api resultArg:(NSDictionary*)resultArg 
{
    DealCallback *deal = [[DealCallback alloc]init];
    
    switch(api){
        case CB_SOCIAL_INITIALIZE: {
            [deal social_InitializeCB:resultArg];
        }break;
            
        case CB_SNS_LOGIN: {
            [deal sns_LoginCB:resultArg];
        }break;
        case CB_SNS_LOGOUT: {
            [deal sns_LogoutCB:resultArg];
        }break;
        case CB_INAPP_DESCRIPTION:{
        }break;
        
        case CB_SNS_SESSION:{
            [deal sns_SessionCB:resultArg];
        
        }break;
            
        case CB_HIVEIAP_INFO_SHOP:
        case CB_INAPPV4_ITEMINFO: {
            [deal hiveIAP_InfoCB:resultArg];
            
        }break;
        
        case CB_SOCIAL_SETGAMEINFO:{
            [deal social_SetGameInfoCB:resultArg];
        }break;
        
        case CB_SOCIAL_INFO:{
            [deal social_Info_PopupCB:resultArg];
        }break;

        
            /*
        case CB_SNS_GETLOGINTYPE: { }break;

        case CB_PUSH_REGISTER: { }break;
        case CB_PUSH_UNREGISTER: { }break;
        case CB_PUSH_DESCRIPTION: { }break;
            
        case CB_SNS_USER: { }break;
        case CB_SNS_POST: { }break;
            
        case CB_PROMOTION_SHOW: { }break;
        case CB_PROMOTION_INFO: { }break;
        case CB_PROMOTION_GETOFFERWALLSTATE: { }break;
            
        case CB_SNS_FRIENDS: { }break;
        case CB_SNS_MESSAGE: { }break;
            
        case CB_INAPP_PURCHASE: { }break;
        case CB_INAPP_RESTORE: { }break;
        case CB_INAPP_FINISH: { }break;
        case CB_INAPP_PREPARE: { }break;
        case CB_INAPP_REQUESTBALANCE: { }break;
            
        case CB_SNS_SHOW: { }break;
        case CB_SOCIAL_SHOW: { }break;
            
        case CB_TRACKER_SETENABLE: { }break;
        case CB_TRACKER_SENDEVENT: { }break;
            
        case CB_ETC: {} break;
             
        case CB_HIVEIAP_SHOW: {}break;
        case CB_HIVEIAP_PURCHASE: {}break;
        case CB_HIVEIAP_RESTORE: {}break;
    */
        default: break;
    }
    
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    dispatch_async(dispatch_get_main_queue(), ^{
        UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
        
        while(rootViewController.presentedViewController)
        {
            rootViewController = rootViewController.presentedViewController;
        }
        
        // topmostView가 샘플앱 view class일 때만 viewDidLoad
        NSArray* sampleRefreshViewList = @[@"LoginView", @"GroupListView", @"ActionListView", @"ParameterLishView", @"LogView"];
        
        for(NSString* refreshClassName in sampleRefreshViewList){
            if([rootViewController.class isEqual:[NSClassFromString(refreshClassName) class]])
                [rootViewController viewDidLoad];
        }
    });
}


//여기서부터는 api callback
-(void)social_InitializeCB:(NSDictionary*)resultArg
{
    [GET_INFO_CONTROLLER setInfoData:INFO_DID_NAME data:resultArg[KEY_DID]];
    

    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while(rootViewController.presentedViewController)
    {
        rootViewController = rootViewController.presentedViewController;
    }
    
    [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_LOGIN];
    [rootViewController performSegueWithIdentifier:@"loginScene" sender:self];

}


-(void)sns_LoginCB:(NSDictionary*)resultArg
{
    [GET_INFO_CONTROLLER setInfoData:INFO_VID_NAME data:resultArg[KEY_VID]];
    
    if(resultArg[KEY_UID]!=nil)
        [GET_INFO_CONTROLLER setInfoData:INFO_UID_NAME data:resultArg[KEY_UID]];
    
    
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while(rootViewController.presentedViewController)
    {
        rootViewController = rootViewController.presentedViewController;
    }
    
    if([GET_LOG_CONTROLLER getCurrentDepth] == DEPTH_LOGIN){
        [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_GROUP];
        [rootViewController performSegueWithIdentifier:@"groupScene" sender:self];
    }

}

-(void)sns_LogoutCB:(NSDictionary*)resultArg
{
    [GET_INFO_CONTROLLER setInfoData:INFO_UID_NAME data:@""];
    [GET_INFO_CONTROLLER setInfoData:INFO_VID_NAME data:@""];
    [GET_INFO_CONTROLLER setInfoData:INFO_LOGIN_NAME data:@""];
    [GET_INFO_CONTROLLER setInfoData:INFO_SESSION_NAME data:@""];

    
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while(rootViewController.presentedViewController)
    {
        rootViewController = rootViewController.presentedViewController;
    }
    [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_LOGIN];
    [rootViewController performSegueWithIdentifier:@"loginScene" sender:self];

}

-(void)sns_SessionCB:(NSDictionary *)resultArg
{
    [GET_INFO_CONTROLLER setInfoData:INFO_SESSION_NAME data:resultArg[KEY_SESSIONTOKEN]];
}


-(void)hiveIAP_InfoCB:(NSDictionary*)resultArg
{
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    
    UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    while(rootViewController.presentedViewController)
    {
        rootViewController = rootViewController.presentedViewController;
    }
    [rootViewController performSegueWithIdentifier:@"HiveIAPScene" sender:self];
    
    [GET_POSTBOX_ACTIONCONTROLLER callThePostBox:false];
}

// 1.16.1
-(void)social_SetGameInfoCB:(NSDictionary*)resultArg
{
    if(resultArg[PARAM_INIT_SERVERID] != nil){
        [GET_INFO_CONTROLLER setInfoData:INFO_SERVERID_NAME data:resultArg[PARAM_INIT_SERVERID]];
    }
    
    if(resultArg[PARAM_INIT_GAMELANGUAGE] != nil){
        [GET_INFO_CONTROLLER setInfoData:INFO_GAMELANGUAGE_NAME data:resultArg[PARAM_INIT_GAMELANGUAGE]];
    }
    
    if(resultArg[KEY_VID] != nil && [[GET_INFO_CONTROLLER getInfoData:INFO_VID_NAME] isEqualToString:@""])
        [GET_INFO_CONTROLLER setInfoData:INFO_VID_NAME data:resultArg[KEY_VID]];
}

// 1.17.0
-(void)social_Info_PopupCB:(NSDictionary*)resultArg
{
    UIAlertController *alert = NULL;
    
    NSError * err;
    NSData * jsonData = [NSJSONSerialization  dataWithJSONObject:resultArg options:0 error:&err];
    NSString * myString = [[NSString alloc] initWithData:jsonData   encoding:NSUTF8StringEncoding];

    alert = [UIAlertController
             alertControllerWithTitle:@"Result - Permission"
             message:myString
             preferredStyle:UIAlertControllerStyleAlert];
    
    
    UIAlertAction *okAction = [UIAlertAction
                               actionWithTitle:@"OK"
                               style:UIAlertActionStyleDefault
                               handler:nil];
    
    [alert addAction:okAction];
    dispatch_async(dispatch_get_main_queue(), ^{
        UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
        
        while(rootViewController.presentedViewController)
        {
            rootViewController = rootViewController.presentedViewController;
        }
        [rootViewController presentViewController:alert animated:YES completion:nil];
    });
}

@end

