//
//  UIViewController+GroupListView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "GroupListView.h"

@interface GroupListView ()
{
    NSMutableArray* groupList;
}
@end


@implementation GroupListView

-(void)viewDidLoad
{
    [super viewDidLoad];
    _logLabel.text = [GET_LOG_CONTROLLER getResultLog];

    
    groupList = [GET_ACTION_CONTROLLER getGroupList];
    
    //_viewTitle.title = group[KEY_NAME];
    
    _loginState.text = [GET_ACTION_CONTROLLER getLoginLabel];
    _serverState.text = [GET_ACTION_CONTROLLER getServerLabel];
    
    groupTableView.delegate = self;
    groupTableView.dataSource = self;
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated
{
    [groupTableView reloadData];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [groupList count];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}


//- (NSString*)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
//    return [mainMenu objectAtIndex:section];
//}


- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    GroupListViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"GroupCell"];
    
    NSMutableDictionary *dict = [groupList objectAtIndex:indexPath.row];
    
    [cell setName:dict];
    
    return cell;
}

- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSMutableDictionary *dict = [groupList objectAtIndex:indexPath.row];
    
    [GET_ACTION_CONTROLLER setCurrentGroup:dict];
    [GET_LOG_CONTROLLER clearLog:0];
    
    NSString* dictName = [[NSString alloc] initWithFormat:@"%@의 기능", dict[KEY_NAME]];
    [GET_LOG_CONTROLLER setResultLog:dictName];

    [self performSegueWithIdentifier:@"actionScene" sender:self];
}

- (IBAction)logMore:(id)sender {
    [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_GROUP];
    [self performSegueWithIdentifier:@"logView" sender:self];

}

@end




@implementation GroupListViewCell

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

-(void)setName:(NSMutableDictionary*)dic
{
    _groupName.text = dic[KEY_NAME];
}


@end
