//
//  UIViewController+InitializeView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "InitializeView.h"

@interface InitializeView ()

@end

@implementation InitializeView

- (void)viewDidLoad {
    [super viewDidLoad];
    [GET_ACTION_CONTROLLER setLoginLabel:@"미정"];
    [GET_ACTION_CONTROLLER setServerLabel:@"미정"];
    [GET_LOG_CONTROLLER initialize];
    _appVersion.text = [NSString stringWithFormat:@"AppVersion : %@", [[NSBundle mainBundle] objectForInfoDictionaryKey:@"CFBundleVersion"]];
	_externalLibraryVersion.text = [self getExternalLibraryVersions];
    
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// External Library Version Setting
- (NSString *)getExternalLibraryVersions {
	NSString *versionsStr = @"";
	{
		// Facebook
		NSString *version = @"";
		Class class = NSClassFromString(@"FBSDKSettings");
		SEL selector = NSSelectorFromString(@"sdkVersion");
		if (class != nil && [class respondsToSelector:(NSSelectorFromString(@"sdkVersion"))]) {
		  
			NSMethodSignature *methodSignature = [class methodSignatureForSelector:selector];
			if (methodSignature != nil) {
				NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
				[inv setSelector:selector];
				[inv setTarget:class];
				[inv invoke];
				[inv getReturnValue:&version];
			}
		}
		versionsStr = [NSString stringWithFormat:@"Facebook : %@", version];
	}
	{
		// Google
		NSString *version = @"";
		
		versionsStr = [NSString stringWithFormat:@"%@ | Google : %@", versionsStr, version];
	}
	{
		// QQ
		NSString *version = @"";
		Class class = NSClassFromString(@"TencentOAuth");
		SEL selector = NSSelectorFromString(@"sdkVersion");
		if (class != nil && [class respondsToSelector:(NSSelectorFromString(@"sdkVersion"))]) {
		  
			NSMethodSignature *methodSignature = [class methodSignatureForSelector:selector];
			if (methodSignature != nil) {
				NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
				[inv setSelector:selector];
				[inv setTarget:class];
				[inv invoke];
				[inv getReturnValue:&version];
			}
		}
		versionsStr = [NSString stringWithFormat:@"%@\nQQ : %@", versionsStr, version];
	}
	{
		// Singular
		NSString *version = @"";
		Class class = NSClassFromString(@"Singular");
		SEL selector = NSSelectorFromString(@"version");
		if (class != nil && [class respondsToSelector:(NSSelectorFromString(@"version"))]) {
		  
			NSMethodSignature *methodSignature = [class methodSignatureForSelector:selector];
			if (methodSignature != nil) {
				NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
				[inv setSelector:selector];
				[inv setTarget:class];
				[inv invoke];
				[inv getReturnValue:&version];
			}
		}
		versionsStr = [NSString stringWithFormat:@"%@ | Singular : %@", versionsStr, version];
	}
	{
		//adjust
		NSString *version = @"";
		Class class = NSClassFromString(@"Adjust");
		SEL selector = NSSelectorFromString(@"sdkVersion");
		if (class != nil && [class respondsToSelector:(NSSelectorFromString(@"sdkVersion"))]) {
		  
			NSMethodSignature *methodSignature = [class methodSignatureForSelector:selector];
			if (methodSignature != nil) {
				NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
				[inv setSelector:selector];
				[inv setTarget:class];
				[inv invoke];
				[inv getReturnValue:&version];
			}
		}
		versionsStr = [NSString stringWithFormat:@"%@\nAdjust : %@", versionsStr, version];
	}
    {
        //appsFlyer
        NSString *version = @"";
        Class class = NSClassFromString(@"AppsFlyerLib");
        SEL selector = NSSelectorFromString(@"getSDKVersion");
        if (class != nil && [class instancesRespondToSelector:(NSSelectorFromString(@"getSDKVersion"))]) {
            NSObject *appsInstance = [class new];
            void *temp = nil;

            NSMethodSignature *methodSignature = [appsInstance methodSignatureForSelector:selector];
            if (methodSignature != nil) {
                NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
                [inv setSelector:selector];
                [inv setTarget:appsInstance];
                [inv invoke];
                [inv getReturnValue:&temp];
                version = (__bridge NSString*)temp;
            }
        }
        versionsStr = [NSString stringWithFormat:@"%@ | AppsFlyer : %@", versionsStr, version];
    }
	
	return versionsStr;
}
- (IBAction)sandboxButton:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][0]];
    [GET_LOG_CONTROLLER setResultLog:@"SandBox Initialize"];
    for(Parameter* param in [GET_ACTION_CONTROLLER getCurrentAction].paramList){
        if([param.name isEqualToString:PARAM_INIT_USESANDBOX])
            param.value = @true;
        if([param.name isEqualToString:PARAM_INIT_USEDEVELOP])
            param.value = @false;
    }
    [GET_ACTION_CONTROLLER callModuleApi];
}

- (IBAction)liveButton:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][0]];
    [GET_LOG_CONTROLLER setResultLog:@"Live Initialize"];
    for(Parameter* param in [GET_ACTION_CONTROLLER getCurrentAction].paramList){
        if([param.name isEqualToString:PARAM_INIT_USESANDBOX])
            param.value = @false;
        if([param.name isEqualToString:PARAM_INIT_USEDEVELOP])
            param.value = @false;
    }
    [GET_ACTION_CONTROLLER callModuleApi];
}

- (IBAction)stagingButton:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][0]];
    [GET_LOG_CONTROLLER setResultLog:@"Staging Initialize"];
    for(Parameter* param in [GET_ACTION_CONTROLLER getCurrentAction].paramList){
        if([param.name isEqualToString:PARAM_INIT_USEDEVELOP])
            param.value = @true;
        if([param.name isEqualToString:PARAM_INIT_USESANDBOX])
            param.value = @false;
    }
    [GET_ACTION_CONTROLLER callModuleApi];
}

- (IBAction)delegateSwitch:(id)sender {
    
    [GET_ACTION_CONTROLLER setCurrentDelegate];

    if ([GET_ACTION_CONTROLLER getCurrentDelegate] == DELEGATE_HANDLER)
        [_delegateSwitch setTitle:@"Handler 이용" forState:UIControlStateNormal];
    else
        [_delegateSwitch setTitle:@"전역 Delegate 이용" forState:UIControlStateNormal];
}

- (IBAction)paramButton:(id)sender {
    [self performSegueWithIdentifier:@"parameterScene" sender:self];
}

//1.10.1
- (IBAction)SetGuestUserInfo:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][1]];
    [GET_ACTION_CONTROLLER callModuleApi];
}

// 1.17.0
- (IBAction)requestPermissionButton:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][2]];
    [GET_ACTION_CONTROLLER callModuleApi];
}


@end
