//
//  UIViewController+ParameterListView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "ParameterListView.h"

@interface ParameterListView ()
{
    NSMutableArray* paramList;
    NSMutableArray* paramCellList;
}
@end

@implementation ParameterListView

-(void)viewDidLoad
{
    [super viewDidLoad];
    _logLabel.text = [GET_LOG_CONTROLLER getResultLog];
    
    paramCellList = [[NSMutableArray alloc]init];
    
    APIAction* action= [GET_ACTION_CONTROLLER getCurrentAction];
    paramList = action.paramList;
    
    _viewTitle.title = action.name;
    
    _loginState.text = [GET_ACTION_CONTROLLER getLoginLabel];
    _serverState.text = [GET_ACTION_CONTROLLER getServerLabel];
    
    paramTableView.delegate = self;
    paramTableView.dataSource = self;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [paramList count];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}

- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    Parameter *dict = [paramList objectAtIndex:indexPath.row];
    
//    apiParamCell *cell;
    
    switch (dict.type) {
        case PARAM_TYPE_NONEDIT:{
            NonEditParam* cell = [tableView dequeueReusableCellWithIdentifier:@"NonEditCell"];
            [cell setParamCell:dict];
            [paramCellList addObject:cell];
        }break;
        case PARAM_TYPE_NUMBER:
        case PARAM_TYPE_TEXT:{
            TextParam* cell = [tableView dequeueReusableCellWithIdentifier:@"TextCell"];
            [cell setParamCell:dict];
            [paramCellList addObject:cell];
        }break;
        case PARAM_TYPE_NONEDIT_CHECKBOX:
        case PARAM_TYPE_CHECKBOX:{
            CheckBoxParam* cell = [tableView dequeueReusableCellWithIdentifier:@"CheckBoxCell"];
            [cell setParamCell:dict];
            [paramCellList addObject:cell];
        }break;
        case PARAM_TYPE_DROPDOWN:{
            DropdownParam* cell = [tableView dequeueReusableCellWithIdentifier:@"DropDownCell"];
            [cell setParamCell:dict];
            [paramCellList addObject:cell];
        }break;
        case PARAM_TYPE_INPUT:{
            InputParam* cell = [tableView dequeueReusableCellWithIdentifier:@"InputCell"];
            [cell setParamCell:dict];
            [paramCellList addObject:cell];
        }break;
        default:break;
    }

    return [paramCellList objectAtIndex:[paramCellList count]-1];
}
/*
// 칸을 선택했을 때
- (void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{

}
*/

- (IBAction)sendData:(id)sender {
    for(int i=0;i<[paramCellList count] ; i++)
        [paramCellList[i] setParamData];

}

- (IBAction)goBack:(id)sender {
    if([GET_ACTION_CONTROLLER getCurrentAction].num == ACTION_NUM_SOCIAL_INITIALIZE)
        [self performSegueWithIdentifier:@"initializeScene" sender:self];
    else
        [self performSegueWithIdentifier:@"actionScene" sender:self];    
}


- (IBAction)logMore:(id)sender {
    [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_PARAMETER];
    [self performSegueWithIdentifier:@"logView" sender:self];

}




@end
