//
//  UIViewController+InformationView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "InformationView.h"

@interface InformationView ()
{
    NSMutableArray* infoList;
}
@end

@implementation InformationView

-(void)viewDidLoad
{
    [super viewDidLoad];
    
    infoList = [GET_INFO_CONTROLLER getInfoList];
    NSString* vid;
    NSString* sessionToken;
    
    for(InformationData* data1 in infoList){
        if([data1.name isEqualToString:INFO_LOGIN_NAME]){
            _loginState.text = data1.data;
            if([_loginState.text isEqualToString:KEY_GUESTUSER])
                [_loginoutButton setTitle:@"Login" forState:UIControlStateNormal];
            else 
                [_loginoutButton setTitle:@"Logout" forState:UIControlStateNormal];
        }
        if([data1.name isEqualToString:INFO_SERVER_NAME])
            _serverState.text = data1.data;
        
        if([data1.name isEqualToString:INFO_VID_NAME])
            vid = data1.data;
        if([data1.name isEqualToString:INFO_SESSION_NAME])
            sessionToken = data1.data;
    }
    
    NSString* vidSessionTokenString = [NSString stringWithFormat:@"%@#%@", vid,sessionToken];
    
    if([_loginState.text isEqualToString:KEY_GUESTUSER])
        _vidSessionToken.text = vidSessionTokenString;
    
    infoTableView.delegate = self;
    infoTableView.dataSource = self;
    
    //Logout 때문에
    [GET_ACTION_CONTROLLER setCurrentGroup:[GET_ACTION_CONTROLLER getRealGroupList][1]];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated
{
    [infoTableView reloadData];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [infoList count];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}


//- (NSString*)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
//    return [mainMenu objectAtIndex:section];
//}


- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    InformationViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"InfoCell"];
    
    InformationData *data = [infoList objectAtIndex:indexPath.row];
    
    [cell setName:data];
    
    return cell;
}


- (IBAction)loginoutButton:(id)sender {
    //하이브 유저일 때
    if([_loginState.text isEqualToString:KEY_HIVEUSER]){
        [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][2]];
        [GET_LOG_CONTROLLER setResultLog:@"HIVE User Logout"];
        [GET_LOG_CONTROLLER clearLog:0];
        for(Parameter* param in [GET_ACTION_CONTROLLER getCurrentAction].paramList){
            if([param.name isEqualToString:PARAM_VALUE_TYPE])
                param.value = PARAM_VALUE_BLANK;
        }
    
        [GET_ACTION_CONTROLLER callModuleApi];
    }
    else{
        [GET_LOG_CONTROLLER setCurrentDepth:DEPTH_LOGIN];
        [self performSegueWithIdentifier:@"loginScene" sender:self];
    }
}

- (IBAction)logoutUserExitButton:(id)sender {
    [GET_ACTION_CONTROLLER setCurrentAction:[GET_ACTION_CONTROLLER getCurrentGroup][KEY_ACTIONLIST][2]];
    [GET_LOG_CONTROLLER setResultLog:@"HIVE User Logout UserExit"];

    [GET_LOG_CONTROLLER clearLog:0];
    for(Parameter* param in [GET_ACTION_CONTROLLER getCurrentAction].paramList){
        if([param.name isEqualToString:PARAM_VALUE_TYPE])
            param.value = PARAM_LOGIN_USEREXIT;
    }

    [GET_ACTION_CONTROLLER callModuleApi];
}

- (IBAction)goBack:(id)sender {
    [self performSegueWithIdentifier:@"groupScene" sender:self];
}



@end


@implementation InformationViewCell

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

-(void)setName:(InformationData*)data
{
    _infoName.text = data.name;
    _infoData.text = data.data;
}

@end

