//
//  LogController.h
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#ifndef LogController_h
#define LogController_h

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "Log.h"
#import "DealCallback.h"


#define GET_LOG_CONTROLLER [LogController shareInstance]


typedef NS_ENUM(NSInteger, programDepth)
{
    DEPTH_INITIALIZE,
    DEPTH_LOGIN,
    DEPTH_GROUP,
    DEPTH_ACTION,
    DEPTH_PARAMETER,
    DEPTH_HIVEIAP
};

@interface LogController : NSObject

+ (LogController*)shareInstance;

-(void)initialize;
-(NSMutableArray*)getAllLog;
-(NSMutableArray*)getLocalLog;


-(programDepth)getCurrentDepth;
-(void)setCurrentDepth:(programDepth)currentDepth;

-(NSString*)getResultLog;
-(void)setResultLog:(NSString*)result;

-(void)addAllLog:(Log*)Log;
-(void)addLocalLog:(Log*)Log;

-(void)addErrorLog:(NSError*)error;

-(void)clearLog:(int)type;


-(void)requestLogSend:(NSString*)name parameter:(NSDictionary *)parameter;
-(void)callbackLogSend:(NSString*)name parameter:(NSDictionary *)parameter result:(int)result;
-(void)errorLogSend:(NSError *)error name:(NSString*)name result:(int)result;

@end



#endif /* LogController_h */
