//
//  LogController.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//


#import "LogController.h"


@interface LogController()
{
    programDepth depth;
    NSString* resultLog;
    NSMutableArray* allLog;
    NSMutableArray* localLog;
}

@end

@implementation LogController

// 여러곳에서 동시에 호출을 대비
+ (LogController*)shareInstance
{
    static LogController* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
    });
    
    return instance;
}

-(void)initialize
{
    allLog = [[NSMutableArray alloc]init];
    localLog = [[NSMutableArray alloc]init];

}

-(NSMutableArray*)getAllLog
{
    return allLog;
}
-(NSMutableArray*)getLocalLog
{
    return localLog;
}


//뎁쓰
-(programDepth)getCurrentDepth
{
    return depth;
}

-(void)setCurrentDepth:(programDepth)currentDepth
{
    depth = currentDepth;
}

//resultLog 올림
-(NSString*)getResultLog
{
    return resultLog;
}
-(void)setResultLog:(NSString*)result
{
    resultLog = result;
}

-(void)addAllLog:(Log*)Log
{
    [allLog addObject:Log];
}
-(void)addLocalLog:(Log*)Log
{
    [localLog addObject:Log];
    [allLog addObject:Log];
}

/*
//test
-(void)addAllLog:(NSString*)Log
{
    [allLog addObject:Log];
}
-(void)addLocalLog:(NSString*)Log
{
    [localLog addObject:Log];
    [allLog addObject:Log];
}
 */

-(void)clearLog:(int)type
{
    if(type ==1)
        [allLog removeAllObjects];
    [localLog removeAllObjects];
}

-(void)addErrorLog:(NSError*)error
{

    
}

//0. Request Data
-(void)requestLogSend:(NSString*)name parameter:(NSDictionary *)parameter
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"[yyyy-MM-dd hh:mm:ss] "];
    NSString* date1 = [formatter stringFromDate:[NSDate date]];
    
    NSString* title;
    NSString* name2 = [name stringByAppendingString : @">\n"];
    
    title = [@"<Request API Data : " stringByAppendingString : name2];
    
    NSMutableString* text = [[NSMutableString alloc] init];
    
    for(NSString* key in parameter.allKeys)
    {
        NSString* Dic = [[NSString alloc] initWithFormat:@"[%@] : %@\n", key, [parameter objectForKey:key]];
        [text insertString:Dic atIndex:text.length];
    }
    [text insertString:@"\nRequest>>>>>>>>\n" atIndex:text.length];

    [self addLocalLog:[Log setLogData:date1 title:title text:text]];
}

//1. Callback Data
-(void)callbackLogSend:(NSString*)name parameter:(NSDictionary *)parameter result:(int)result
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"[yyyy-MM-dd hh:mm:ss] "];
    NSString* date1 = [formatter stringFromDate:[NSDate date]];
    
    NSString* title;
    NSString* name2 = [name stringByAppendingString : @">\n"];
    
    if(result ==0)
        title = [@"<Delegate : " stringByAppendingString : name2];
    else
        title = [@"<Handler : " stringByAppendingString : name2];
    
    NSMutableString* text = [[NSMutableString alloc] init];
    for(NSString* key in parameter.allKeys)
    {
        NSString* Dic = [[NSString alloc] initWithFormat:@"[%@] : %@\n", key, [parameter objectForKey:key]];
        [text insertString:Dic atIndex:text.length];
    }
    [text insertString:@"\n<<<<<<<<Callback\n" atIndex:text.length];
    
    [self addLocalLog:[Log setLogData:date1 title:title text:text]];
}

//2. Error Data
-(void)errorLogSend:(NSError *)error name:(NSString*)name result:(int)result
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"[yyyy-MM-dd hh:mm:ss] "];
    NSString* date1 = [formatter stringFromDate:[NSDate date]];
    
    NSString* title;
    NSString* name2 = [name stringByAppendingString : @">\n"];
    
    if(result ==0)
        title = [@"<Result Delegate : " stringByAppendingString : name2];
    else if(result ==1)
        title = [@"<Result Handler : " stringByAppendingString : name2];
    else
        title = [@"<Return Error : " stringByAppendingString : name2];
    
    NSString* text = [[NSString alloc] initWithFormat:@"Error : %@\n\n!!!!Error!!!!\n", [error localizedDescription]];
    
    [self addLocalLog:[Log setLogData:date1 title:title text:text]];

    
    NSString* resultLog2 = [[NSString alloc] initWithFormat:@"%@ 에러(error code %ld)", name, error.code];
    [self setResultLog:resultLog2];
    
    // 최상위 뷰 컨트롤러를 찾는다.
    //UIViewController* currentViewController = nil;
    if(![name isEqualToString:ACTION_ENAME_SOCIAL_INITIALIZE] && ![name isEqualToString:@"C2SModuleApi_SocialInitialize"]){
        dispatch_async(dispatch_get_main_queue(), ^{
            UIViewController* rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;

            while(rootViewController.presentedViewController)
            {
                rootViewController = rootViewController.presentedViewController;
            }
            [rootViewController viewDidLoad];
        });
    }
}



@end

