//
//  UIViewController+AllLogView.m
//  HiveSDKSampleXcode
//
//  Created by BK on 2016. 3. 21..
//  Copyright © 2016년 BK. All rights reserved.
//

#import "LogView.h"

@interface LogView ()
{
    int currentLog;
}
@end

@implementation LogView

- (void)viewDidLoad {
    [super viewDidLoad];
    _logLabel.text = [GET_LOG_CONTROLLER getResultLog];
    _logTextView.text=[self resultLogAppear:0];
    currentLog = 0;
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)goBack:(id)sender {
    NSString* scene;
    
    switch ([GET_LOG_CONTROLLER getCurrentDepth]) {
        case DEPTH_INITIALIZE:{
            scene = @"initScene";
        }break;
        case DEPTH_LOGIN:{
            scene = @"loginScene";
        }break;
        case DEPTH_GROUP:{
            scene = @"groupScene";
        }break;
        case DEPTH_ACTION:{
            scene = @"actionScene";
        }break;
        case DEPTH_PARAMETER:{
            scene = @"parameterScene";
        }break;
        case DEPTH_HIVEIAP: {
            scene = @"HiveIAPScene";
        }break;
    }
    
    [self performSegueWithIdentifier:scene sender:self];
}

- (IBAction)allLocalSwitch:(id)sender {
    switch ([sender selectedSegmentIndex]) {
        case 1:{
            currentLog = 1;
        }break;
        case 0:{
            currentLog = 0;
        }break;
    }
    
    _logTextView.text=[self resultLogAppear:currentLog];
}

- (IBAction)clearButton:(id)sender {
    [GET_LOG_CONTROLLER setResultLog : @"Clear"];
    _logLabel.text = [GET_LOG_CONTROLLER getResultLog];

    [GET_LOG_CONTROLLER clearLog:currentLog];
    _logTextView.text=[self resultLogAppear:currentLog];
}

- (IBAction)saveButton:(id)sender {
    
    MFMailComposeViewController *mailViewController = [[MFMailComposeViewController alloc] init];
    
    
    
    if([MFMailComposeViewController canSendMail])  //메일을 보낼 수 있는지를 체크
    {
        NSString *messageTitle = @"<<= iOS Sample Log =>>";
        
        //보내는 사람을 세팅 , 여려명 보낼경우 array에 담아 setToRecipients 로 세팅한다.
        [mailViewController setToRecipients:@[@"choibk@com2us.com"]];

        [mailViewController setSubject:messageTitle]; //메일 타이틀 세팅
        [mailViewController setMessageBody:[self resultLogAppear:1] isHTML:NO];  //메일 내용 세팅
        
        mailViewController.mailComposeDelegate = self; //델리게이트 설정
    
        [self presentModalViewController:mailViewController animated:YES];  //모달로 화면을 띄운다
    }
}

#pragma mark -
#pragma mark MFMailComposeViewControllerDelegate

- (void)mailComposeController:(MFMailComposeViewController *)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError *)error
{
    NSString* title;
    
    switch (result) {
        case MFMailComposeResultCancelled:  //취소
            title = @"Close - Mail";
            [GET_LOG_CONTROLLER setResultLog : @"Close - Mail"];
            break;
        case MFMailComposeResultSaved:  // 저장
            title = @"Save - Mail";
            [GET_LOG_CONTROLLER setResultLog : @"Save - Mail"];
            break;
        case MFMailComposeResultSent:  // 보냄
            title = @"Success - Mail send";
            [GET_LOG_CONTROLLER setResultLog : @"Success - Mail send"];
            break;
        case MFMailComposeResultFailed:  // 실패
            title = @"Success - Mail send";
            [GET_LOG_CONTROLLER setResultLog : @"Fail - Mail send"];
            break;
        default:
            break;
    }
    [self dismissModalViewControllerAnimated:YES];  // 취소 버튼 시 모달을 dismiss하기 위하여 사용
    
    UIAlertView *noClick = [[UIAlertView alloc] initWithTitle:title message:@"" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Close", nil];
    
    [noClick show];
}



//로그array를 string으로 변환해줌.
-(NSString*)resultLogAppear:(int)type
{
    NSString* LogStr = @"";
    /*test*/
    if(type ==1){
        for(Log* logStr in [GET_LOG_CONTROLLER getAllLog]){
            NSString* str = [[logStr.time stringByAppendingString:logStr.title] stringByAppendingString:logStr.text];
            LogStr = [[LogStr stringByAppendingString : @"\n-----------------------------\n"] stringByAppendingString:str];
        }
    }
    else{
        for(Log* logStr in [GET_LOG_CONTROLLER getLocalLog]){
            NSString* str = [[logStr.time stringByAppendingString:logStr.title] stringByAppendingString:logStr.text];
            LogStr = [[LogStr stringByAppendingString : @"\n-----------------------------\n"] stringByAppendingString:str];
        }
    }
    
    
    LogStr = [LogStr stringByAppendingString:@"\n\n"];
    
    return LogStr;
}


@end
