//
//  PostBox.m
//  C2SModuleDemo
//
//  Created by Kim Sang-U on 2015. 8. 5..
//  Copyright (c) 2015년 Kim Sang-U. All rights reserved.
//

#import "PostBoxActionController.h"
#import <HiveSDKPostBox/HiveSDKPostBox.h>

void finishHandler2(const char* pid)
{
    // 결과를 통지
    GET_POSTBOX_ACTIONCONTROLLER.finishHandler(pid?[NSString stringWithUTF8String:pid]:nil);
}

@implementation PostBoxActionController

// 여러곳에서 동시에 호출을 대비
+ (PostBoxActionController*)shareInstance
{
    static PostBoxActionController* instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
    });
    
    return instance;
}

- (void)callThePostBox:(bool)isShow;
{
    NSMutableArray *infoArray = [GET_INFO_CONTROLLER getInfoList];
    
    const char* did = nil;
    const char* uid = nil;
    const char* vid = nil;
    const char* appId = nil;
    const char* sessionToken = nil;
    PBServerState serverState = Server_LiveServer;
    
    for(InformationData* str in infoArray)
    {
        if(str.data != nil){
            if([str.name isEqualToString:INFO_DID_NAME])
                did = [str.data UTF8String];
            else if([str.name isEqualToString:INFO_UID_NAME])
                uid = [str.data UTF8String];
            else if([str.name isEqualToString:INFO_VID_NAME])
                vid = [str.data UTF8String];
            else if([str.name isEqualToString:INFO_APPID_NAME])
                appId = [str.data UTF8String];
            else if([str.name isEqualToString:INFO_SESSION_NAME])
                sessionToken = [str.data UTF8String];
            else if([str.name isEqualToString:INFO_SERVER_NAME]){
                if([str.data isEqualToString:KEY_LIVESERVER])
                    serverState = Server_LiveServer;
                else if([str.data isEqualToString:KEY_STAGINGSERVER])
                    serverState = Server_StagingServer;
                else if([str.data isEqualToString:KEY_SANDBOXSERVER])
                    serverState = Server_SandboxServer;
            }
        }
    }
    
    [GET_LOG_CONTROLLER requestLogSend:@"postBox Start" parameter: @{@"appID":appId?[NSString stringWithUTF8String:appId]:@"",
                                                                     @"AppVersion":@"1.0",
                                                                     @"Country":@"KR",
                                                                     @"Language":@"ko",
                                                                     @"DID":did?[NSString stringWithUTF8String:did]:@"",
                                                                     @"VID":vid?[NSString stringWithUTF8String:vid]:@"",
                                                                     @"UID":uid?[NSString stringWithUTF8String:uid]:@"",
                                                                     @"LoginCenterSessionKey":sessionToken?[NSString stringWithUTF8String:sessionToken]:@"",
                                                                     @"TestMode":[NSNumber numberWithInteger: serverState],
                                                                     @"World":@"kr"}];
    
    PB_StartPostBox(serverState, appId, did, uid, vid, sessionToken, isShow);
    
}

- (void)postBoxIapVerify:(NSString*)bypassInfo isSub:(bool)isSub completionHandler:(void(^)(NSString* pid))completionHandler
{
    self.finishHandler = completionHandler;
    
    const char* bypassInfoString = nil;
    if(bypassInfo)
        bypassInfoString = [bypassInfo UTF8String];
    
    PB_VerifyIap(bypassInfoString, isSub, finishHandler2);
}

@end
