//
//  C2SHub2Errors.h
//
//  Created by Archaeo Lucid on 2014. 12. 26..      // iOS
//  ...                                             // Android
//
//  Copyright (c) 2014년 com2us. All rights reserved.
//
//  Last Update : C2S.21.0.2

#ifndef Peppermint_C2SHub2Errors_h
#define Peppermint_C2SHub2Errors_h

typedef enum HiveSocialErrorCode {
    HiveSocialSuccess	= 0,

    HiveSocialErrorAlreadyInUse = -8,
    HiveSocialErrorInvalidParameter = -9,
    HiveSocialErrorNotSupportedService = -16,
    HiveSocialErrorNotEnoughMemory = -17,
    HiveSocialErrorNotExist = -28,
    HiveSocialErrorFacebookSessionNotOpened = -100,
    HiveSocialErrorNotSupportedSocialService = -101,

    HiveSocialErrorUnknown = 1100,
    HiveSocialErrorFailedToDatabaseConnection = 1101,

    HiveSocialErrorInvalidURL = 1200,
    HiveSocialErrorInvalidJSON = 1201,

    HiveSocialErrorFailedToAuthorize = 1300,

    HiveSocialErrorDeviceDenied = 1400,
    HiveSocialErrorUserDenied = 1401,
    HiveSocialErrorGuestAPIDenied = 1402,

    HiveSocialErrorGatewayTimeout = 1500,
    HiveSocialErrorGatewayBadResponse = 1501,

    HiveSocialErrorHiveUserExit = 1801,

    HiveSocialErrorSystemError = 2000,
    HiveSocialErrorDialogClose = 2001,
    HiveSocialErrorFailedToSocialAuthorize = 2002,
    HiveSocialErrorFailedToSocialRequest = 2003,
    HiveSocialErrorUserCancelledSocialRequest = 2004,       // deprecated (iOS only)

    HiveSocialErrorNetworkTimeout = 2100,
    HiveSocialErrorNetworkBadResponse = 2101,
    HiveSocialErrorSSLError = 2102,

    HiveSocialPgsSignInFail = 2400,
    HiveSocialPgsServiceNotAvailable = 2401,
    HiveSocialPgsAlreadyExistSession = 2402,
    HiveSocialPgsInvalidJson = 2403,
    HiveSocialPgsCannotFoundClientId = 2404,

    HiveSocialAuthCancel = 3000,
}HiveSocialErrorCode;

/**
 * ERROR CODE
 */

// Common Error Code
#define HUB_E_SUCCESS				 0		// 성공

#define HUB_E_INUSE					-8		// 현재 사용중이거나 이미 사용중
#define HUB_E_INVALID				-9		// 매개변수가 잘못되었음
#define HUB_E_NOTSUP				-16		// 해당 서비스를 지원하지 않음
#define HUB_E_NOMEMORY				-17		// 메모리 부족
#define HUB_E_NOTEXIST				-28		// 존재하지 않는 것
#define HUB_E_FBNOTOPEN				-100	// 페이스북 세션이 열려있지 않음
#define HUB_E_SOCIAL_NOTSUP			-101	// 앱에서 지원하지 않는 소셜 서비스임

// General error
#define HUB_E_UNKNOWN				1100	// 알수 없는, 또는 기타  에러 상황
#define HUB_E_NOT_CONNECT_DB		1101	// DB 접속 에러

// JSON Param validation
#define HUB_E_INVALID_URL			1200	// (Corresponds to HTTP 404 Error) - 없는 URL
#define HUB_E_INVALID_JSON			1201	// 잘못된 포맷의 요청을 보냈을 때 (JSON 파싱 실패 등)

// Authorizations
#define HUB_E_AUTH_FAIL				1300	// 쿠키 인증 등이 실패했을 때

// Service denial
#define HUB_E_DEVICE_DENIED			1400	// 디바이스가 차단되어서 서비스를 더 이상 제공할 수 없음
#define HUB_E_USER_DENIED			1401	// 유저가 차단되어서 서비스를 더 이상 제공할 수 없음
#define HUB_E_GUEST_API_DENIED		1402	// 정식 유저의 인증 쿠키가 존재하는 상태에서는 게스트 생성 또는 인증 API를 사용할 수 없음

// Related to gateway service
#define HUB_E_GATEWAY_TIMEOUT		1500	// 외부 시스템 연결시 타임아웃 발생
#define HUB_E_GATEWAY_BAD_RESPONSE	1501	// 외부 시스템에서 정상적이지 않은 응답을 보냈을 때

// Hive User Exit
#define HUB_E_HIVE_USER_EXIT        1801	// Hive 정식 유저 웹뷰에서 회원 탈퇴 시 에러 코드 (logout scheme으로 전달됨)

// etc..
#define HUB_E_SYSTEM_ERROR			2000	// 기타 시스템에서 전달되는 네트워크 에러
#define HUB_E_DIALOG_CLOSE			2001	// 사용자에 의해 다이얼로그 닫힘
#define HUB_E_SOCIAL_AUTH_FAIL		2002	// 외부 소셜 서비스 인증 에러
#define HUB_E_SOCIAL_REQUEST_FAIL	2003	// 외부 소셜 서비스 에러
#define HUB_E_SOCIAL_DIALOG_CLOSE   2004	// 외부 소셜 서비스 사용자 취소
//#define HUB_E_SOCIAL_USER_CANCELLED 2004    // deprecated, 사용자에 의한 외부 소셜 서비스 취소 (iOS Only)

#define HUB_E_NETWORK_TIMEOUT       2100	// 네트워크 요청 시 타임아웃 에러 (SocketTimeoutException, 2000에러의 세분화 코드)
#define HUB_E_NETWORK_BAD_RESPONSE  2101	// 정상적이지 않은 응답을 보냈을 때 (JSONException, 2000에러의 세분화 코드)
#define HUB_E_SSL_ERROR             2102	// 웹뷰 SSL Error가 발생했을 때 (onReceivedSslError 발생 시 에러 메세지를 반영, 2000에러의 세분화 코드)

#define HUB_E_PGS_SIGNIN_FAIL               2400			// PGS SignIn 실패 (Android Only)
#define HUB_E_PGS_SERVICE_NOT_AVAILABLE     2401		    // 구글 서비스 이용 불가 (Android Only)
#define HUB_E_PGS_ALREADY_EXIST_SESSION     2402			// 페퍼민트 세션이 이미 존재함 (Android Only)
#define HUB_E_PGS_INVALID_JSON              2403			// json 파싱 에러 (Android Only)
#define HUB_E_PGS_CANNOT_FOUND_CLIENT_ID    2404		    // google server client id 확인 불가 (Android Only)

#define HUB_E_NETWORK_TIMEOUT       2100	// 네트워크 요청 시 타임아웃 에러 (SocketTimeoutException, 2000에러의 세분화 코드)
#define HUB_E_NETWORK_BAD_RESPONSE  2101	// 정상적이지 않은 응답을 보냈을 때 (JSONException, 2000에러의 세분화 코드)
#define HUB_E_SSL_ERROR             2102	// 웹뷰 SSL Error가 발생했을 때 (onReceivedSslError 발생 시 에러 메세지를 반영, 2000에러의 세분화 코드)

#define HUB_E_PGS_SIGNIN_FAIL               2400			// PGS SignIn 실패
#define HUB_E_PGS_SERVICE_NOT_AVAILABLE     2401		    // 구글 서비스 이용 불가
#define HUB_E_PGS_ALREADY_EXIST_SESSION     2402			// 페퍼민트 세션이 이미 존재함
#define HUB_E_PGS_INVALID_JSON              2403			// json 파싱 에러
#define HUB_E_PGS_CANNOT_FOUND_CLIENT_ID    2404		    // google server client id 확인 불가

#define HUB_E_SOCIAL_AUTH_CANCEL	3000	// 외부 소셜 서비스 인증 취소 (에러 팝업이 뜨지 않고 로그인 화면으로 돌아가도록 하는 목적)

//for PGS Check
#define HUB_E_SOCIAL_PGS_TRUE 		1		//PGS 소셜 모듈 로그인 성공
#define HUB_E_SOCIAL_PGS_FALSE		0		//PGS 소셜 모듈 로그인 실패

#endif
